IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[adfBankAccountBrowse]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	BEGIN
		PRINT 'Dropping procedure adfBankAccountBrowse'
		DROP PROCEDURE [dbo].[adfBankAccountBrowse]
	END
GO

PRINT 'Creating procedure adfBankAccountBrowse'
GO

/******************************************************************************
**		File: adfBankAccountBrowse.sql
**		Name: adfBankAccountBrowse
**		Desc: this procedure automatically generated by Avicom.Adf.Generator
**
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**      ----------						-----------
**
**		Auth: Dmitry.Kolchev
**		Date: 10/04/2004 15:04:36
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		--------	--------		-------------------------------------------
**    
*******************************************************************************/
CREATE PROCEDURE [adfBankAccountBrowse]
	@CompanyID TIdentifier,
	@StateSelector INT
AS
	SET NOCOUNT ON
	SELECT
		[BankAccount].[ID],
		[BankAccount].[CompanyID],
		[BankAccount].[Class],
		[BankAccount].[State],
		[BankAccount].[Flag],
		[BankAccount].[FileAs],
		[BankAccount].[CurrencyCode],
		[BankAccount].[BankName],
		[BankAccount].[BankCode],
		[BankAccount].[City],
		[BankAccount].[Account],
		[BankAccount].[IntermediaryAccount],
		[BankAccount].[AdditionalAccounts],
		[BankAccount].[Created],
		[BankAccount].[CreatedBy],
		[BankAccount].[Modified],
		[BankAccount].[ModifiedBy],
		[BankAccount].[Timestamp]
	FROM
		[BankAccount]
	WHERE
		[BankAccount].[CompanyID] = @CompanyID
	AND
		((@StateSelector = 0) OR (@StateSelector != 0 AND [BankAccount].[State] = @StateSelector))
		
	RETURN 0
GO

GRANT EXECUTE ON [adfBankAccountBrowse] TO PUBLIC
GO
 