IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[adfCompanyDelete]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	BEGIN
		PRINT 'Dropping procedure adfCompanyDelete'
		DROP PROCEDURE [dbo].[adfCompanyDelete]
	END
GO

PRINT 'Creating procedure adfCompanyDelete'
GO

/******************************************************************************
**		File: adfCompanyDelete.sql
**		Name: adfCompanyDelete
**		Desc: this procedure automatically generated by Avicom.Adf.Generator
**
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**      ----------						-----------
**
**		Auth: Dmitry
**		Date: 10/03/2004 21:04:59
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		--------	--------		-------------------------------------------
**		28.06.10	KOV				    
*******************************************************************************/
CREATE PROCEDURE adfCompanyDelete
	@ID TIdentifier
AS
	SET NOCOUNT ON
	IF EXISTS(SELECT * FROM [SuperTimer] 
					WHERE [SuperTimer].[DocumentClass] = dbo.adfGetClassByName('Adf.Company') AND [SuperTimer].[DocumentID] = @ID AND 
					([SuperTimer].[State] in (1,2) OR ([SuperTimer].[State] = 3 AND [SuperTimer].[Persistent] = 1)))
	BEGIN
		RAISERROR('#CannotDeleteDocumentWithActiveTimer', 18, -1)
		RETURN 1
	END
	BEGIN TRANSACTION
	
	DELETE [DocumentContact] WHERE [BusinessCardClass] = dbo.adfGetClassByName('Adf.Company') AND [BusinessCardID] = @ID
	IF @@ERROR != 0
	BEGIN
		ROLLBACK TRANSACTION
		RETURN 1
	END
	
	DELETE FROM [CompanyCalendar] WHERE [CompanyID] = @ID
	IF @@ERROR != 0
	BEGIN
		ROLLBACK TRANSACTION
		RETURN 1
	END

	DELETE FROM [BusinessCard] WHERE [ID] = @ID AND [Class] = dbo.adfGetClassByName('Adf.Company')
	IF @@ERROR != 0
	BEGIN
		ROLLBACK TRANSACTION
		RETURN 1
	END
	
	DELETE [CompanyIndustryBranch] WHERE [CompanyID] = @ID
	IF @@ERROR != 0
	BEGIN
		ROLLBACK TRANSACTION
		RETURN 1
	END

	DELETE FROM [Company] WHERE [Company].[ID] = @ID
	IF @@ERROR != 0
	BEGIN
		ROLLBACK TRANSACTION
		RETURN 1
	END


	COMMIT TRANSACTION

	RETURN 0
GO

GRANT EXECUTE ON adfCompanyDelete TO PUBLIC
GO
 