﻿IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[adfEmployeeRegistrationDataAdd]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	BEGIN
		PRINT 'Dropping procedure adfEmployeeRegistrationDataAdd'
		DROP PROCEDURE [dbo].[adfEmployeeRegistrationDataAdd]
	END
GO

PRINT 'Creating procedure adfEmployeeRegistrationDataAdd'
GO

/******************************************************************************
**		File: adfEmployeeRegistrationDataAdd.sql
**		Name: adfEmployeeRegistrationDataAdd
**		Desc: Процедура добавляет учетные данные для сотрудника
**
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**      ----------						-----------
**
**		Auth: Anton.Paramonov
**		Date: 22.06.2012 12:22:00
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		--------	--------		-------------------------------------------
**    
*******************************************************************************/
CREATE PROCEDURE [adfEmployeeRegistrationDataAdd]
	@EmployeeID TIdentifier
AS
	DECLARE
		@UserID				TIdentifier,
		@EmployeeFileAs		TName,
		@rv					int

	SELECT @EmployeeFileAs = [FileAs] FROM [Employee] WHERE [ID] = @EmployeeID
	
	BEGIN TRANSACTION

	EXEC @rv = adfUserCreate @EmployeeFileAs, @EmployeeFileAs, NULL, NULL, @UserID OUTPUT
	IF @rv != 0
	BEGIN
		ROLLBACK TRANSACTION
		RETURN 1
	END

	UPDATE [Employee] SET [UserID] = @UserID  WHERE [ID] = @EmployeeID
	IF @@ERROR != 0
	BEGIN
		ROLLBACK TRANSACTION
		RETURN 1
	END

	COMMIT TRANSACTION

	RETURN 0
GO

GRANT EXECUTE ON [adfEmployeeRegistrationDataAdd] TO PUBLIC
GO
 