IF EXISTS (SELECT * FROM sysobjects WHERE type = 'P' AND name = 'adfPresenceBrowse')
	BEGIN
		PRINT 'Dropping Procedure adfPresenceBrowse'
		DROP  Procedure  adfPresenceBrowse
	END

GO

PRINT 'Creating Procedure adfPresenceBrowse'
GO
/******************************************************************************
**		File: 
**		Name: adfPresenceBrowse
**		Desc: 
**
**		This template can be customized:
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**      ----------						-----------
**
**		Auth: 
**		Date: 
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		--------	--------		-------------------------------------------
**    
*******************************************************************************/
CREATE Procedure adfPresenceBrowse
AS
	SET NOCOUNT ON

	SELECT 
		[Presence].[ID], 
		[Presence].[State], 
		[Presence].[ActivityTime], 
		[Presence].[UpdateTime],
		[Employee].[ID] as [EmployeeID],
		ISNULL([Employee].[FileAs], [Trustee].[DisplayName]) as [FileAs],
		(SELECT TOP 1 [Email] FROM [Email] WHERE [BusinessCardClass]=[Employee].[Class] AND [BusinessCardID] = [Employee].[ID] AND [EmailTypeID] IN (1, 2, 3) ORDER BY [EmailTypeID]) as [Email]
	FROM 
		[Presence] INNER JOIN [User]
			ON ([Presence].[ID] = [User].[ID] AND [User].[Locked] = 0)
		INNER JOIN [Trustee] 
			ON ([User].[ID] = [Trustee].[ID])
		LEFT OUTER JOIN [Employee]
			ON ([User].[ID] = [Employee].[UserID])
	WHERE
		[Employee].[ID] IS NOT NULL OR [User].[ID] = 1
	ORDER BY 
		ISNULL([Employee].[FileAs], [Trustee].[DisplayName])
		
	RETURN 0
GO

GRANT EXECUTE ON [adfPresenceBrowse] TO [public]
GO
