IF EXISTS (SELECT * FROM sysobjects WHERE type = 'P' AND name = 'adfPresenceUpdate')
	BEGIN
		PRINT 'Dropping Procedure adfPresenceUpdate'
		DROP  Procedure  adfPresenceUpdate
	END

GO

PRINT 'Creating Procedure adfPresenceUpdate'
GO
/******************************************************************************
**		File: 
**		Name: adfPresenceUpdate
**		Desc: 
**
**		This template can be customized:
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**      ----------						-----------
**
**		Auth: 
**		Date: 
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		--------	--------		-------------------------------------------
**    
*******************************************************************************/
CREATE Procedure adfPresenceUpdate
	@State TState,
	@ActivityTime TDateTime,
	@HasStickers TBool = NULL OUTPUT
AS
	DECLARE @UserID TIdentifier, @Now TDateTime
	
	SET NOCOUNT ON

	SET @UserID = dbo.adfGetCurrentUserID()
	SET @Now = GETUTCDATE()
	
	IF NOT EXISTS(SELECT * FROM [Presence] WHERE [ID] = @UserID)
	BEGIN
		INSERT INTO [Presence] ([ID], [State], [ActivityTime], [UpdateTime]) 
		VALUES(@UserID, 0, @Now, @Now)
	END
	
	UPDATE [Presence]
	SET
		[State] = CASE WHEN @State IS NULL THEN [State] ELSE @State END,
		[ActivityTime] = @ActivityTime,
		[UpdateTime] = @Now
	WHERE
		[ID] = @UserID
		
	IF EXISTS(SELECT * FROM [Sticker] LEFT OUTER JOIN [DocumentUserState] ON 
		([Sticker].[Class] = [DocumentUserState].[DocumentClass] 
			AND [Sticker].[ID] = [DocumentUserState].[DocumentID] 
			AND [DocumentUserState].[UserID] = @UserID)
			WHERE [Sticker].[RecipientUserID] = @UserID AND
				([DocumentUserState].[Read] IS NULL OR [DocumentUserState].[Read]=0))
	BEGIN
		SET @HasStickers = 1
	END
	ELSE
	BEGIN
		SET @HasStickers = 0
	END

	RETURN 0
GO

GRANT EXECUTE ON [adfPresenceUpdate] TO [public]
GO