﻿IF EXISTS (SELECT * FROM sysobjects WHERE type = 'P' AND name = 'adfSetEmployeeTimeZone')
	BEGIN
		PRINT 'Dropping Procedure adfSetEmployeeTimeZone'
		DROP  Procedure  adfSetEmployeeTimeZone
	END

GO

PRINT 'Creating Procedure adfSetEmployeeTimeZone'
GO
/******************************************************************************
**		File: 
**		Name: adfDocumentGet
**		Desc: Процедура записывает новую временую зону для сотрудника
**
**		This template can be customized:
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**      ----------						-----------
**
**		Auth: Anton.Paramonov
**		Date: 12.07.2012 12:05:00
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		--------	--------		-------------------------------------------
**    
*******************************************************************************/
CREATE Procedure adfSetEmployeeTimeZone
	@TimeZoneID TName = NULL,
	@TimeZoneOffset int = NULL,
	@EmployeeID TIdentifier = NULL
AS
	SET NOCOUNT ON
	
	IF @EmployeeID IS NULL
		SET @EmployeeID = dbo.adfGetCurrentEmployeeID()
	IF @EmployeeID IS NULL
		RETURN 0
	
	IF( EXISTS(SELECT *FROM [EmployeeTimeZone] WHERE [EmployeeID] = @EmployeeID))
	BEGIN
		UPDATE [EmployeeTimeZone]
		SET
			[EmployeeTimeZone].[TimeZone] = (CASE WHEN @TimeZoneID IS NOT NULL THEN @TimeZoneID ELSE [EmployeeTimeZone].[TimeZone] END),
			[EmployeeTimeZone].[TimeZoneOffset] = (CASE WHEN @TimeZoneOffset IS NOT NULL THEN  @TimeZoneOffset ELSE [EmployeeTimeZone].[TimeZoneOffset] END)
		WHERE 
			[EmployeeTimeZone].[EmployeeID] = @EmployeeID
	END
	ELSE
	BEGIN
		INSERT INTO [EmployeeTimeZone] ([EmployeeID], [TimeZone], [TimeZoneOffset])
		VALUES(@EmployeeID, @TimeZoneID, @TimeZoneOffset)
	END
	
	
	RETURN 0
GO

GRANT EXEC ON adfSetEmployeeTimeZone TO PUBLIC
GO
