﻿IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[fnpjm6GetSubprojectsForBrowse]') AND xtype IN (N'FN', N'IF', N'TF'))
	BEGIN
		PRINT 'Dropping function fnpjm6GetSubprojectsForBrowse'
		DROP FUNCTION [dbo].[fnpjm6GetSubprojectsForBrowse]
	END

GO

PRINT 'Creating function fnpjm6GetSubprojectsForBrowse'
GO
/******************************************************************************
**		File:	fnpjm6GetSubprojectsForBrowse.sql
**		Name: 	fnpjm6GetSubprojectsForBrowse
**		Desc:	Процедура возвращает список подпроектов (включена логика при
**				которой исключаются подпроекты, которые имеют 2 родителя
**
*******************************************************************************
**		Date:		Author:		Description:
**		28.06.11	PAM			Первая версия
**		13.07.11	SYV			Убрана проверка на UseSubProjects
*******************************************************************************/
CREATE FUNCTION fnpjm6GetSubprojectsForBrowse (
)

RETURNS @SubProjects TABLE (
		[ID] INT PRIMARY KEY,
		[ProjectID] INT NOT NULL,	
		[SubprojectID] INT NOT NULL,
		[FinanceManagerOfParentProject] INT,
		[ManagerAssistantOfParentProject] INT
)

AS 

BEGIN
	INSERT INTO @SubProjects (
		[ID],
		[ProjectID],
		[SubprojectID],
		[FinanceManagerOfParentProject],
		[ManagerAssistantOfParentProject]
	)
	SELECT
		[Task].[ID],
		[Task].[ProjectID],
		[Task].[SubprojectID],
		[Project].[FinanceManagerEmployeeID],
		[Project].[ManagerAssistantEmployeeID]
	FROM
		[Task]
		INNER JOIN [Project]
			ON [Project].[ID] = [ProjectID]
	WHERE
		[Task].[SubprojectID] IS NOT NULL
	
	DELETE FROM 
		@SubProjects
	WHERE
		[SubprojectID] IN (
		SELECT
			[SubprojectID]
		FROM @SubProjects
		GROUP BY [SubprojectID]
		HAVING count(*) > 1
		)
		
	RETURN

END	
GO