IF EXISTS (SELECT * FROM sysobjects WHERE type = 'P' AND name = 'adfActionBrowse')
	BEGIN
		PRINT 'Dropping Procedure adfActionBrowse'
		DROP  Procedure  adfActionBrowse
	END

GO

PRINT 'Creating Procedure adfActionBrowse'
GO
/******************************************************************************
**		File: 
**		Name: adfActionBrowse
**		Desc: 
**
**		This template can be customized:
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**      ----------						-----------
**
**		Auth: 
**		Date: 
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		--------	--------		-------------------------------------------
**    
*******************************************************************************/
CREATE Procedure adfActionBrowse
AS
	DECLARE @Class TClass
	SET NOCOUNT ON
	
	DECLARE @Lang TLanguage
	SET @Lang = dbo.adfGetLanguage()

	SET @Class = dbo.adfGetClassByName('Adf.Action')
	
	SELECT
		[Action].[ID],
		@Class as [Class],
		ISNULL([ActionGlobal].[Name], [Action].[Name]) as [Name],
		ISNULL([ActionGlobal].[Comments], [Action].[Comments]) as [Comments],
		1 as [State]
	FROM
		[Action] LEFT OUTER JOIN [ActionGlobal]
			ON ([Action].[ID] = [ActionGlobal].[ID] AND [ActionGlobal].[Language] = @Lang)
	
	RETURN 0
GO

GRANT EXEC ON adfActionBrowse TO PUBLIC
GO
