IF EXISTS (SELECT * FROM sysobjects WHERE type = 'P' AND name = 'adfActionUpdate')
	BEGIN
		PRINT 'Dropping Procedure adfActionUpdate'
		DROP  Procedure  adfActionUpdate
	END

GO

PRINT 'Creating Procedure adfActionUpdate'
GO
/******************************************************************************
**		File: 
**		Name: adfActionUpdate
**		Desc: 
**
**		This template can be customized:
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**      ----------						-----------
**
**		Auth: 
**		Date: 
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		--------	--------		-------------------------------------------
**    
*******************************************************************************/
CREATE Procedure adfActionUpdate
	@ID TIdentifier,
	@Name TName,
	@Comments TNotes
AS
	SET NOCOUNT ON
	
	DECLARE @Lang TLanguage
	SET @Lang = dbo.adfGetLanguage()
	
	BEGIN TRANSACTION
	
	IF @Lang = 'ru'
	BEGIN
		UPDATE [Action]
		SET
			[Action].[Name] = @Name,
			[Action].[Comments] = @Comments
		WHERE
			[Action].[ID] = @ID
		IF @@ERROR != 0
		BEGIN
			ROLLBACK TRANSACTION
			RETURN 1
		END
	END

	IF EXISTS(SELECT * FROM [ActionGlobal] WHERE [ID] = @ID AND [Language] = @Lang)
	BEGIN
		UPDATE [ActionGlobal]
		SET 
			[Name] = @Name, [Comments] = @Comments
		WHERE
			[ID] = @ID AND [Language] = @Lang
	END
	ELSE
	BEGIN
		INSERT [ActionGlobal] 
			([ID], [Language], [Name], [Comments])
		VALUES
			(@ID, @Lang, @Name, @Comments)
	END
	IF @@ERROR != 0
	BEGIN
		ROLLBACK TRANSACTION
		RETURN 1
	END
	
	COMMIT TRANSACTION
			
	EXEC adfActionGet @ID

	RETURN 0
GO

GRANT EXEC ON adfActionUpdate TO PUBLIC
GO
