IF EXISTS (SELECT * FROM sysobjects WHERE type = 'P' AND name = 'adfRoleDelete')
	BEGIN
		PRINT 'Dropping Procedure adfRoleDelete'
		DROP  Procedure  adfRoleDelete
	END

GO

PRINT 'Creating Procedure adfRoleDelete'
GO
/******************************************************************************
**		File: 
**		Name: adfRoleDelete
**		Desc: 
**
**		This template can be customized:
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**      ----------						-----------
**
**		Auth: 
**		Date: 
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		--------	--------		-------------------------------------------
**    
*******************************************************************************/
CREATE PROCEDURE adfRoleDelete
	@Name TSysname
AS
	DECLARE @result INT 
	
	SET NOCOUNT ON

	EXEC @result = adfAccessRightCheck 'ManageRights'
	IF @result != 0
		RETURN @result

	DELETE [Trustee] WHERE [Trustee].[ID] = dbo.adfGetRoleID(@Name)
	IF @@ERROR != 0 OR @@ROWCOUNT = 0
		RETURN 1
	RETURN 0
GO

GRANT EXEC ON adfRoleDelete TO PUBLIC
GO
