IF EXISTS (SELECT * FROM sysobjects WHERE type = 'TR' AND name = 'adftrTrusteeD')
	BEGIN
		PRINT 'Dropping Trigger adftrTrusteeD'
		DROP  Trigger adftrTrusteeD
	END
GO

/******************************************************************************
**		File: 
**		Name: adftrTrusteeD
**		Desc: 
**
**		This template can be customized:
**              
**
**		Auth: 
**		Date: 
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		--------	--------		-------------------------------------------
**      20040616	DYK
*******************************************************************************/

PRINT 'Creating Trigger adftrTrusteeD'
GO
CREATE TRIGGER adftrTrusteeD ON [dbo].[Trustee] FOR DELETE
AS
	IF EXISTS(SELECT * FROM deleted WHERE [BuiltIn] = 1)
	BEGIN
		RAISERROR('   .', 16, -1)
		ROLLBACK TRANSACTION
	END

GO

IF EXISTS (SELECT * FROM sysobjects WHERE type = 'TR' AND name = 'adftrTrusteeIU')
	BEGIN
		PRINT 'Dropping Trigger adftrTrusteeIU'
		DROP  Trigger adftrTrusteeIU
	END
GO

/******************************************************************************
**		File: 
**		Name: adftrTrusteeIU
**		Desc: 
**
**		This template can be customized:
**              
**
**		Auth: 
**		Date: 
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		--------	--------		-------------------------------------------
**      20040616	DYK
*******************************************************************************/

PRINT 'Creating Trigger adftrTrusteeIU'
GO
CREATE TRIGGER adftrTrusteeIU ON [dbo].[Trustee] FOR INSERT, UPDATE
AS
	IF EXISTS(SELECT * FROM deleted WHERE [BuiltIn] = 1)
	BEGIN
		RAISERROR('   .', 16, -1)
		ROLLBACK TRANSACTION
		RETURN
	END

	IF EXISTS(SELECT COUNT(*) FROM [Trustee] GROUP BY [Name] HAVING COUNT(*)>1)
	BEGIN
		RAISERROR('#UserNameMustBeUnique', 16, -1)
		ROLLBACK TRANSACTION
		RETURN
	END

	IF EXISTS(SELECT COUNT(*) FROM [Trustee] GROUP BY [DisplayName] HAVING COUNT(*)>1)
	BEGIN
		RAISERROR('#UserNameMustBeUnique', 16, -1)
		ROLLBACK TRANSACTION
		RETURN
	END
GO

