IF EXISTS (SELECT * FROM sysobjects WHERE type = 'P' AND name = 'adfuiUserCommandsGet')
	BEGIN
		PRINT 'Dropping Procedure adfuiUserCommandsGet'
		DROP  Procedure  adfuiUserCommandsGet
	END

GO

PRINT 'Creating Procedure adfuiUserCommandsGet'
GO
/******************************************************************************
**		File: 
**		Name: adfuiUserCommandsGet
**		Desc: 
**
**		This template can be customized:
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**      ----------						-----------
**
**		Auth: 
**		Date: 
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		--------	--------		-------------------------------------------
**    
*******************************************************************************/
CREATE Procedure adfuiUserCommandsGet
AS
	SET NOCOUNT ON

	DECLARE @Lang TLanguage
	SET @Lang = dbo.adfGetLanguage()

	SELECT 
		[Class].[Guid],
		[UICommand].[ID],
		[UICommand].[ActionID],
		[UICommand].[Name],
		[UICommand].[Text],
		[UICommand].[AlternateText],
		[Class].[SmallImage],
		[UICommand].[Picture],
		[UICommand].[Shortcut],
		[UICommand].[Comments],
		[UICommand].[Position],
		[UICommand].[BeginGroup]
	FROM 
		[adfvwUICommand] as [UICommand] INNER JOIN [Class]
			ON ([UICommand].[Class] = [Class].[Class])
	WHERE 
		[UICommand].[ID] IN (
			SELECT DISTINCT
				[TransitionTemplate].[UICommandID]
			FROM 
				[TransitionTemplate] INNER JOIN dbo.adfGetCurrentUserRights() as [Right]
					ON ([TransitionTemplate].[RightID] = [Right].[ID])
			WHERE
				[TransitionTemplate].[UICommandID] IS NOT NULL) 
	ORDER BY
		ISNULL([UICommand].[Position], 1000000000)
	RETURN 0
GO

GRANT EXEC ON adfuiUserCommandsGet TO PUBLIC
GO
