IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[adfwfGetInitialState]') AND xtype IN (N'FN', N'IF', N'TF'))
	BEGIN
		PRINT 'Dropping function adfwfGetInitialState'
		DROP FUNCTION [dbo].[adfwfGetInitialState]
	END

GO

PRINT 'Creating function adfwfGetInitialState'
GO
/******************************************************************************
**		File: 
**		Name: adfwfGetInitialState
**		Desc: 
**
**		This template can be customized:
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**      ----------						-----------
**
**		Auth: 
**		Date: 
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		--------	--------		-------------------------------------------
**    
*******************************************************************************/
CREATE FUNCTION adfwfGetInitialState
	(@Guid TGuid)
RETURNS INT
AS
BEGIN
	DECLARE @State INT

	SELECT 
		@State = MIN([TransitionTemplate].[ToState])
	FROM 
		[TransitionTemplate]
	WHERE 
		[TransitionTemplate].[FromState] IS NULL 
	AND 
		[TransitionTemplate].[Class] = (SELECT [Class].[Class] FROM [Class] WHERE [Class].[Guid] = @Guid)
	AND	
		dbo.adfHasAccessRight([TransitionTemplate].[RightID]) = 1
		
	RETURN @State
END
GO
