IF NOT EXISTS (SELECT * FROM syscolumns WHERE [name] = 'ProductKey' AND OBJECTPROPERTY(id, N'IsUserTable') = 1 AND OBJECT_NAME(id)='User')
BEGIN
	ALTER TABLE [User] ADD [ProductKey] TName NULL
	ALTER TABLE [User] ADD [SerialNumber] TName NULL
	ALTER TABLE [User] ADD [IsPermanent] TBool not null default 0
	ALTER TABLE [User] ADD [InitialDate] TDate NULL
	ALTER TABLE [User] ADD [ValidationData] TVariant NULL
END
GO
IF NOT EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'UserNTLoginMapping') AND OBJECTPROPERTY(id, N'IsUserTable') = 1)
	/*==============================================================*/
	/* Table: UserNTLoginMapping                                    */
	/*==============================================================*/
	create table UserNTLoginMapping (
	   ID                   TIdentifier          identity,
	   UserID               TIdentifier          not null,
	   NTLogin              TSysname             not null,
	   constraint UserNTLoginMappingPK primary key  (ID)
	)
go

IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'FolderNotificationSettings') AND OBJECTPROPERTY(id, N'IsUserTable') = 1)
BEGIN
	DELETE FROM [FolderNotificationSettings] 
		WHERE [TrusteeID] IN (SELECT [ID] FROM [User] WHERE [Locked] = 1)
END
GO