IF NOT EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'CompanyRelationshipView') AND OBJECTPROPERTY(id, N'IsUserTable') = 1)
/*==============================================================*/
/* Table: CompanyRelationshipView                                 */
/*==============================================================*/
create table CompanyRelationshipView (
	   ID                   TIdentifier          identity,
	   Class                TClass               not null,
	   State                TState               not null,
	   Flag                 TFlag                not null,
	   Code                 TCode                not null,
	   FileAs               TName                not null,
	   RelationshipViewID	TIdentifier			 not null,
	   ParentText			TName				 null,
	   ChildText			TName				 null,
	   Created              TSysDateTime         not null default GETDATE(),
	   CreatedBy            TUserID              not null,
	   Modified             TSysDateTime         not null default GETDATE(),
	   ModifiedBy           TUserID              not null,
	   Comments             TNotes               null,
	   Timestamp            timestamp            not null,
	   constraint CompanyRelationshipViewPK primary key  (ID)
	)
go

IF NOT EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'RelationshipView') AND OBJECTPROPERTY(id, N'IsUserTable') = 1)
/*==============================================================*/
/* Table: RelationshipView                                     */
/*==============================================================*/
create table RelationshipView (
	ID					TIdentifier          identity,
	Text				TName                not null,
	constraint RelationshipViewPK primary key  (ID)
)
go

IF NOT EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'CompanyRelationshipEntry') AND OBJECTPROPERTY(id, N'IsUserTable') = 1)
/*==============================================================*/
/* Table: CompanyRelationshipEntry			                                    */
/*==============================================================*/
create table CompanyRelationshipEntry (
	Class						TClass               not null,
	ID							TIdentifier          identity,
	State						TState               not null,
	Flag						TFlag                not null,
	FileAs						TName                not null,
	FirstCompanyID				TIdentifier          not null,
	SecondCompanyID				TIdentifier			 not null,
	CompanyRelationshipViewID	TIdentifier	         not null,
	Created						TSysDateTime         not null default GETDATE(),
	CreatedBy					TUserID              not null,
	Modified					TSysDateTime         not null default GETDATE(),
	ModifiedBy					TUserID              not null,
	Timestamp					timestamp            not null,
	Comments					TNotes				 null,
	constraint CompanyRelationshipEntryPK primary key  (ID)
	)
go