IF EXISTS(select * from systypes where name='tnotes' and prec=2048)
BEGIN
	DECLARE @proc sysname, @type sysname, @sql nvarchar(2048)
	DECLARE procs CURSOR FAST_FORWARD FOR
		select distinct specific_name, sysobjects.xtype 
		from 
			INFORMATION_SCHEMA.PARAMETERS 
			INNER JOIN sysobjects
				ON sysobjects.name = specific_name
		WHERE USER_DEFINED_TYPE_NAME = 'TNotes'
	OPEN procs
	FETCH NEXT FROM procs INTO @proc, @type
	WHILE @@FETCH_STATUS = 0 
	BEGIN
		IF @type = 'P'
			SET @sql = N'DROP PROCEDURE ' + @proc
		ELSE IF @type = 'FN'
			SET @sql = N'DROP FUNCTION ' + @proc
		EXEC sp_executesql @sql
		FETCH NEXT FROM procs INTO @proc, @type
	END
	CLOSE procs
	DEALLOCATE procs
	
	EXEC sp_rename 'TNotes', 'TNotesOld', 'USERDATATYPE'
	CREATE TYPE TNotes FROM nvarchar(max) null
	GRANT REFERENCES ON TYPE ::dbo.TNotes TO PUBLIC
	
	declare tables cursor for
		select OBJECT_NAME(syscolumns.id), dbo.syscolumns.name
		from dbo.syscolumns
			inner join dbo.systypes 
				on dbo.systypes.xusertype = dbo.syscolumns.xusertype
			inner join sysobjects
				on sysobjects.id = syscolumns.id
		where dbo.systypes.name = 'tnotesold' and sysobjects.xtype = 'U'

	declare @table sysname, @column sysname
	open tables
	fetch next from tables into @table, @column
	while @@fetch_status = 0
	begin
		SET @sql = 'ALTER TABLE [' + @table + '] ALTER COLUMN [' + @column + '] TNotes'
		EXEC (@sql)
		fetch next from tables into @table, @column
	end
	close tables
	deallocate tables
END 
GO