IF NOT EXISTS(SELECT * FROM [CustomScriptExecution] WHERE [ParameterName] = 'Update_PJMAM_DataModel')
BEGIN
	SET ANSI_NULLS, ANSI_PADDING, ANSI_WARNINGS, ARITHABORT, CONCAT_NULL_YIELDS_NULL, QUOTED_IDENTIFIER ON;

	SET NUMERIC_ROUNDABORT OFF;	 
END
GO

IF NOT EXISTS(SELECT * FROM [CustomScriptExecution] WHERE [ParameterName] = 'Update_PJMAM_DataModel')
BEGIN
	IF NOT EXISTS (SELECT * FROM sys.schemas WHERE name = N'pjmams')
	begin
		PRINT N'Creating schema [pjmams]';
		EXEC sys.sp_executesql N'create schema [pjmams] AUTHORIZATION [dbo]';
	end
	ELSE
	BEGIN
		PRINT N'Changing owner of schema [pjmams] to [dbo]';
		EXEC sys.sp_executesql N'ALTER AUTHORIZATION ON SCHEMA::pjmams TO [dbo]';
	END
END
GO

IF NOT EXISTS(SELECT * FROM [CustomScriptExecution] WHERE [ParameterName] = 'Update_PJMAM_DataModel')
BEGIN
	if not exists (select * from sys.database_principals where name = N'activitymonitorservice' and type = 'R')
	begin
		PRINT N'Creating role [activitymonitorservice]';
		CREATE ROLE [activitymonitorservice] AUTHORIZATION [dbo];
	end
END
GO
	 





IF NOT EXISTS(SELECT * FROM [CustomScriptExecution] WHERE [ParameterName] = 'Update_PJMAM_DataModel')
BEGIN
	IF EXISTS (SELECT * FROM INFORMATION_SCHEMA.TABLES WHERE TABLE_SCHEMA = 'pjmams' AND  TABLE_NAME = 'Session')
	BEGIN
		PRINT N'Dropping DF_Session_SessionStart...';
		ALTER TABLE [pjmams].[Session] DROP CONSTRAINT [DF_Session_SessionStart];
	END
END
GO

IF NOT EXISTS(SELECT * FROM [CustomScriptExecution] WHERE [ParameterName] = 'Update_PJMAM_DataModel')
BEGIN
	IF EXISTS (SELECT * FROM INFORMATION_SCHEMA.TABLES WHERE TABLE_SCHEMA = 'pjmams' AND  TABLE_NAME = 'Session')
	BEGIN
		PRINT N'Dropping DF_Session_SessionEnd...';
		ALTER TABLE [pjmams].[Session] DROP CONSTRAINT [DF_Session_SessionEnd];
	END
END
GO

IF NOT EXISTS(SELECT * FROM [CustomScriptExecution] WHERE [ParameterName] = 'Update_PJMAM_DataModel')
BEGIN
	IF EXISTS (SELECT * FROM INFORMATION_SCHEMA.TABLES WHERE TABLE_SCHEMA = 'pjmams' AND  TABLE_NAME = 'Module')
	BEGIN
		PRINT N'Dropping DF_Module_CategoryID...';
		ALTER TABLE [pjmams].[Module] DROP CONSTRAINT [DF_Module_CategoryID];
	END
END
GO

IF NOT EXISTS(SELECT * FROM [CustomScriptExecution] WHERE [ParameterName] = 'Update_PJMAM_DataModel')
BEGIN
	IF EXISTS (SELECT * FROM INFORMATION_SCHEMA.TABLES WHERE TABLE_SCHEMA = 'pjmams' AND  TABLE_NAME = 'Module')
	BEGIN
		PRINT N'Dropping DF_Module_Active...';
		ALTER TABLE [pjmams].[Module] DROP CONSTRAINT [DF_Module_Active];
	END
END
GO

IF NOT EXISTS(SELECT * FROM [CustomScriptExecution] WHERE [ParameterName] = 'Update_PJMAM_DataModel')
BEGIN
	IF EXISTS (SELECT * FROM INFORMATION_SCHEMA.TABLES WHERE TABLE_SCHEMA = 'pjmams' AND  TABLE_NAME = 'Process')
	BEGIN
		PRINT N'Dropping DF_Process_Created...';
		ALTER TABLE [pjmams].[Process] DROP CONSTRAINT [DF_Process_Created];
	END
END
GO

IF NOT EXISTS(SELECT * FROM [CustomScriptExecution] WHERE [ParameterName] = 'Update_PJMAM_DataModel')
BEGIN
	IF EXISTS (SELECT * FROM INFORMATION_SCHEMA.TABLES WHERE TABLE_SCHEMA = 'pjmams' AND  TABLE_NAME = 'Window')
	BEGIN
		PRINT N'Dropping DF_Window_Created...';
		ALTER TABLE [pjmams].[Window] DROP CONSTRAINT [DF_Window_Created];
	END
END
GO

IF NOT EXISTS(SELECT * FROM [CustomScriptExecution] WHERE [ParameterName] = 'Update_PJMAM_DataModel')
BEGIN
	IF EXISTS (SELECT * FROM INFORMATION_SCHEMA.TABLES WHERE TABLE_SCHEMA = 'pjmams' AND  TABLE_NAME = 'Process')
	BEGIN
		PRINT N'Dropping FK_Process_Session...';
		ALTER TABLE [pjmams].[Process] DROP CONSTRAINT [FK_Process_Session];
	END
END
GO

IF NOT EXISTS(SELECT * FROM [CustomScriptExecution] WHERE [ParameterName] = 'Update_PJMAM_DataModel')
BEGIN
	IF EXISTS (SELECT * FROM INFORMATION_SCHEMA.TABLES WHERE TABLE_SCHEMA = 'pjmams' AND  TABLE_NAME = 'Module')
	BEGIN
		PRINT N'Dropping FK_Module_Category...';
		ALTER TABLE [pjmams].[Module] DROP CONSTRAINT [FK_Module_Category];
	END
END
GO

IF NOT EXISTS(SELECT * FROM [CustomScriptExecution] WHERE [ParameterName] = 'Update_PJMAM_DataModel')
BEGIN
	IF EXISTS (SELECT * FROM INFORMATION_SCHEMA.TABLES WHERE TABLE_SCHEMA = 'pjmams' AND  TABLE_NAME = 'Process')
	BEGIN
		PRINT N'Dropping FK_Process_Module...';
		ALTER TABLE [pjmams].[Process] DROP CONSTRAINT [FK_Process_Module];
	END
END
GO

IF NOT EXISTS(SELECT * FROM [CustomScriptExecution] WHERE [ParameterName] = 'Update_PJMAM_DataModel')
BEGIN
	IF EXISTS (SELECT * FROM INFORMATION_SCHEMA.TABLES WHERE TABLE_SCHEMA = 'pjmams' AND  TABLE_NAME = 'Window')
	BEGIN
		PRINT N'Dropping FK_Window_Process...';
		ALTER TABLE [pjmams].[Window] DROP CONSTRAINT [FK_Window_Process];
	END
END



IF NOT EXISTS(SELECT * FROM [CustomScriptExecution] WHERE [ParameterName] = 'Update_PJMAM_DataModel')
BEGIN
	PRINT N'Starting rebuilding table [pjmams].[Process]...';
	BEGIN TRANSACTION;

	SET TRANSACTION ISOLATION LEVEL SERIALIZABLE;

	SET XACT_ABORT ON;

	CREATE TABLE [pjmams].[tmp_ms_xx_Process] (
		[ID]        INT            IDENTITY (1, 1) NOT NULL,
		[SessionID] INT            NULL,
		[ModuleID]  INT            NULL,
		[PID]       INT            NOT NULL,
		[UserName]  NVARCHAR (128) NOT NULL,
		[Created]   DATETIME       DEFAULT (getdate()) NOT NULL,
		[Closed]    DATETIME       NULL,
		[Idle]      INT            DEFAULT (0) NOT NULL,
		PRIMARY KEY CLUSTERED ([ID] ASC)
	);

	IF EXISTS (SELECT * FROM INFORMATION_SCHEMA.TABLES WHERE TABLE_SCHEMA = 'pjmams' AND  TABLE_NAME = 'Process')
	BEGIN
		IF EXISTS (SELECT TOP 1 1 
				   FROM   [pjmams].[Process])
			BEGIN
				SET IDENTITY_INSERT [pjmams].[tmp_ms_xx_Process] ON;
				INSERT INTO [pjmams].[tmp_ms_xx_Process] ([ID], [SessionID], [ModuleID], [PID], [UserName], [Created], [Closed])
				SELECT   [ID],
						 [SessionID],
						 [ModuleID],
						 [PID],
						 [UserName],
						 [Created],
						 [Closed]
				FROM     [pjmams].[Process]
				ORDER BY [ID] ASC;
				SET IDENTITY_INSERT [pjmams].[tmp_ms_xx_Process] OFF;
			END

		DROP TABLE [pjmams].[Process];
	END

	EXECUTE sp_rename N'[pjmams].[tmp_ms_xx_Process]', N'Process';

	COMMIT TRANSACTION;

	SET TRANSACTION ISOLATION LEVEL READ COMMITTED;
END
GO

IF NOT EXISTS(SELECT * FROM [CustomScriptExecution] WHERE [ParameterName] = 'Update_PJMAM_DataModel')
BEGIN
	PRINT N'Starting rebuilding table [pjmams].[Session]...';

	BEGIN TRANSACTION;

	SET TRANSACTION ISOLATION LEVEL SERIALIZABLE;

	SET XACT_ABORT ON;

	CREATE TABLE [pjmams].[tmp_ms_xx_Session] (
		[ID]              INT            IDENTITY (1, 1) NOT NULL,
		[MachineName]     NVARCHAR (128) NOT NULL,
		[SessionStart]    DATETIME       DEFAULT (getdate()) NOT NULL,
		[SessionEnd]      DATETIME       DEFAULT (getdate()) NOT NULL,
		[UserStatus]      INT            DEFAULT (0) NOT NULL,
		[RemoteSession]   TINYINT        DEFAULT (0) NOT NULL,
		[WinDir]          NVARCHAR (256) NULL,
		[ProgramFiles]    NVARCHAR (256) NULL,
		[ActiveProcessID] INT            NULL,
		[UserStatusTime]  DATETIME       DEFAULT (getdate()) NOT NULL, 
		[UserName]		  nvarchar(128)  null,
		[ActiveWindowID]  INT            NULL,
		PRIMARY KEY CLUSTERED ([ID] ASC)
	);

	IF EXISTS (SELECT * FROM INFORMATION_SCHEMA.TABLES WHERE TABLE_SCHEMA = 'pjmams' AND  TABLE_NAME = 'Session')
	BEGIN
		IF EXISTS (SELECT TOP 1 1 
				   FROM   [pjmams].[Session])
			BEGIN
				SET IDENTITY_INSERT [pjmams].[tmp_ms_xx_Session] ON;
				INSERT INTO [pjmams].[tmp_ms_xx_Session] ([ID], [MachineName], [SessionStart], [SessionEnd], [WinDir], [ProgramFiles])
				SELECT   [ID],
						 [MachineName],
						 [SessionStart],
						 [SessionEnd],
						 [WinDir],
						 [ProgramFiles]
				FROM     [pjmams].[Session]
				ORDER BY [ID] ASC;
				SET IDENTITY_INSERT [pjmams].[tmp_ms_xx_Session] OFF;
			END

		DROP TABLE [pjmams].[Session];
	END

	EXECUTE sp_rename N'[pjmams].[tmp_ms_xx_Session]', N'Session';

	COMMIT TRANSACTION;

	SET TRANSACTION ISOLATION LEVEL READ COMMITTED;
END
GO

IF NOT EXISTS(SELECT * FROM [CustomScriptExecution] WHERE [ParameterName] = 'Update_PJMAM_DataModel')
BEGIN
	PRINT N'Starting rebuilding table [pjmams].[Category]...';

	BEGIN TRANSACTION;

	SET TRANSACTION ISOLATION LEVEL SERIALIZABLE;

	SET XACT_ABORT ON;

	CREATE TABLE [pjmams].[tmp_ms_xx_Category] (
		[ID]   INT            IDENTITY (1, 1) NOT NULL,
		[Name] NVARCHAR (256) NOT NULL,
		PRIMARY KEY CLUSTERED ([ID] ASC)
	);

	IF EXISTS (SELECT * FROM INFORMATION_SCHEMA.TABLES WHERE TABLE_SCHEMA = 'pjmams' AND  TABLE_NAME = 'Category')
	BEGIN
		IF EXISTS (SELECT TOP 1 1 
				   FROM   [pjmams].[Category])
			BEGIN
				SET IDENTITY_INSERT [pjmams].[tmp_ms_xx_Category] ON;
				INSERT INTO [pjmams].[tmp_ms_xx_Category] ([ID], [Name])
				SELECT   [ID],
						 [Name]
				FROM     [pjmams].[Category]
				ORDER BY [ID] ASC;
				SET IDENTITY_INSERT [pjmams].[tmp_ms_xx_Category] OFF;
			END

		DROP TABLE [pjmams].[Category];
	END

	EXECUTE sp_rename N'[pjmams].[tmp_ms_xx_Category]', N'Category';

	COMMIT TRANSACTION;

	SET TRANSACTION ISOLATION LEVEL READ COMMITTED;
END
GO

IF NOT EXISTS(SELECT * FROM [CustomScriptExecution] WHERE [ParameterName] = 'Update_PJMAM_DataModel')
BEGIN
	PRINT N'Starting rebuilding table [pjmams].[Module]...';

	BEGIN TRANSACTION;

	SET TRANSACTION ISOLATION LEVEL SERIALIZABLE;

	SET XACT_ABORT ON;

	CREATE TABLE [pjmams].[tmp_ms_xx_Module] (
		[ID]          INT            IDENTITY (1, 1) NOT NULL,
		[CategoryID]  INT            DEFAULT (1) NOT NULL,
		[Name]        NVARCHAR (MAX) NOT NULL,
		[Description] NVARCHAR (MAX) NULL,
		[Version]     NVARCHAR (32)  NULL,
		[Lang]        NVARCHAR (32)  NULL,
		[Active]      BIT            DEFAULT (1) NOT NULL,
		PRIMARY KEY CLUSTERED ([ID] ASC)
	);

	IF EXISTS (SELECT * FROM INFORMATION_SCHEMA.TABLES WHERE TABLE_SCHEMA = 'pjmams' AND  TABLE_NAME = 'Module')
	BEGIN
		IF EXISTS (SELECT TOP 1 1 
				   FROM   [pjmams].[Module])
			BEGIN
				SET IDENTITY_INSERT [pjmams].[tmp_ms_xx_Module] ON;
				INSERT INTO [pjmams].[tmp_ms_xx_Module] ([ID], [CategoryID], [Name], [Description], [Version], [Lang], [Active])
				SELECT   [ID],
						 [CategoryID],
						 [Name],
						 [Description],
						 [Version],
						 [Lang],
						 [Active]
				FROM     [pjmams].[Module]
				ORDER BY [ID] ASC;
				SET IDENTITY_INSERT [pjmams].[tmp_ms_xx_Module] OFF;
			END

		DROP TABLE [pjmams].[Module];
	END

	EXECUTE sp_rename N'[pjmams].[tmp_ms_xx_Module]', N'Module';

	COMMIT TRANSACTION;

	SET TRANSACTION ISOLATION LEVEL READ COMMITTED;
END
GO

IF NOT EXISTS(SELECT * FROM [CustomScriptExecution] WHERE [ParameterName] = 'Update_PJMAM_DataModel')
BEGIN
	PRINT N'Starting rebuilding table [pjmams].[Window]...';

	BEGIN TRANSACTION;

	SET TRANSACTION ISOLATION LEVEL SERIALIZABLE;

	SET XACT_ABORT ON;

	CREATE TABLE [pjmams].[tmp_ms_xx_Window] (
		[ID]        INT            IDENTITY (1, 1) NOT NULL,
		[ProcessID] INT            NOT NULL,
		[HWND]      INT            NOT NULL,
		[Caption]   NVARCHAR (MAX) NOT NULL,
		[Created]   DATETIME       DEFAULT (getdate()) NOT NULL,
		PRIMARY KEY CLUSTERED ([ID] ASC)
	);

	IF EXISTS (SELECT * FROM INFORMATION_SCHEMA.TABLES WHERE TABLE_SCHEMA = 'pjmams' AND  TABLE_NAME = 'Window')
	BEGIN
		IF EXISTS (SELECT TOP 1 1 
				   FROM   [pjmams].[Window])
			BEGIN
				SET IDENTITY_INSERT [pjmams].[tmp_ms_xx_Window] ON;
				INSERT INTO [pjmams].[tmp_ms_xx_Window] ([ID], [ProcessID], [HWND], [Caption], [Created])
				SELECT   [ID],
						 [ProcessID],
						 [HWND],
						 [Caption],
						 [Created]
				FROM     [pjmams].[Window]
				ORDER BY [ID] ASC;
				SET IDENTITY_INSERT [pjmams].[tmp_ms_xx_Window] OFF;
			END

		DROP TABLE [pjmams].[Window];
	END

	EXECUTE sp_rename N'[pjmams].[tmp_ms_xx_Window]', N'Window';

	COMMIT TRANSACTION;

	SET TRANSACTION ISOLATION LEVEL READ COMMITTED;
END
GO

IF NOT EXISTS(SELECT * FROM [CustomScriptExecution] WHERE [ParameterName] = 'Update_PJMAM_DataModel')
BEGIN
	PRINT N'Creating FK_Process_Session...';
	ALTER TABLE [pjmams].[Process] WITH NOCHECK
		ADD CONSTRAINT [FK_Process_Session] FOREIGN KEY ([SessionID]) REFERENCES [pjmams].[Session] ([ID]);
END
GO

IF NOT EXISTS(SELECT * FROM [CustomScriptExecution] WHERE [ParameterName] = 'Update_PJMAM_DataModel')
BEGIN
	PRINT N'Creating FK_Module_Category...';
	ALTER TABLE [pjmams].[Module] WITH NOCHECK
		ADD CONSTRAINT [FK_Module_Category] FOREIGN KEY ([CategoryID]) REFERENCES [pjmams].[Category] ([ID]);
END
GO

IF NOT EXISTS(SELECT * FROM [CustomScriptExecution] WHERE [ParameterName] = 'Update_PJMAM_DataModel')
BEGIN
	PRINT N'Creating FK_Process_Module...';
	ALTER TABLE [pjmams].[Process] WITH NOCHECK
		ADD CONSTRAINT [FK_Process_Module] FOREIGN KEY ([ModuleID]) REFERENCES [pjmams].[Module] ([ID]);
END
GO

IF NOT EXISTS(SELECT * FROM [CustomScriptExecution] WHERE [ParameterName] = 'Update_PJMAM_DataModel')
BEGIN
	PRINT N'Creating FK_Window_Process...';
	ALTER TABLE [pjmams].[Window] WITH NOCHECK
		ADD CONSTRAINT [FK_Window_Process] FOREIGN KEY ([ProcessID]) REFERENCES [pjmams].[Process] ([ID]);
END
GO



IF NOT EXISTS(SELECT * FROM [CustomScriptExecution] WHERE [ParameterName] = 'Update_PJMAM_DataModel')
BEGIN
	-- Refactoring step to update target server with deployed transaction logs
	ALTER TABLE [pjmams].[Process] WITH CHECK CHECK CONSTRAINT [FK_Process_Session];

	ALTER TABLE [pjmams].[Module] WITH CHECK CHECK CONSTRAINT [FK_Module_Category];

	ALTER TABLE [pjmams].[Process] WITH CHECK CHECK CONSTRAINT [FK_Process_Module];

	ALTER TABLE [pjmams].[Window] WITH CHECK CHECK CONSTRAINT [FK_Window_Process];

	PRINT N'Update complete.';
END
GO

IF NOT EXISTS(SELECT * FROM [CustomScriptExecution] WHERE [ParameterName] = 'Update_PJMAM_DataModel')
BEGIN
	DECLARE @DBVersion TVariant
	EXEC adfParameterGet 'DatabaseVersion', 'VersionInfo', @Value = @DBVersion OUTPUT
	
	INSERT INTO [CustomScriptExecution] ([ParameterName], [FromDBVersion], [ScriptName])
		VALUES ('Update_PJMAM_DataModel', @DBVersion, 'dbModelUpdate.sql')
END




IF NOT EXISTS(SELECT * FROM [CustomScriptExecution] WHERE [ParameterName] = 'Update_PJMAM_DataModel_CreateRole_activitymonitorsite')
BEGIN
	if not exists (select * from sys.database_principals where name = N'activitymonitorsite' and type = 'R')
	begin
		PRINT N'Creating role [activitymonitorsite]';
		CREATE ROLE [activitymonitorsite] AUTHORIZATION [dbo];
	end
END
GO

IF NOT EXISTS(SELECT * FROM [CustomScriptExecution] WHERE [ParameterName] = 'Update_PJMAM_DataModel_CreateRole_activitymonitorsite')
BEGIN
	DECLARE @DBVersion TVariant
	EXEC adfParameterGet 'DatabaseVersion', 'VersionInfo', @Value = @DBVersion OUTPUT
	
	INSERT INTO [CustomScriptExecution] ([ParameterName], [FromDBVersion], [ScriptName])
		VALUES ('Update_PJMAM_DataModel_CreateRole_activitymonitorsite', @DBVersion, 'dbModelUpdate.sql')
END








IF NOT EXISTS(SELECT * FROM [CustomScriptExecution] WHERE [ParameterName] = 'Update_PJMAM_DataModel_AddDurationToWindow')
BEGIN
	IF NOT EXISTS (SELECT * FROM syscolumns WHERE [name] = 'Duration' AND OBJECTPROPERTY(id, N'IsUserTable') = 1 AND OBJECT_NAME(id)='Window')
		ALTER TABLE [pjmams].[Window] ADD [Duration] int not null default 0

	IF NOT EXISTS (SELECT * FROM syscolumns WHERE [name] = 'ActiveWindowID' AND OBJECTPROPERTY(id, N'IsUserTable') = 1 AND OBJECT_NAME(id)='Session')
		ALTER TABLE [pjmams].[Session] ADD [ActiveWindowID] int null
END
GO

IF NOT EXISTS(SELECT * FROM [CustomScriptExecution] WHERE [ParameterName] = 'Update_PJMAM_DataModel_AddDurationToWindow')
BEGIN
	DECLARE @DBVersion TVariant
	EXEC adfParameterGet 'DatabaseVersion', 'VersionInfo', @Value = @DBVersion OUTPUT
	
	INSERT INTO [CustomScriptExecution] ([ParameterName], [FromDBVersion], [ScriptName])
		VALUES ('Update_PJMAM_DataModel_AddDurationToWindow', @DBVersion, 'dbModelUpdate.sql')
END




IF NOT EXISTS(SELECT * FROM [CustomScriptExecution] WHERE [ParameterName] = 'Update_PJMAM_DataModel_Fix_Session_ActiveWindowID')
BEGIN
	IF EXISTS (SELECT * FROM syscolumns WHERE [name] = 'ActiveWindowID' AND [isnullable] = 0 AND OBJECTPROPERTY(id, N'IsUserTable') = 1 AND OBJECT_NAME(id)='Session')
		ALTER TABLE [pjmams].[Session] ALTER COLUMN [ActiveWindowID] int NULL
END
GO

IF NOT EXISTS(SELECT * FROM [CustomScriptExecution] WHERE [ParameterName] = 'Update_PJMAM_DataModel_Fix_Session_ActiveWindowID')
BEGIN
	DECLARE @DBVersion TVariant
	EXEC adfParameterGet 'DatabaseVersion', 'VersionInfo', @Value = @DBVersion OUTPUT
	
	INSERT INTO [CustomScriptExecution] ([ParameterName], [FromDBVersion], [ScriptName])
		VALUES ('Update_PJMAM_DataModel_Fix_Session_ActiveWindowID', @DBVersion, 'dbModelUpdate.sql')
END

