﻿if exists (select * from dbo.sysobjects where id = object_id(N'[exch].[UserBrowse]') and objectproperty(id, N'IsProcedure') = 1)
begin
	print 'Dropping procedure UserBrowse'
	drop procedure [exch].[UserBrowse]
end
go

print 'Creating procedure UserBrowse'
go

create procedure [exch].[UserBrowse]
with execute as 'pjmexchangesync'
as
begin
	set nocount on;
	
	with [Parameter] ([UserID], [CalendarSyncPeriod], [MeetingRequestSyncPeriod], [SyncReminders], [LoggingMode], [TimeEntriesSyncMode], [MeetingRequestSyncMode], [ContactSyncMode]) as
	(
	select
			[UserID],
			min(case when [Name] = 'SyncExchangeCalendarEntriesTimeLimit' then CAST([Value] as int) else null end)	as [CalendarSyncPeriod],
			min(case when [Name] = 'SyncExchangeCalendarEntriesTimeLimit' then CAST([Value] as int) else null end)  as [MeetingRequestSyncPeriod],
			min(case when [Name] = 'SyncExchangeNotifications' then CAST([Value] as int) else null end)				as [SyncReminders],
			min(case when [Name] = 'SyncExchangeLogging' then CAST([Value] as int) else null end)					as [LoggingMode],
			min(case when [Name] = 'SyncExchangeCalendar' then CAST([Value] as int) else null end)					as [TimeEntriesSyncMode],
			min(case when [Name] = 'SyncExchangeMeetings' then CAST([Value] as int) else null end)					as [MeetingRequestsSyncMode],
			min(case when [Name] = 'SyncExchangeContacts' then CAST([Value] as int) else null end)					as [ContactsSyncMode]
		from	
			[UserParameter]
		group by
			[UserID]
	),
	[FirstEmail] ([EmployeeID], [Email1], [Email2], [Email3]) as 
	(
		select
			[BusinessCardID],
			min(case when [EmailTypeID] = 1 then [Email] else null end),
			min(case when [EmailTypeID] = 2 then [Email] else null end),
			min(case when [EmailTypeID] = 3 then [Email] else null end)
		from	
			[Email] inner join [Employee]
				on ([Email].[BusinessCardID] = [Employee].[ID] and [Email].[BusinessCardClass] = [Employee].[Class])
		where
			[Employee].[State] = 1 and [Employee].[UserID] is not null and [EmailTypeID] <= 3
		group by
			[BusinessCardID]
	)
	select
		[User].[ID]																as [UserID],
		[Employee].[ID]															as [EmployeeID],
		[Employee].[FileAs]														as [FileAs],
		coalesce([Email1], [Email2], [Email3])									as [Email],
		[User].[NTLogin]														as [NTLogin],
		case [Parameter].[ContactSyncMode]
			when 1 then (case when dbo.adfHasAccessRightByNameForUser('ManageContacts',[User].[ID]) = 1 AND dbo.adfHasAccessRightByNameForUser('ManagePerson',[User].[ID]) = 1 then 3
							when (dbo.adfHasAccessRightByNameForUser('ManageContacts',[User].[ID]) = 0 OR dbo.adfHasAccessRightByNameForUser('ManagePerson',[User].[ID]) = 0) 
								AND dbo.adfHasAccessRightByNameForUser('ViewAllContacts',[User].[ID]) = 1 then 1 else 0 end)
			else 0
		end																		as [ContactsSyncMode],
		(case when [Parameter].[TimeEntriesSyncMode] = 1 then 3 else 0 end)		as [TimeEntriesSyncMode],
		(case when [Parameter].[MeetingRequestSyncMode] = 1 then 3 else 0 end)	as [MeetingRequestsSyncMode],
		isnull([Parameter].[CalendarSyncPeriod], 1)								as [CalendarSyncPeriod],
		isnull([Parameter].[MeetingRequestSyncPeriod], 1)						as [MeetingRequestSyncPeriod],
		isnull([Parameter].[SyncReminders], 0)									as [SyncReminders],
		isnull([Parameter].[LoggingMode], 0)									as [LoggingMode]
	from
		[Employee] inner join [User]
			ON ([User].[ID] = [Employee].[UserID])
		left outer join [Parameter]
			on ([User].[ID] = [Parameter].[UserID])
		left outer join [FirstEmail]
			on ([Employee].[ID] = [FirstEmail].[EmployeeID])
	where
		[Employee].[State] = 1 and [User].[Locked] = 0
	and
			(
			(case [Parameter].[ContactSyncMode]
				when 1 then (case when dbo.adfHasAccessRightByNameForUser('ManageContacts',[User].[ID]) = 1 AND dbo.adfHasAccessRightByNameForUser('ManagePerson',[User].[ID]) = 1 then 3
							when (dbo.adfHasAccessRightByNameForUser('ManageContacts',[User].[ID]) = 0 OR dbo.adfHasAccessRightByNameForUser('ManagePerson',[User].[ID]) = 0) 
								AND dbo.adfHasAccessRightByNameForUser('ViewAllContacts',[User].[ID]) = 1 then 1 else 0 end)
				else 0
			end) != 0
		or
			(case when [Parameter].[TimeEntriesSyncMode] = 1 then 3 else 0 end) != 0
		or
			(case when [Parameter].[MeetingRequestSyncMode] = 1 then 3 else 0 end) != 0
		)
		
	return 0;
end
go


grant execute on [exch].[UserBrowse] to [projectmateservice];
go
