IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[fnPjm6GetDefaultBankAccount]') AND xtype IN (N'FN', N'IF', N'TF'))
	BEGIN
		PRINT 'Dropping function fnPjm6GetDefaultBankAccount'
		DROP FUNCTION [dbo].[fnPjm6GetDefaultBankAccount]
	END
GO

PRINT 'Creating function fnPjm6GetDefaultBankAccount'
GO
/******************************************************************************
**		File: fnPjm6GetDefaultBankAccount
**		Name: fnPjm6GetDefaultBankAccount
**		Desc: 
**
**		This template can be customized:
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**      ----------						-----------
**
**		Auth: pavel.svintsov
**		Date: 30/03/10
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		--------	--------		-------------------------------------------
**		30/03/10	spv				first version
**    
*******************************************************************************/
CREATE FUNCTION fnPjm6GetDefaultBankAccount (@CompanyID TIdentifier)
RETURNS TIdentifier
AS
BEGIN
	
	DECLARE @BankAccountID TIdentifier
	
	SELECT
		@BankAccountID = [Company].[BankAccountID]
	FROM
		[Company]
	WHERE
		[Company].[ID] = @CompanyID
	
	RETURN @BankAccountID
END
GO

GRANT EXECUTE ON dbo.fnPjm6GetDefaultBankAccount TO PUBLIC
GO


  