﻿IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[fnpjm7CompanyFindAllChildren]') AND xtype IN (N'FN', N'IF', N'TF'))
	BEGIN
		PRINT 'Dropping function fnpjm7CompanyFindAllChildren'
		DROP FUNCTION [dbo].[fnpjm7CompanyFindAllChildren]
	END
GO

PRINT 'Creating function fnpjm7CompanyFindAllChildren'
GO

/******************************************************************************
**		File: fnpjm7CompanyFindAllChildren.sql
**		Name: fnpjm7CompanyFindAllChildren
**
**              
**		Return values:
**		Функция возвращает все дочерние компании для указанной головной компании
**
**		Called by:   
**              fnReportPaymentsEfficiencyByClientsGetTime
**				fnReportPaymentsEfficiencyByClientsGetMoney
**		Parameters:
**		Input							Output
**      ----------						-----------
**		
**		
**		Auth: Sergey Pelevin
**		Date: 18.12.14 
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:		Description:
**		--------	--------	-------------------------------------------
**		
*******************************************************************************/
CREATE FUNCTION dbo.fnpjm7CompanyFindAllChildren
(
	@ParentCompanyID int	
)
RETURNS @ChildCompanies TABLE
(	
	[ID] int
)
AS
BEGIN

	DECLARE
		@RelationType nvarchar(20) = 'Дочерняя компания',
		@TmpParentCompanyID int = @ParentCompanyID,
		@ChildCompanyID int

	WHILE 1 = 1
	BEGIN
	
		SELECT 
			@ChildCompanyID = [CRE].[SecondCompanyID]
		FROM 
			[CompanyRelationshipEntry] AS [CRE] 
		WHERE 
			[CRE].[FirstCompanyID] = @TmpParentCompanyID 
			AND
			[CRE].[FileAs] = @RelationType

		IF (@ChildCompanyID IS NULL)
		BEGIN			
			BREAK
		END
		ELSE
		BEGIN
			INSERT INTO @ChildCompanies ([ID])
			VALUES (@ChildCompanyID)
		END

		IF EXISTS (SELECT 1 FROM [CompanyRelationshipEntry] AS [CRE1] WHERE [CRE1].[FirstCompanyID] = @ChildCompanyID
			AND [CRE1].[SecondCompanyID] <> @TmpParentCompanyID)
		BEGIN		
			SET @TmpParentCompanyID = @ChildCompanyID
		END
		ELSE
		BEGIN					
			BREAK
		END
	END
	
	RETURN	
END

GO