IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[fnPjm5IsWorkingDayByMask]') AND xtype IN (N'FN', N'IF', N'TF'))
	BEGIN
		PRINT 'Dropping function fnPjm5IsWorkingDayByMask'
		DROP FUNCTION [dbo].[fnPjm5IsWorkingDayByMask]
	END

GO

PRINT 'Creating function fnPjm5IsWorkingDayByMask'
GO
/******************************************************************************
**		File: 
**		Name: fnPjm5IsWorkingDayByMask
**		Desc: 
**
**		This template can be customized:
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**      ----------						-----------
**
**		Auth: 
**		Date: 
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		--------	--------		-------------------------------------------
**		28.07.10	SYV				       @@DATEFIRST
*******************************************************************************/
CREATE FUNCTION fnPjm5IsWorkingDayByMask(@start datetime, @daymask int)
RETURNS bit
AS
BEGIN
	DECLARE @curdate datetime, @curday int, @curmonth int,
		@value TVariant, @weekday int, @res bit

	SET @curdate = CAST(CONVERT(varchar(8), @start, 112) AS DATETIME)
	SET @curday = DATEPART(day, @curdate)
	SET @curmonth = DATEPART(month, @curdate)
	SET @weekday = DATEPART(weekday, @curdate)

	IF @daymask IS NULL
	BEGIN
		SELECT @value = Value FROM [F41AB0F8-FDF0-4FAD-9B71-8F17B4A51B53] WHERE [Name]='WorkDaysOfWeek' AND [Group]='Pjm5'
		SET @daymask = CAST(@value as int)
	END

	DECLARE @mask int, @count int
	
	IF (@@DATEFIRST != 7)
	BEGIN
		SET @weekday = (@weekday + @@DATEFIRST) % 7
	END
	
	SELECT @mask = @daymask, @count = @weekday

	WHILE (@count > 1)
	BEGIN
		SET @mask = @mask/2
		SET @count = @count - 1
	END

	SET @res = @mask & 1

	IF EXISTS (
		SELECT *
		FROM [Calendar]
		WHERE
		(
			([NonWorkingTime] = 1 AND (@res = 1)) OR
			([NonWorkingTime] = 0 AND (@res = 0))
		) AND
		(
			(
				[Recurrent] = 0 AND
				(CAST(CONVERT(varchar(8), [Date], 112) AS DATETIME) = @curdate)
			) OR
			(
				[Recurrent] = 1 AND (DATEPART(day, [Calendar].[Date]) = @curday) AND
				(DATEPART(month, [Calendar].[Date]) = @curmonth)
			)
		)
	)
	BEGIN
		SET @res = @res ^ 1
	END

	RETURN @res
END
GO

GRANT EXEC ON fnPjm5IsWorkingDayByMask TO PUBLIC
GO
   