IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[fnPjm6GetAvailableProjectsForProjectMemberAndManager]') AND xtype IN (N'FN', N'IF', N'TF'))
	BEGIN
		PRINT 'Dropping function fnPjm6GetAvailableProjectsForProjectMemberAndManager'
		DROP FUNCTION [dbo].[fnPjm6GetAvailableProjectsForProjectMemberAndManager]
	END

GO

PRINT 'Creating function fnPjm6GetAvailableProjectsForProjectMemberAndManager'
GO
/******************************************************************************
**		File:	fnPjm6GetAvailableProjectsForProjectMemberAndManager.sql
**		Name: 	fnPjm6GetAvailableProjectsForProjectMemberAndManager
**		Desc:	      
**				   
*******************************************************************************
**		Date:		Author:		Description:
**		-----		-------		-------------
**    	16.06.10	PAM			 
*******************************************************************************/
CREATE FUNCTION fnPjm6GetAvailableProjectsForProjectMemberAndManager()

RETURNS @Projects TABLE ([ID] INT PRIMARY KEY)

AS 

BEGIN

	DECLARE 
		@CurrentEmployeeID	TIdentifier,
		@ManageProject		int

--   
	SELECT 
		@CurrentEmployeeID = dbo.adfGetCurrentEmployeeID(),
		@ManageProject = dbo.adfHasAccessRightByName('ManageProject')

--   ,    
--  !!! 
--    AssignmentEntry  ,   
	INSERT INTO @Projects ([ID])
	SELECT
		[Assignment].[ProjectID]
	FROM
        [Assignment]
	WHERE
		([Assignment].[State] = 1) 
		AND
        [Assignment].[ID] IN (
			SELECT [AssignmentEntry].[AssignmentID]
			FROM   [AssignmentEntry]
			WHERE  
				[AssignmentEntry].[EmployeeID] = @CurrentEmployeeID 
 		)

--  ,    ,       	
	IF @ManageProject = 1 
	BEGIN
		INSERT INTO @Projects ([ID])
		SELECT
			[Project].[ID]
		FROM
			[Project]
		WHERE
			(
				[Project].[ID] NOT IN (SELECT [ID] FROM @Projects)
			)	
				AND
			(
				[Project].[ProjectManagerEmployeeID] = @CurrentEmployeeID
			)
	END

	RETURN

END
	
GO