 IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[fnPjm5AllowCreateProjectEntry]') AND xtype IN (N'FN', N'IF', N'TF'))
	BEGIN
		PRINT 'Dropping function fnPjm5AllowCreateProjectEntry'
		DROP FUNCTION [dbo].[fnPjm5AllowCreateProjectEntry]
	END

GO

PRINT 'Creating function fnPjm5AllowCreateProjectEntry'
GO
/******************************************************************************
**		File: 
**		Name: fnPjm5AllowCreateProjectEntry
**		Desc: 
**
**		This template can be customized:
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**      ----------						-----------
**
**		Auth: 
**		Date: 
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		--------	--------		-------------------------------------------
**		01.04.13	SOV				. -     
*******************************************************************************/
CREATE FUNCTION fnPjm5AllowCreateProjectEntry(
	@ProjectID TIdentifier, 
	@EmployeeID TIdentifier
	)
RETURNS BIT
AS
BEGIN
	DECLARE @CurrentEmployeeID TIdentifier
	SET @CurrentEmployeeID = dbo.adfGetCurrentEmployeeID()
	
	IF @CurrentEmployeeID = @EmployeeID AND 
		@ProjectID is null 
		RETURN 1
	IF @CurrentEmployeeID = @EmployeeID AND 
		dbo.fnPjm5IsProjectMember(@ProjectID, @CurrentEmployeeID) = 1 
		RETURN 1
	IF dbo.fnPjm5IsProjectManager(@ProjectID, @CurrentEmployeeID) = 1 
		RETURN 1
	IF dbo.fnPjm5IsProjectAdministrator(@ProjectID, @CurrentEmployeeID) = 1
		RETURN 1
	IF dbo.fnPjm5IsProjectApprover(@ProjectID, @CurrentEmployeeID) = 1
		RETURN 1
	IF dbo.fnPjm7IsManagerAssistant(@ProjectID, @CurrentEmployeeID) = 1
		RETURN 1

	DECLARE
		@ViewAllProjects TBool,
		@Assistant TBool
	SET @ViewAllProjects = dbo.adfHasAccessRight(dbo.adfGetRightID('ViewAllProjects')) 
	SET @Assistant = dbo.adfHasAccessRight(dbo.adfGetRightID('Assistant'))
	IF @ViewAllProjects = 1 AND @Assistant = 1
		RETURN 1

	RETURN 0
END
GO

GRANT EXEC ON fnPjm5AllowCreateProjectEntry TO PUBLIC
GO
