﻿IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[fnPjm7CanModifyDocumentInClosedPeriod]') AND xtype IN (N'FN', N'IF', N'TF'))
	BEGIN
		PRINT 'Dropping function fnPjm7CanModifyDocumentInClosedPeriod'
		DROP FUNCTION [dbo].[fnPjm7CanModifyDocumentInClosedPeriod]
	END

GO

PRINT 'Creating function fnPjm7CanModifyDocumentInClosedPeriod'
GO
/******************************************************************************
**		File: fnPjm7CanModifyDocumentInClosedPeriod.sql
**		Name: fnPjm7CanModifyDocumentInClosedPeriod
**		Desc: Функция определяет, может ли работник создавать, удалять,
**			  редактировать и изменять состояние записей о времени
**			  в закрытом периоде
**			  
**
**		This template can be customized:
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**      ----------						-----------
**
**		Auth: DAL
**		Date: 04.03.15
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		--------	--------		-------------------------------------------
**    
*******************************************************************************/
CREATE FUNCTION [dbo].[fnPjm7CanModifyDocumentInClosedPeriod]
	(@ProjectID TIdentifier, @EmployeeID TIdentifier)
RETURNS BIT
AS
BEGIN
	DECLARE
		@false bit = 0,
		@true bit = 1

	DECLARE 
		@Result BIT,
		@CanCreate bit = @false
		

	IF @EmployeeID IS NULL
		SET @EmployeeID = dbo.adfGetCurrentEmployeeID()
	
	SET @Result = [dbo].[fnPjm5IsProjectManager](@ProjectID, NULL)
	IF @Result = @true
	BEGIN
		SET @CanCreate = @true
	END

	SET @Result = [dbo].[fnPjm7IsManagerAssistant](@ProjectID, NULL)
	IF @Result = @true
	BEGIN
		SET @CanCreate = @true
	END

	SET @Result = [dbo].[fnPjm5IsProjectApprover](@ProjectID, NULL)
	IF @Result = @true
	BEGIN
		SET @CanCreate = @true
	END

	SET @Result = [dbo].[fnPjm5IsAssistant]()
	IF @Result = @true
	BEGIN
		SET @CanCreate = @true
	END
	
	RETURN @CanCreate
END
GO

GRANT EXEC ON fnPjm7CanModifyDocumentInClosedPeriod TO PUBLIC
GO
