IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[fnPjm5GetAssignmentListByTaskRequest]') AND xtype IN (N'FN', N'IF', N'TF'))
	BEGIN
		PRINT 'Dropping function fnPjm5GetAssignmentListByTaskRequest'
		DROP FUNCTION [dbo].[fnPjm5GetAssignmentListByTaskRequest]
	END

GO

PRINT 'Creating function fnPjm5GetAssignmentListByTaskRequest'
GO
/******************************************************************************
**		File: 
**		Name: fnPjm5GetTaskListByAssignment
**		Desc: 
**
**		This template can be customized:
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**      ----------						-----------
**
**		Auth: 
**		Date: 
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		--------	--------		-------------------------------------------
**    
*******************************************************************************/
CREATE FUNCTION fnPjm5GetAssignmentListByTaskRequest(@TaskRequestID TIdentifier)
RETURNS nvarchar(4000)
AS
BEGIN
	DECLARE @AssignmentName	nvarchar(4000),
			@tmpName		TName
	
	DECLARE assignment CURSOR READ_ONLY FAST_FORWARD LOCAL FOR
		
		SELECT
			[Employee].[FileAs]
		FROM
			[Employee]
		INNER JOIN [TaskRequestAssignment]
			ON [Employee].[ID]=[TaskRequestAssignment].[EmployeeID]
		INNER JOIN [TaskRequest]
			ON [TaskRequestAssignment].[TaskRequestID]=[TaskRequest].[ID]
		WHERE
			[TaskRequest].[ID] = @TaskRequestID	
			
	
		OPEN assignment
		FETCH NEXT FROM assignment INTO @tmpName
		
		WHILE @@FETCH_STATUS = 0
		BEGIN
			--------------
			SELECT @AssignmentName = ISNULL(@AssignmentName + ', ', '') + @tmpName 
			--------------
			FETCH NEXT FROM assignment INTO @tmpName
		END
		CLOSE assignment
		DEALLOCATE assignment
	RETURN(@AssignmentName)
END
GO
GRANT EXEC ON fnPjm5GetAssignmentListByTaskRequest TO PUBLIC
GO
