IF  EXISTS (SELECT * FROM sys.objects WHERE object_id = OBJECT_ID(N'[dbo].[fnPjm5CategoriesConcat]') AND type in (N'FN', N'IF', N'TF', N'FS', N'FT'))
BEGIN
	PRINT 'Dropping function [dbo].[fnPjm5CategoriesConcat]'
	DROP FUNCTION [dbo].[fnPjm5CategoriesConcat]
END
GO

PRINT 'Creating function [dbo].[fnPjm5CategoriesConcat]'
GO

CREATE FUNCTION dbo.fnPjm5CategoriesConcat(@Class TClass, @ID TIdentifier)
RETURNS nvarchar(max)
AS
BEGIN
	DECLARE categories CURSOR FOR 
		SELECT [FileAs] FROM [Category] INNER JOIN [DocumentCategory]
			ON ([Category].[ID] = [DocumentCategory].[CategoryID])
		WHERE [DocumentCategory].[DocumentID]=@ID AND [DocumentCategory].[DocumentClass]=@Class
	OPEN categories

	DECLARE @list nvarchar(max), @category TName
	FETCH NEXT FROM categories INTO @category
	WHILE @@FETCH_STATUS = 0
	BEGIN
		IF @list IS NOT NULL
			SET @list = @list + ', ' + @category
		ELSE
			SET @list = @category
		
		FETCH NEXT FROM categories INTO @category
	END
	CLOSE categories
	DEALLOCATE categories
	RETURN @list
END
GO

GRANT EXECUTE ON [dbo].[fnPjm5CategoriesConcat] TO public
GO