IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[fnPjm5GetCategoryList]') AND xtype IN (N'FN', N'IF', N'TF'))
	BEGIN
		PRINT 'Dropping function fnPjm5GetCategoryList'
		DROP FUNCTION [dbo].[fnPjm5GetCategoryList]
	END

GO

PRINT 'Creating function fnPjm5GetCategoryList'
GO
/******************************************************************************
**		File: 
**		Name: fnPjm5GetTaskListByAssignment
**		Desc: 
**
**		This template can be customized:
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**      ----------						-----------
**
**		Auth: 
**		Date: 
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		--------	--------		-------------------------------------------
**    
*******************************************************************************/
CREATE FUNCTION fnPjm5GetCategoryList(@ID TIdentifier, @Class TClass)
RETURNS TName
AS
BEGIN
	
	DECLARE
		@Name		varchar(256),
		@Counter	int,
		@Categories	nvarchar(2048),
		@LastSymbol	char(8)		
			
	DECLARE my_cursor_categoies CURSOR READ_ONLY FAST_FORWARD LOCAL FOR
		SELECT
			[Category].[FileAs],
			COUNT(*)
		FROM 
			[DocumentCategory] 				
			INNER JOIN	[Category]
				ON [DocumentCategory].[CategoryID] = [Category].[ID]
		WHERE
			[DocumentCategory].[DocumentID] = @ID AND
			[DocumentCategory].[DocumentClass] = @Class
		GROUP BY
			[Category].[FileAs]	
			
	OPEN my_cursor_categoies
	FETCH NEXT FROM my_cursor_categoies INTO @Name, @Counter
	
	WHILE @@FETCH_STATUS = 0
	BEGIN
		IF @Counter > 0
		BEGIN
			IF @Categories IS NULL
				SET @Categories = @Name
			ELSE
				SET @Categories = @Categories + N'; ' + @Name
		END
		FETCH NEXT FROM my_cursor_categoies INTO @Name, @Counter
	END
	IF @Categories IS NOT NULL
	BEGIN
		SET @Categories = RTRIM(@Categories)
		SET @LastSymbol = RIGHT(@Categories,1)
			IF @LastSymbol != '.'
			BEGIN
				SET @Categories = @Categories + N'.'
			END
	END
	CLOSE my_cursor_categoies
	DEALLOCATE my_cursor_categoies		
	RETURN(@Categories)
END
GO

GRANT EXEC ON fnPjm5GetCategoryList TO PUBLIC
GO
