IF EXISTS (SELECT * FROM sysobjects WHERE type = 'P' AND name = 'BillingFilterPeriodGet')
	BEGIN
		PRINT 'Dropping Procedure BillingFilterPeriodGet'
		DROP  Procedure  BillingFilterPeriodGet
	END

GO

PRINT 'Creating Procedure BillingFilterPeriodGet'
GO
/******************************************************************************
**		File: 
**		Name: BillingFilterPeriodGet
**		Desc: 
**
**		This template can be customized:
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**     ----------							-----------
**
**		Auth: 
**		Date: 
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:				Description:
**		--------		--------				-------------------------------------------
**    
*******************************************************************************/
CREATE Procedure BillingFilterPeriodGet
	@DateSelector int,
	@PeriodStart TDate OUTPUT,
	@PeriodEnd TDate OUTPUT
AS
	DECLARE @Date TDate
	SET @Date = CAST(CONVERT(varchar(8), GETDATE(), 112) AS DATETIME)
	
	IF @DateSelector = 1 -- 3 month
		SELECT
			@PeriodStart = DATEADD(month, -2, DATEADD(day, 1 - DATEPART(day, @Date), @Date)),
			@PeriodEnd = DATEADD(day, -1, DATEADD(month, 3, @PeriodStart))
	IF @DateSelector = 2
		SELECT
			@PeriodStart = CAST(CONVERT(varchar(8), @PeriodStart, 112) AS datetime),
			@PeriodEnd = CAST(CONVERT(varchar(8), @PeriodEnd, 112) AS datetime)
	RETURN 0



GO

