﻿IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[pjm6BudgetLineWorkCreateUnplanned]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	BEGIN
		PRINT 'Dropping procedure pjm6BudgetLineWorkCreateUnplanned'
		DROP PROCEDURE [dbo].[pjm6BudgetLineWorkCreateUnplanned]
	END
GO

PRINT 'Creating procedure pjm6BudgetLineWorkCreateUnplanned'
GO

/******************************************************************************
**		File: BudgetLineWorkCreateUnplanned.sql
**		Name: pjm6BudgetLineWorkCreateUnplanned
**		Desc: this procedure automatically generated by Avicom.Adf.Generator
**
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**      ----------						-----------
**
**		Auth: Anton.Paramonov
**		Date: 27/01/2011 09:53:00
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		--------	--------		-------------------------------------------
**
*******************************************************************************/
CREATE PROCEDURE pjm6BudgetLineWorkCreateUnplanned
	@BudgetID								TIdentifier,
	@BudgetLineGroupID						TIdentifier,
	@BudgetPlanningRateForWork				TBool,
	@DocumentClass							TClass,
	@DocumentID								TIdentifier,
	@EmployeeID								TIdentifier,
	@ActivityTypeID							TIdentifier,
	@QualificationID						Tidentifier,
	@ActualManHour							TAmount,
	@TotalPCActualManHour					TMoney,
	@TotalWithVATPCActualManHour			TMoney,
	@Rate									TMoney,
	@BudgetPlanningEmployeeForWork			TBool,
	@BudgetPlanningActivityForWork			TBool,
	@BudgetPlanningQualificationForWork		TBool,
	@BudgetWorkLineID						TIdentifier OUTPUT
AS
	DECLARE
		@State				TState,
		@FileAs				TName,
		@UnplannedWorkCount	TCount

	IF @BudgetLineGroupID IS NULL
		SET @BudgetLineGroupID = (SELECT [ID] FROM [BudgetLineGroup] WHERE [BudgetLineGroup].[BudgetID] = @BudgetID AND 
			[BudgetLineGroup].[State] = 2 AND [BudgetLineGroup].[GroupTypeID] = 1)
	
	SET @UnplannedWorkCount = (SELECT COUNT(*) + 1 FROM [BudgetLineWork] WHERE [BudgetLineWork].[BudgetID] = @BudgetID AND [BudgetLineWork].[State] = 2)

	SET @State = 2 
	SET @FileAs = 'Внеплановая работа №' + CAST(@UnplannedWorkCount as nvarchar(256))
	IF @BudgetPlanningRateForWork = 0
		SET @Rate = 0
	IF @BudgetPlanningEmployeeForWork = 0
		SET @EmployeeID = NULL
	IF @BudgetPlanningActivityForWork = 0
		SET @ActivityTypeID = NULL
	IF @BudgetPlanningQualificationForWork = 0
		SET @QualificationID = NULL

	INSERT INTO [BudgetLineWork]
		([State], [FileAs], [BudgetID], [DocumentClass], [DocumentID],
		[BudgetLineGroupID], [Order], 
		[Rate],
		[EmployeeID], [ActivityTypeID], [QualificationID],
		[ActualManHour], [TotalPCActualManHour], [TotalWithVATPCActualManHour])
	VALUES
		(@State, @FileAs, @BudgetID, @DocumentClass, @DocumentID,
		@BudgetLineGroupID, dbo.fnPjm6GetBudgetObjectsOrder(@BudgetID, 'WorkLine', 'Actual', NULL, @BudgetLineGroupID), 
		@Rate,
		@EmployeeID, @ActivityTypeID, @QualificationID, 
		@ActualManHour, @TotalPCActualManHour, @TotalWithVATPCActualManHour)
	IF @@ERROR != 0
		RETURN 2

	SET @BudgetWorkLineID = SCOPE_IDENTITY()
	RETURN 0
GO

GRANT EXECUTE ON pjm6BudgetLineWorkCreateUnplanned TO PUBLIC
GO