IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[pjm6BudgetLineWorkUpdate]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	BEGIN
		PRINT 'Dropping procedure pjm6BudgetLineWorkUpdate'
		DROP PROCEDURE [dbo].[pjm6BudgetLineWorkUpdate]
	END
GO

PRINT 'Creating procedure pjm6BudgetLineWorkUpdate'
GO

/******************************************************************************
**		File: pjm6BudgetLineWorkUpdate.sql
**		Name: pjm6BudgetLineWorkUpdate
**		Desc: this procedure automatically generated by Avicom.Adf.Generator
**
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**      ----------						-----------
**
**		Auth: Anton.Paramonov
**		Date: 01/11/2010 14:00:00
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:		Description:
**		--------	--------	-------------------------------------------
**		21.02.13	MAB			  " "  "" 
**		28.02.13	MAB			  OPENXML
**		08.07.13	MAB			    
**		17.09.14	SAP			     ()
*******************************************************************************/
CREATE PROCEDURE pjm6BudgetLineWorkUpdate
	@Xml	XML
	
AS
DECLARE
		@BudgetState				    TState,
		@ID								TIdentifier,
		@FileAs							TName,
		@State							TState,
		@BudgetID						TIdentifier,
		@StartDate						TDate,
		@EndDate						TDate,
		@DocumentClass					TIdentifier,
		@DocumentID						TIdentifier,
		@LineParrentClass				TName,
		@BudgetLineGroupID				TIdentifier,
		@Order							TCount,
		@Rate							TMoney,
		@EmployeeID						TIdentifier,
		@ActivityTypeID					TIdentifier,
		@QualificationID				TIdentifier,
		@Own							TBool,
		@PlannedManHour					TAmount,
		@VATPCPlannedManHour			TMoney,
		@TotalPCPlannedManHour			TMoney,
		@TotalWithVATPCPlannedManHour	TMoney,
		@ExpenseID						TIdentifier,
		@Comments						TNotes,
		@PlanningActivityForWork		TBool,
		@PlanningEmployeeForWork		TBool,
		@PlanningQualificationForWork	TBool,
		@PlanningRateForWork			TBool,
		@PlanningDateForWork			TBool,
		@AssignmentID					TIdentifier

	SET NOCOUNT ON

	SELECT
		@ID								= @XML.value('(/pjm6BudgetLineWorkGet/BudgetLineWork/ID)[1]','int'),
		@FileAs							= @XML.value('(/pjm6BudgetLineWorkGet/BudgetLineWork/FileAs)[1]','nvarchar(256)'),
		@State							= @XML.value('(/pjm6BudgetLineWorkGet/BudgetLineWork/State)[1]','int'),
		@BudgetID						= @XML.value('(/pjm6BudgetLineWorkGet/BudgetLineWork/BudgetID)[1]','int'),					
		@StartDate						= CAST(@XML.value('(/pjm6BudgetLineWorkGet/BudgetLineWork/StartDate)[1]','varchar(19)') as datetime), 			
		@EndDate						= CAST(@XML.value('(/pjm6BudgetLineWorkGet/BudgetLineWork/EndDate)[1]','varchar(19)') as datetime),			 				
		@DocumentClass					= dbo.adfGetClassByName(@XML.value('(/pjm6BudgetLineWorkGet/BudgetLineWork/DocumentClass)[1]','varchar(32)')),		
		@DocumentID						= @XML.value('(/pjm6BudgetLineWorkGet/BudgetLineWork/DocumentID)[1]','int'),
		@LineParrentClass				= @XML.value('(/pjm6BudgetLineWorkGet/BudgetLineWork/BudgetClass)[1]','int'),		
		@BudgetLineGroupID				= @XML.value('(/pjm6BudgetLineWorkGet/BudgetLineWork/BudgetLineGroupID)[1]','int'),
		@Order							= @XML.value('(/pjm6BudgetLineWorkGet/BudgetLineWork/Order)[1]','int'),	
		@Rate							= @XML.value('(/pjm6BudgetLineWorkGet/BudgetLineWork/Rate)[1]','decimal(18,4)'),				
		@EmployeeID						= @XML.value('(/pjm6BudgetLineWorkGet/BudgetLineWork/EmployeeID)[1]','int'),		
		@ActivityTypeID					= @XML.value('(/pjm6BudgetLineWorkGet/BudgetLineWork/ActivityTypeID)[1]','int'),
		@QualificationID				= @XML.value('(/pjm6BudgetLineWorkGet/BudgetLineWork/QualificationID)[1]','int'),
		@Own							= @XML.value('(/pjm6BudgetLineWorkGet/BudgetLineWork/Own)[1]','bit'),
		@PlannedManHour					= @XML.value('(/pjm6BudgetLineWorkGet/BudgetLineWork/PlannedManHour)[1]','decimal(18,4)'),
		@VATPCPlannedManHour			= @XML.value('(/pjm6BudgetLineWorkGet/BudgetLineWork/VATPCPlannedManHour)[1]','decimal(18,4)'),		
		@TotalPCPlannedManHour			= @XML.value('(/pjm6BudgetLineWorkGet/BudgetLineWork/TotalPCPlannedManHour)[1]','decimal(18,4)'),			
		@TotalWithVATPCPlannedManHour	= @XML.value('(/pjm6BudgetLineWorkGet/BudgetLineWork/TotalWithVATPCPlannedManHour)[1]','decimal(18,4)'),
		@ExpenseID						= @XML.value('(/pjm6BudgetLineWorkGet/BudgetLineWork/ExpenseID)[1]','int'),		
		@Comments						= @XML.value('(/pjm6BudgetLineWorkGet/BudgetLineWork/Comments)[1]','nvarchar(max)'),
		@AssignmentID					= @XML.value('(/pjm6BudgetLineWorkGet/BudgetLineWork/AssignmentID)[1]','int')						

	IF dbo.fnPjm6CanEditBudget(@BudgetID) != 1
	BEGIN
		RAISERROR('#accessdenied', 18, -1)
		RETURN 1
	END

	IF @State = 1
	BEGIN
		SELECT		
			@PlanningActivityForWork		= [Budget].[PlanningActivityForWork],
			@PlanningEmployeeForWork		= [Budget].[PlanningEmployeeForWork],
			@PlanningQualificationForWork	= [Budget].[PlanningQualificationForWork],
			@PlanningRateForWork			= [Budget].[PlanningRateForWork],
			@PlanningDateForWork			= [Budget].[PlanningDateForWork],
			@BudgetState					= [Budget].[State]
		FROM
			[Budget]
		WHERE
			[Budget].[ID] = @BudgetID

		IF (@BudgetState <> 1 AND @BudgetState <> 6) AND @LineParrentClass = dbo.adfGetClassByName('Pjm6.Budget')
		BEGIN
			RAISERROR('#budgetIsOpenOrClosed', 18, -1)
			RETURN 1
		END

		IF ((@PlanningActivityForWork = 1 AND @ActivityTypeID IS NULL) OR 
			(@PlanningQualificationForWork = 1 AND @QualificationID IS NULL) OR
			((@BudgetState != 4 AND @BudgetState != 5) AND @PlanningDateForWork = 1 AND (@StartDate IS NULL OR @EndDate IS NULL)))
		BEGIN
			RAISERROR('#budgetplanningparameterisnull', 18, -1)
			RETURN 1
		END

		DECLARE
			@CountAssignment TCount

		IF @PlanningEmployeeForWork = 1
		BEGIN
			IF (@BudgetState != 6 AND @EmployeeID IS NULL) OR (@BudgetState = 6 AND @AssignmentID IS NULL)
			BEGIN
				IF @DocumentID IS NULL
				BEGIN
					RAISERROR('#budgetplanningparameterisnull', 18, -1)
					RETURN 1
				END	
				ELSE
				BEGIN
					SELECT
						@CountAssignment = COUNT(*)
					FROM
						[TaskRequestAssignment]
					WHERE
						[TaskRequestAssignment].[TaskRequestID] = @DocumentID
					IF @CountAssignment != 1 OR @EmployeeID IS NULL
					BEGIN
						RAISERROR('#budgetplanningparameterisnull', 18, -1)
						RETURN 1
					END
					ELSE
					BEGIN
						SELECT
							@EmployeeID = [EmployeeID],
							@AssignmentID = [AssignmentID]
						FROM
							[TaskRequest]
						WHERE
							[TaskRequest].[ID] = @DocumentID 
					END
				END
			END	
		END


		IF EXISTS(SELECT TOP 1 *FROM [BudgetLineWork] WHERE [BudgetLineWork].[State] = 1 AND [BudgetLineWork].[ID] != @ID AND
					[BudgetLineWork].[BudgetID] = @BudgetID AND [BudgetLineWork].[DocumentClass] = @DocumentClass AND
					[BudgetLineWork].[DocumentID] = @DocumentID)
		BEGIN
			RAISERROR('#BudgetLineAssociatedWithThisDocument', 18, -1)
			RETURN 1
		END

		--       
		DECLARE
			@OldLineGroup	TIdentifier
		SET @OldLineGroup = (SELECT [BudgetLineGroupID] FROM [BudgetLineWork] WHERE [ID] = @ID)
	END

	BEGIN TRANSACTION

	IF @DocumentID IS NULL
		SET @DocumentClass = NULL
	
	IF @State = 1
	BEGIN
		UPDATE
			[BudgetLineWork]
		SET
			[FileAs] = @FileAs,
			[StartDate] = @StartDate,
			[EndDate] = @EndDate,
			[DocumentClass] = @DocumentClass,
			[DocumentID] = @DocumentID,
			[BudgetLineGroupID] = @BudgetLineGroupID,
			[Order] = (CASE 
						WHEN (@OldLineGroup IS NOT NULL AND @BudgetLineGroupID IS NOT NULL AND @OldLineGroup != @BudgetLineGroupID) OR
							(@OldLineGroup IS NOT NULL AND @BudgetLineGroupID IS NULL) OR (@OldLineGroup IS NULL AND @BudgetLineGroupID IS NOT NULL) THEN 
							dbo.fnPjm6GetBudgetObjectsOrder(@BudgetID, 'WorkLine', 'Planned', NULL, @BudgetLineGroupID)
						ELSE
							[Order]
						END),
			[Rate] = @Rate,
			[EmployeeID] =	(CASE @BudgetState
								WHEN 6 THEN
									NULL
								ELSE 
									@EmployeeID
								END),
			[AssignmentID] =	(CASE @BudgetState
									WHEN 6 THEN
										@AssignmentID
									ELSE 
										NULL
								END),
			[ActivityTypeID] = @ActivityTypeID,
			[QualificationID] = @QualificationID,
			[Own] = ~@Own,
			[PlannedManHour] = @PlannedManHour,
			[TotalPCPlannedManHour] = @TotalPCPlannedManHour,
			[TotalWithVATPCPlannedManHour] = @TotalWithVATPCPlannedManHour,
			[ExpenseID] =	(CASE
								WHEN @Own = 0 THEN
									NULL
								ELSE
									@ExpenseID
							END),
			[Comments] = @Comments
		WHERE
			[ID] = @ID
		IF @@ERROR != 0
		BEGIN
			ROLLBACK TRANSACTION
			RETURN 1
		END

		IF (@OldLineGroup IS NOT NULL AND @BudgetLineGroupID IS NOT NULL AND @OldLineGroup != @BudgetLineGroupID) OR
		(@OldLineGroup IS NOT NULL AND @BudgetLineGroupID IS NULL) OR (@OldLineGroup IS NULL AND @BudgetLineGroupID IS NOT NULL)
		BEGIN
			UPDATE 
				[BudgetLineWork] 
			SET 
				[Order] = [Order] - 1
			WHERE 
				[Order] > @Order AND
				[BudgetID] = @BudgetID AND ((@OldLineGroup IS NULL AND [BudgetLineGroupID] IS NULL) OR (@OldLineGroup IS NOT NULL AND [BudgetLineGroupID] IS NOT NULL AND [BudgetLineGroupID] = @OldLineGroup))
			IF @@ERROR != 0
			BEGIN
				ROLLBACK TRANSACTION
				RETURN 1
			END
		END

		UPDATE 
			[TaskRequest]
		SET
			[ManHour] = @PlannedManHour,
			[Budget] = @Rate * @PlannedManHour
		WHERE
			[TaskRequest].[ID] = @DocumentID
		IF @@ERROR != 0
		BEGIN
			ROLLBACK TRANSACTION
			RETURN 1
		END
	END
	ELSE IF @State = 2
	BEGIN
		UPDATE
			[BudgetLineWork]
		SET
			[FileAs] = @FileAs,
			[Comments] = @Comments
		WHERE
			[ID] = @ID
		IF @@ERROR != 0
		BEGIN
			ROLLBACK TRANSACTION
			RETURN 1
		END
	END
	COMMIT TRANSACTION

	EXEC pjm6BudgetLineWorkGet @ID

	RETURN 0
GO

GRANT EXECUTE ON pjm6BudgetLineWorkUpdate TO PUBLIC
GO