﻿IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[pjm6BudgetTemplateDelete]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	BEGIN
		PRINT 'Dropping procedure pjm6BudgetTemplateDelete'
		DROP PROCEDURE [dbo].[pjm6BudgetTemplateDelete]
	END
GO

PRINT 'Creating procedure pjm6BudgetTemplateDelete'
GO

/******************************************************************************
**		File: pjm6BudgetTemplateDelete.sql
**		Name: pjm6BudgetTemplateDelete
**		Desc: this procedure automatically generated by Avicom.Adf.Generator
**
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**      ----------						-----------
**
**		Auth: Anton.Paramonov
**		Date: 09/12/2010 16:19:00
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		--------	--------		-------------------------------------------
**    
*******************************************************************************/
CREATE PROCEDURE pjm6BudgetTemplateDelete
	@ID TIdentifier
AS
	SET NOCOUNT ON
	
	IF dbo.adfHasAccessRight(dbo.adfGetRightID('ManageBudgetTemplates')) != 1 
	BEGIN
		RAISERROR('#accessdenied', 18, -1)
		RETURN 1
	END	

	BEGIN TRANSACTION
	
	DECLARE @TemplateClass TClass
	SET @TemplateClass = dbo.adfGetClassByName('Pjm6.BudgetTemplate')
	
	DELETE FROM [Document] WHERE ([ID] = @ID) AND ([Class] = @TemplateClass)
	IF @@ERROR != 0
	BEGIN
		ROLLBACK TRANSACTION
		RETURN 1
	END
	
	DELETE FROM [Budget] WHERE [Budget].[ID] = @ID
	IF @@ERROR != 0
	BEGIN
		ROLLBACK TRANSACTION
		RETURN 1
	END
	
	COMMIT TRANSACTION

	RETURN 0
GO

GRANT EXECUTE ON pjm6BudgetTemplateDelete TO PUBLIC
GO 