﻿IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[pjm6BudgetTemplateGet]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	BEGIN
		PRINT 'Dropping procedure pjm6BudgetTemplateGet'
		DROP PROCEDURE [dbo].[pjm6BudgetTemplateGet]
	END
GO

PRINT 'Creating procedure pjm6BudgetTemplateGet'
GO

/******************************************************************************
**		File: pjm6BudgetTemplateGet.sql
**		Name: pjm6BudgetTemplateGet
**		Desc: this procedure automatically generated by Avicom.Adf.Generator
**
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**      ----------						-----------
**
**		Auth: Anton.Paramonov
**		Date: 09/12/2010 16:01:00
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		--------	--------		-------------------------------------------
**
*******************************************************************************/
CREATE PROCEDURE [pjm6BudgetTemplateGet]
	@ID TIdentifier
AS
	SET NOCOUNT ON
	
	IF dbo.adfHasAccessRight(dbo.adfGetRightID('ManageBudgetTemplates')) != 1 
	BEGIN
		RAISERROR('#accessdenied', 18, -1)
		RETURN 1
	END	

	DECLARE @TemplateClass TClass,
			@CurrentUserID TIdentifier
	SET @TemplateClass = dbo.adfGetClassByName('Pjm6.BudgetTemplate')
	SET @CurrentUserID = dbo.adfGetCurrentUserID()
	
	SELECT
		@TemplateClass AS [Class],
		[Budget].[ID],
		[Budget].[State],
		[Budget].[Flag],
		[Budget].[FileAs],
		[Budget].[BudgetTypeID],
		[Budget].[UseWorkPlanning],
		[Budget].[UseExpensePlanning],
		[Budget].[CurrencyCode],
		[Budget].[CalculateBudgetPatternID],
		[Budget].[VATRate],
		[Budget].[VATIsIncluded],
		[Budget].[WorkBudgetBottom],
		[Budget].[WorkBudgetHigh],
		[Budget].[WorkBudgetBottomEqualsPlan],
		[Budget].[WorkBudgetHighEqualsPlan],
		[Budget].[ExpenseBudgetBottom],
		[Budget].[ExpenseBudgetHigh],
		[Budget].[ExpenseBudgetBottomEqualsPlan],
		[Budget].[ExpenseBudgetHighEqualsPlan],
		[Budget].[SupervisorEmployeeID],
		[Budget].[DiscountViewWork],
		ABS([Budget].[DiscountPercentWork]) AS [DiscountPercentWork],
		ABS([Budget].[DiscountTotalWork]) AS [DiscountTotalWork],
		CASE WHEN [DiscountPercentWork] > 0 OR [DiscountTotalWork] > 0 THEN 2
			WHEN [DiscountPercentWork] < 0 OR [DiscountTotalWork] < 0 THEN 1
			WHEN [DiscountPercentWork] IS NULL AND [DiscountTotalWork] IS NULL THEN 0 END  AS [DiscountTypeWork],
		[Budget].[DiscountViewExpense],
		ABS([Budget].[DiscountPercentExpense]) AS [DiscountPercentExpense],
		ABS([Budget].[DiscountTotalExpense]) AS [DiscountTotalExpense],
		CASE WHEN [DiscountPercentExpense] > 0 OR [DiscountTotalExpense] > 0 THEN 2
			WHEN [DiscountPercentExpense] < 0 OR [DiscountTotalExpense] < 0 THEN 1
			WHEN [DiscountPercentExpense] IS NULL AND [DiscountTotalExpense] IS NULL THEN 0 END AS [DiscountTypeExpense],
		[Budget].[PlanningActivityForWork],
		[Budget].[PlanningEmployeeForWork],
		[Budget].[PlanningQualificationForWork],
		[Budget].[PlanningRateForWork],
		[Budget].[PlanningDateForWork],
		[Budget].[PlanningExpenseTypeForExpense],
		[Budget].[PlanningEmployeeForExpense],
		[Budget].[PlanningPriceForExpense],
		[Budget].[PlanningDateForExpense],
		[Budget].[TimeEntryAccount],
		[Budget].[TimeEntrySendingForApprovalAccount],
		--Включать в расчет (0 - внесенное, 1 - проданное время)
		[Budget].[TimeEntryActualTotalsAccount],
		([Budget].[PlanProfitability] * 100) as [PlanProfitability],
		[Budget].[ExpenseAccount],
		[Budget].[ExpenseSendingForApprovalAccount],
		[Budget].[PlanPurchases],
		--Стоимость работ (план)
		(CASE WHEN [Budget].[VATRate] IS NOT NULL AND [Budget].[VATIsIncluded] = 1 THEN [TotalWithVATPCPlannedManHour]
			ELSE [TotalPCPlannedManHour] 
		END) AS [TotalPlannedManHour],
		--Стоимость затрат (план)
		dbo.fnPjm6GetBudgetTotal([VATRate], [VATIsIncluded], [TotalPCPlannedExpense], [TotalWithVATPCPlannedExpense], 'Expense')  
			 AS [TotalPlannedExpense],
		[Budget].[Comments],
		[Budget].[Created],
		[Budget].[CreatedBy],
		[Budget].[Modified],
		[Budget].[ModifiedBy],
		[Budget].[Timestamp]
	FROM
		[Budget] 
	WHERE
		[Budget].[ID] = @ID
		
	RETURN 0
GO

GRANT EXECUTE ON [pjm6BudgetTemplateGet] TO PUBLIC
GO  