﻿IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[pjm6BudgetUpdateTotalsWithSub]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	BEGIN
		PRINT 'Dropping procedure pjm6BudgetUpdateTotalsWithSub'
		DROP PROCEDURE [dbo].[pjm6BudgetUpdateTotalsWithSub]
	END
GO

PRINT 'Creating procedure pjm6BudgetUpdateTotalsWithSub'
GO

/******************************************************************************
**		File: BudgetUpdateTotalsWithSub.sql
**		Name: pjm6BudgetUpdateTotalsWithSub
**		Desc: this procedure automatically generated by Avicom.Adf.Generator
**
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**      ----------						-----------
**
**		Auth: Anton.Paramonov
**		Date: 02/02/2011 22:30:00
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		--------	--------		-------------------------------------------
**
*******************************************************************************/
CREATE PROCEDURE [pjm6BudgetUpdateTotalsWithSub]
	@BudgetID TIdentifier,
	@PlannedManHourWithSub						TAmount,
	@ActualManHourWithSub						TAmount,
	@TotalPCPlannedManHourWithSub				TMoney,
	@TotalWithVATPCPlannedManHourWithSub		TMoney,
	@TotalPCActualManHourWithSub				TMoney,
	@TotalWithVATPCActualManHourWithSub			TMoney,
	@TotalPCPlannedExpenseWithSub				TMoney,
	@TotalWithVATPCPlannedExpenseWithSub		TMoney,
	@TotalPCActualExpenseWithSub				TMoney,
	@TotalWithVATPCActualExpenseWithSub			TMoney,
	@TotalPCWDPlannedManHourWithSub				TMoney,
	@TotalWithVATPCWDPlannedManHourWithSub		TMoney,
	@TotalPCWDActualManHourWithSub				TMoney,
	@TotalWithVATPCWDActualManHourWithSub		TMoney,
	@TotalPCWDPlannedExpenseWithSub				TMoney,
	@TotalWithVATPCWDPlannedExpenseWithSub		TMoney,
	@TotalPCWDActualExpenseWithSub				TMoney,
	@TotalWithVATPCWDActualExpenseWithSub		TMoney
AS
	UPDATE
		[Budget]
	SET
		[PlannedManHourWithSub]					= [PlannedManHour]					+ @PlannedManHourWithSub,				
		[ActualManHourWithSub]					= [ActualManHour]					+ @ActualManHourWithSub,							
		[TotalPCPlannedManHourWithSub]			= [TotalPCPlannedManHour]			+ @TotalPCPlannedManHourWithSub,		
		[TotalWithVATPCPlannedManHourWithSub]	= [TotalWithVATPCPlannedManHour]	+ @TotalWithVATPCPlannedManHourWithSub,		
		[TotalPCActualManHourWithSub]			= [TotalPCActualManHour]			+ @TotalPCActualManHourWithSub,		
		[TotalWithVATPCActualManHourWithSub]	= [TotalWithVATPCActualManHour]		+ @TotalWithVATPCActualManHourWithSub,				
		[TotalPCPlannedExpenseWithSub]			= [TotalPCPlannedExpense]			+ @TotalPCPlannedExpenseWithSub,		
		[TotalWithVATPCPlannedExpenseWithSub]	= [TotalWithVATPCPlannedExpense]	+ @TotalWithVATPCPlannedExpenseWithSub,		
		[TotalPCActualExpenseWithSub]			= [TotalPCActualExpense]			+ @TotalPCActualExpenseWithSub,		
		[TotalWithVATPCActualExpenseWithSub]	= [TotalWithVATPCActualExpense]		+ @TotalWithVATPCActualExpenseWithSub,

		[TotalPCWDPlannedManHourWithSub]		= CASE WHEN [VATRate] IS NOT NULL AND [VATIsIncluded] = 1 THEN dbo.fnPjm6GetBudgetTotalWithDiscount([VATRate], [VATIsIncluded], [DiscountViewWork], [DiscountPercentWork], [DiscountTotalWork], [TotalPCPlannedManHour], [TotalWithVATPCPlannedManHour]) - 
			dbo.fnPjm6GetBudgetVATForTotal([VATRate], [VATIsIncluded], [DiscountViewWork], [DiscountPercentWork], [DiscountTotalWork], [TotalPCPlannedManHour], [TotalWithVATPCPlannedManHour]) ELSE
			dbo.fnPjm6GetBudgetTotalWithDiscount([VATRate], [VATIsIncluded], [DiscountViewWork], [DiscountPercentWork], [DiscountTotalWork], [TotalPCPlannedManHour], [TotalWithVATPCPlannedManHour]) END + @TotalPCWDPlannedManHourWithSub,			 
		
		[TotalWithVATPCWDPlannedManHourWithSub]	= CASE WHEN [VATRate] IS NOT NULL AND [VATIsIncluded] = 1 THEN dbo.fnPjm6GetBudgetTotalWithDiscount([VATRate], [VATIsIncluded], [DiscountViewWork], [DiscountPercentWork], [DiscountTotalWork], [TotalPCPlannedManHour], [TotalWithVATPCPlannedManHour]) ELSE
			dbo.fnPjm6GetBudgetTotalWithDiscount([VATRate], [VATIsIncluded], [DiscountViewWork], [DiscountPercentWork], [DiscountTotalWork], [TotalPCPlannedManHour], [TotalWithVATPCPlannedManHour]) + 
			dbo.fnPjm6GetBudgetVATForTotal([VATRate], [VATIsIncluded], [DiscountViewWork], [DiscountPercentWork], [DiscountTotalWork], [TotalPCPlannedManHour], [TotalWithVATPCPlannedManHour]) END
			+ @TotalWithVATPCWDPlannedManHourWithSub,	
		
		[TotalPCWDActualManHourWithSub]			= CASE WHEN [VATRate] IS NOT NULL AND [VATIsIncluded] = 1 THEN dbo.fnPjm6GetBudgetTotalWithDiscount([VATRate], [VATIsIncluded], [DiscountViewWork], [DiscountPercentWork], [DiscountTotalWork], [TotalPCActualManHour], [TotalWithVATPCActualManHour]) - 
			dbo.fnPjm6GetBudgetVATForTotal([VATRate], [VATIsIncluded], [DiscountViewWork], [DiscountPercentWork], [DiscountTotalWork], [TotalPCActualManHour], [TotalWithVATPCActualManHour]) ELSE 
			dbo.fnPjm6GetBudgetTotalWithDiscount([VATRate], [VATIsIncluded], [DiscountViewWork], [DiscountPercentWork], [DiscountTotalWork], [TotalPCActualManHour], [TotalWithVATPCActualManHour]) END + @TotalPCWDActualManHourWithSub,			
		
		[TotalWithVATPCWDActualManHourWithSub]	= CASE WHEN [VATRate] IS NOT NULL AND [VATIsIncluded] = 1 THEN dbo.fnPjm6GetBudgetTotalWithDiscount([VATRate], [VATIsIncluded], [DiscountViewWork], [DiscountPercentWork], [DiscountTotalWork], [TotalPCActualManHour], [TotalWithVATPCActualManHour]) ELSE
			dbo.fnPjm6GetBudgetTotalWithDiscount([VATRate], [VATIsIncluded], [DiscountViewWork], [DiscountPercentWork], [DiscountTotalWork], [TotalPCActualManHour], [TotalWithVATPCActualManHour]) + 
			dbo.fnPjm6GetBudgetVATForTotal([VATRate], [VATIsIncluded], [DiscountViewWork], [DiscountPercentWork], [DiscountTotalWork], [TotalPCActualManHour], [TotalWithVATPCActualManHour]) END
			+ @TotalWithVATPCWDActualManHourWithSub,	
		
		[TotalPCWDPlannedExpenseWithSub]		= dbo.fnPjm6GetBudgetTotalWithDiscount([VATRate], 0, [DiscountViewExpense], [DiscountPercentExpense], [DiscountTotalExpense], [TotalPCPlannedExpense], [TotalPCPlannedExpense] + dbo.fnPjm6GetVATForTotal([TotalPCPlannedExpense], [VATRate], 0, 1))		
			+ @TotalPCWDPlannedExpenseWithSub,			
		
		[TotalWithVATPCWDPlannedExpenseWithSub]	= dbo.fnPjm6GetBudgetTotalWithDiscount([VATRate], 1, [DiscountViewExpense], [DiscountPercentExpense], [DiscountTotalExpense], [TotalPCPlannedExpense], [TotalPCPlannedExpense] + dbo.fnPjm6GetVATForTotal([TotalPCPlannedExpense], [VATRate], 0, 1))	
			+ @TotalWithVATPCWDPlannedExpenseWithSub,	
		
		[TotalPCWDActualExpenseWithSub]			= dbo.fnPjm6GetBudgetTotalWithDiscount([VATRate], 0, [DiscountViewExpense], [DiscountPercentExpense], [DiscountTotalExpense], [TotalPCActualExpense], [TotalPCActualExpense] + dbo.fnPjm6GetVATForTotal([TotalPCActualExpense], [VATRate], 0, 1))
			+ @TotalPCWDActualExpenseWithSub,			
		
		[TotalWithVATPCWDActualExpenseWithSub]	= dbo.fnPjm6GetBudgetTotalWithDiscount([VATRate], 1, [DiscountViewExpense], [DiscountPercentExpense], [DiscountTotalExpense], [TotalPCActualExpense], [TotalPCActualExpense] + dbo.fnPjm6GetVATForTotal([TotalPCActualExpense], [VATRate], 0, 1))	
			+ @TotalWithVATPCWDActualExpenseWithSub
	WHERE
		[Budget].[ID] = @BudgetID
	IF @@ERROR != 0
		RETURN 2

	RETURN 0
GO

GRANT EXECUTE ON [pjm6BudgetUpdateTotalsWithSub] TO PUBLIC
GO
