  IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[pjm5CalculationLinesSelect]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	BEGIN
		PRINT 'Dropping procedure pjm5CalculationLinesSelect'
		DROP PROCEDURE [dbo].[pjm5CalculationLinesSelect]
	END
GO

PRINT 'Creating procedure pjm5CalculationLinesSelect'
GO

/******************************************************************************
**		File: pjm5CalculationLinesSelect.sql
**		Name: pjm5CalculationLinesSelect
**		Desc: this procedure automatically generated by Avicom.Adf.Generator
**
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**      ----------						-----------
**
**		Auth: Andrew.Maklakov
**		Date: 05/03/2005 11:14:48
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		--------	--------		-------------------------------------------
**		30.03.11	SYV				    "  "
**		13.09.12	MAB				         
**		17.12.12	SOV				 :        (UseVariousCurrency);
**									   TotalSumProjectCurrency -     
**		28.12.12	SOV				     ,         
**		28.02.13	SOV				        
**		13.03.13	SOV				          
**		04.03.15	SAP				 @PeriodEnd (+ 1 ,   )
*******************************************************************************/
CREATE PROCEDURE [pjm5CalculationLinesSelect]
	@ProjectID TIdentifier,
	@DocumentClass TClass,
	@PeriodStart TDate,
	@PeriodEnd TDate,
	@Employee TIdentifier = NULL,
	@Category TName,
	@CurrencyCode TCode3,
	@SentToApprove TBool,
	@Task TIdentifier = NULL,
	@Service TIdentifier = NULL,
	@Contact TIdentifier = NULL,
	@ContactClass TClass = NULL,
	@Flag int = NULL,
	@JobID TIdentifier = NULL,
	@JobClass TClass = NULL,
	@DocumentID TIdentifier,
	@UseVariousCurrency bit,
	@IncludingRecordsOfSubprojects bit
AS
	SET NOCOUNT ON
	DECLARE 
		@value TVariant,
		@VATRate TPercent,
		@FlagTask TBool,
		@FlagService TBool,
		@FlagFileAs TBool,
		@FlagComments TBool,
		@Separator1 TName,
		@Separator2 TName,
		@Separator3 TName,
		@TaskRequestSeparator TName,
		@ServiceRequestSeparator TName,
		@IssueSeparator TName,
		@FlagTaskRequest TBool,
		@FlagServiceRequest TBool,
		@FlagIssue TBool,
		@RatesWithVAT TBool,
		@PCurrencyCode TCode3

	EXEC adfParameterGet @Name='DocumentLineSeparator1', @Group='Pjm5', @Value = @value OUTPUT
	SET @Separator1 = CAST(@value as nvarchar(256))
	EXEC adfParameterGet @Name='DocumentLineSeparator2', @Group='Pjm5', @Value = @value OUTPUT
	SET @Separator2 = CAST(@value as nvarchar(256))
	EXEC adfParameterGet @Name='DocumentLineSeparator3', @Group='Pjm5', @Value = @value OUTPUT
	SET @Separator3 = CAST(@value as nvarchar(256))
	EXEC adfParameterGet @Name='TaskRequestSeparator', @Group='Pjm5', @Value = @value OUTPUT
	SET @TaskRequestSeparator = CAST(@value as nvarchar(256))
	EXEC adfParameterGet @Name='ServiceRequestSeparator', @Group='Pjm5', @Value = @value OUTPUT
	SET @ServiceRequestSeparator = CAST(@value as nvarchar(256))
	EXEC adfParameterGet @Name='IssueSeparator', @Group='Pjm5', @Value = @value OUTPUT
	SET @IssueSeparator = CAST(@value as nvarchar(256))

	SELECT 
		@RatesWithVAT = [RatesWithVAT],
		@VATRate = [VATRate] 
	FROM 
		[Calculation] 
	WHERE 
		[Calculation].[ID] = @DocumentID
		
	SELECT
		@PCurrencyCode = [CurrencyCode]
	FROM
		[Project]
	WHERE
		[Project].[ID] = @ProjectID
	
	SELECT
		@PeriodStart = CAST(@PeriodStart AS date),
		@PeriodEnd = DATEADD(DAY,1,CAST(@PeriodEnd AS date))
		
	DECLARE
		@CalculationClass TClass,
		@StatementClass TClass,
		@InvoiceClass TClass,
		@FactureClass TClass
	SET @CalculationClass = dbo.adfGetClassByName('Pjm5.Calculation')
	SET @StatementClass = dbo.adfGetClassByName('Pjm5.Statement')
	SET @InvoiceClass = dbo.adfGetClassByName('Pjm5.Invoice')
	SET @FactureClass = dbo.adfGetClassByName('Pjm5.Facture')

	--      
	DECLARE @subprojectsTable TABLE 
	(
		[Class] TClass,
		[ID] TIdentifier,
		[State] TState,
		[Flag] TFlag,
		[Date] TDate,
		[Number] TCode,
		[FileAs] TName,
		[ProjectTypeID] TIdentifier,
		[SupplierCompanyID] TIdentifier,
		[ProjectManagerEmployeeID] TIdentifier,
		[CustomerCompanyID] TIdentifier,
		[CustomerFinanceManagerID] TIdentifier,
		[ResponsiblePersonEmployeeID] TIdentifier,
		[PriorityID] TIdentifier,
		[DueDate] TDate,
		[EndDate] TDate,
		[CurrencyCode] TCode3,
		[CostCenterID] TIdentifier,
		[ManHour] TCount,
		[Budget] TMoney,
		[PlannedManHour] TCount,
		[PlannedBudget] TMoney,
		[Billable] TBool,
		[RoundingInterval] TCount,
		[RoundingMode] TIdentifier,
		[ContractNumber] TCode,
		[ContractDate] TDate,
		[ContractEndDate] TDate,
		[ContractSubject] TName,
		[ServiceLevelID] TIdentifier,
		[ApplyVAT] TBool,
		[InvoiceExpirationPeriod] TCount,
		[InvoiceExpirationPeriodType] TIdentifier,
		[Comments] TNotes,
		[Created] TSysDateTime,
		[CreatedBy] TUserID,
		[Modified] TSysDateTime,
		[ModifiedBy] TUserID,
		[ExchangeSystemName] TName,
		[Timestamp] varbinary(MAX),
		[PercentComplete] TPercent,
		[PC] INT,
		[PaymentCurrencyPoint] TIdentifier,
		[IsConsignor] TBool,
		[Consignor] TName,
		[ConsignorContract] TName,
		[ParentProjectID] INT,
		[ManagerAssistantEmployeeID] TIdentifier,
		[FinanceManagerEmployeeID] TIdentifier
	);

	--     
	INSERT INTO @subprojectsTable exec pjm6SubProjectBrowse @ParentProjectID=@ProjectID,@StateSelector=2,
		@CanCreateCalculation = 1

	IF @DocumentClass = dbo.adfGetClassByName('Pjm5.TimeEntry')
	BEGIN
		SET @value = NULL
		EXEC adfParameterGet @Name='DocumentLineContainsTask', @Group='Pjm5', @Value = @value OUTPUT
		SET @FlagTask = ISNULL(CAST(@value as bit), 0)
			
		SET @value = NULL
		EXEC adfParameterGet @Name='DocumentLineContainsService', @Group='Pjm5', @Value = @value OUTPUT
		SET @FlagService = ISNULL(CAST(@value as bit), 0)

		SET @value = NULL
		EXEC adfParameterGet @Name='DocumentLineContainsFileAs', @Group='Pjm5', @Value = @value OUTPUT
		SET @FlagFileAs = ISNULL(CAST(@value as bit), 0)

		SET @value = NULL
		EXEC adfParameterGet @Name='DocumentLineContainsComments', @Group='Pjm5', @Value = @value OUTPUT
		SET @FlagComments = ISNULL(CAST(@value as bit), 0)
		
		SET @value = NULL
		EXEC adfParameterGet @Name='DocumentLineContainsServiceRequest', @Group='Pjm5', @Value = @value OUTPUT
		SET @FlagServiceRequest = ISNULL(CAST(@value as bit), 0)

		SET @value = NULL
		EXEC adfParameterGet @Name='DocumentLineContainsTaskRequest', @Group='Pjm5', @Value = @value OUTPUT
		SET @FlagTaskRequest = ISNULL(CAST(@value as bit), 0)

		SET @value = NULL
		EXEC adfParameterGet @Name='DocumentLineContainsIssue', @Group='Pjm5', @Value = @value OUTPUT
		SET @FlagIssue = ISNULL(CAST(@value as bit), 0)

		SELECT
			DISTINCT
			CAST(1 AS bit) AS [Selected],
			[Project].[Number] AS [ProjectCode],
			[TimeEntry].[State],
			[TimeEntry].[Class],
			[TimeEntry].[ID],
			[TimeEntry].[DocumentID],
			[TimeEntry].[DocumentClass],			
			[TimeEntry].[StartTime] AS [Date],
			[Employee].[ID] AS [EmployeeID],
			[Employee].[FileAs] AS [Employee],
			[TimeEntry].[FileAs],
			[TimeEntry].[BillableHour] AS [Amount],
			[TimeEntry].[Rate] AS [Price],
			[TimeEntry].[Rate] * (1 + (1 - @RatesWithVAT) * @VATRate) AS [PriceWithVAT],
			[TimeEntry].[Rate] * [TimeEntry].[BillableHour] AS [Sum],
			@RatesWithVAT AS [VATIsIncluded],
			([TimeEntry].[Rate] * [TimeEntry].[BillableHour]) * @VATRate / (1 + @RatesWithVAT * @VATRate) AS [VAT],
			[TimeEntry].[Rate] * [TimeEntry].[BillableHour] / (1 + @RatesWithVAT * @VATRate) AS [SumWithoutVAT],
			[TimeEntry].[Rate] * [TimeEntry].[BillableHour] * (1 + (1 - @RatesWithVAT) * @VATRate) AS [SumWithVAT],
			[TimeEntry].[Comments],
			@PCurrencyCode AS [CurrencyCode],
			dbo.fnPjm5GetEntryDescription(
				CASE @FlagTask WHEN 1 THEN [Task].[FileAs] ELSE NULL END,
				CASE @FlagService WHEN 1 THEN [ServiceAssignment].[FileAs] ELSE NULL END,
				CASE @FlagFileAs WHEN 1 THEN [TimeEntry].[FileAs] ELSE NULL END,
				CASE @FlagComments WHEN 1 THEN [TimeEntry].[Comments] ELSE NULL END,
				CASE @FlagIssue WHEN 1 THEN [Issue].[FileAs] ELSE NULL END,
				CASE @FlagServiceRequest WHEN 1 THEN [ServiceRequest].[FileAs] ELSE NULL END,
				CASE @FlagTaskRequest WHEN 1 THEN [TaskRequest].[FileAs] ELSE NULL END,
				ISNULL(@Separator1, ' '),
				ISNULL(@Separator2, ' '),
				ISNULL(@Separator3, ' '),
				ISNULL(@IssueSeparator, ' '),
				ISNULL(@ServiceRequestSeparator, ' '),
				ISNULL(@TaskRequestSeparator, ' '),
				[TimeEntry].[FileAs]
			) AS [Description]
		FROM
			[vwTimeEntry] as [TimeEntry]
			INNER JOIN [Employee]
				ON [Employee].[ID] = [TimeEntry].[EmployeeID]
			LEFT OUTER JOIN [Task]
				ON [Task].[ID] = [TimeEntry].[TaskID]
			LEFT OUTER JOIN [ServiceAssignment]
				ON [ServiceAssignment].[ID] = [TimeEntry].[DocumentID]
					AND [ServiceAssignment].[Class] = [TimeEntry].[DocumentClass]
			LEFT OUTER JOIN [ServiceRequest]
				ON [ServiceRequest].[Class] = [TimeEntry].[DocumentClass] 
					AND [ServiceRequest].[ID] = [TimeEntry].[DocumentID]
			LEFT OUTER JOIN [Issue]
				ON [Issue].[Class] = [TimeEntry].[DocumentClass] 
					AND [Issue].[ID] = [TimeEntry].[DocumentID]
			LEFT OUTER JOIN [TaskRequest]
				ON [TaskRequest].[Class] = [TimeEntry].[DocumentClass] 
					AND [TaskRequest].[ID] = [TimeEntry].[DocumentID]
			LEFT OUTER JOIN [DocumentContact]
				ON [TimeEntry].[Class] = [DocumentContact].[DocumentClass] 
					AND [TimeEntry].[ID] = [DocumentContact].[DocumentID]
			INNER JOIN [Project]
				ON [TimeEntry].[ProjectID] = [Project].[ID]
		WHERE
			(
				@Task IS NULL OR
				[TimeEntry].[TaskID] = @Task
			) AND
			(
				@Flag IS NULL OR
				[TimeEntry].[Flag] = @Flag
			) AND
			(
				@Service IS NULL OR
				[TimeEntry].[DocumentID] = @Service
			) AND
			(
				(
					@IncludingRecordsOfSubprojects = 1 AND 
					[TimeEntry].[ProjectID] IN (SELECT [ID] FROM @subprojectsTable)
				) OR
				(
					[TimeEntry].[ProjectID] = @ProjectID
				)
			) AND
				[TimeEntry].[StartTime] >= @PeriodStart AND 
				[TimeEntry].[StartTime] < @PeriodEnd AND
			(
				[TimeEntry].[State] = 3 OR
				@SentToApprove = 1 AND [TimeEntry].[State] = 2
			) AND
			[TimeEntry].[Billable] = 1 AND
			NOT EXISTS(
				SELECT * FROM [Attachment] 
				WHERE 
					[DocumentClass] = [TimeEntry].[Class] AND 
					[DocumentID] = [TimeEntry].[ID] AND 
					[AttachmentTypeID] = 3 AND
					[Attachment].[LinkDocumentClass] IN (@CalculationClass, @StatementClass, @InvoiceClass, @FactureClass)
			) AND
			(@Employee IS NULL OR [Employee].[ID] = @Employee) AND
			(
				@Category IS NULL OR 
				EXISTS (
					SELECT * 
					FROM
						[DocumentCategory]
						INNER JOIN [Category]
							ON ([DocumentCategory].[DocumentClass] = [Category].[DocumentClass] AND 
								[DocumentCategory].[CategoryID] = [Category].[ID])
					WHERE
						[DocumentCategory].[DocumentClass] = [TimeEntry].[Class] AND 
						[DocumentCategory].[DocumentID] = [TimeEntry].[ID] AND
						[Category].[FileAs] LIKE @Category
					)
			) AND
			(
				@JobID IS NULL OR
				[TimeEntry].[DocumentID] = @JobID AND [TimeEntry].[DocumentClass] = @JobClass
			) AND
			(
				@Contact IS NULL OR 
				([DocumentContact].[BusinessCardID] = @Contact AND [DocumentContact].[BusinessCardClass] = @ContactClass)
			)
	END	
	ELSE IF @DocumentClass = dbo.adfGetClassByName('Pjm5.Expense')
	BEGIN
		SET @value = NULL
		EXEC adfParameterGet @Name='DocumentLineContainsTask', @Group='Pjm5', @Value = @value OUTPUT
		SET @FlagTask = ISNULL(CAST(@value as bit), 0)
			
		SET @value = NULL
		EXEC adfParameterGet @Name='DocumentLineContainsService', @Group='Pjm5', @Value = @value OUTPUT
		SET @FlagService = ISNULL(CAST(@value as bit), 0)

		SET @value = NULL
		EXEC adfParameterGet @Name='DocumentLineContainsFileAs', @Group='Pjm5', @Value = @value OUTPUT
		SET @FlagFileAs = ISNULL(CAST(@value as bit), 0)

		SET @value = NULL
		EXEC adfParameterGet @Name='DocumentLineContainsComments', @Group='Pjm5', @Value = @value OUTPUT
		SET @FlagComments = ISNULL(CAST(@value as bit), 0)
		
		SET @value = NULL
		EXEC adfParameterGet @Name='DocumentLineContainsServiceRequest', @Group='Pjm5', @Value = @value OUTPUT
		SET @FlagServiceRequest = ISNULL(CAST(@value as bit), 0)

		SET @value = NULL
		EXEC adfParameterGet @Name='DocumentLineContainsTaskRequest', @Group='Pjm5', @Value = @value OUTPUT
		SET @FlagTaskRequest = ISNULL(CAST(@value as bit), 0)

		SET @value = NULL
		EXEC adfParameterGet @Name='DocumentLineContainsIssue', @Group='Pjm5', @Value = @value OUTPUT
		SET @FlagIssue = ISNULL(CAST(@value as bit), 0)

		SELECT
			DISTINCT
			CAST(1 AS bit) AS [Selected],
			[Project].[Number] AS [ProjectCode],
			[Expense].[State],
			[Expense].[Class],
			[Expense].[ID],
			[Expense].[DocumentID],
			[Expense].[DocumentClass],			
			[Expense].[Date],
			[Employee].[ID] AS [EmployeeID],
			[Employee].[FileAs] AS [Employee],
			[Expense].[FileAs],
			[Expense].[Amount],
			CASE 
				WHEN [Expense].[VATIsIncluded] = 1 AND [Expense].[Amount] != 0
					THEN [Expense].[Price] - [Expense].[VAT] / [Expense].[Amount]
				WHEN [Expense].[VATIsIncluded] = 1 AND [Expense].[Amount] = 0
					THEN [Expense].[Price] / (1 + [Expense].[VATRate])
				ELSE [Expense].[Price]
			END AS [Price],
			CASE 
				WHEN @VATRate = [Expense].[VATRate]
					THEN CASE
							WHEN [Expense].[VATIsIncluded] = 1
								THEN [Expense].[Price]
							WHEN [Expense].[VATIsIncluded] = 0 AND [Expense].[Amount] != 0
								THEN [Expense].[Price] + [Expense].[VAT] / [Expense].[Amount]
							ELSE [Expense].[Price] * (1 + [Expense].[VATRate])
						END
				ELSE
					CASE
						WHEN [Expense].[VATIsIncluded] = 1 AND [Expense].[Amount] != 0
							THEN ([Expense].[Price] - [Expense].[VAT] / [Expense].[Amount]) * (1 + @VATRate)
						WHEN [Expense].[VATIsIncluded] = 1 AND [Expense].[Amount] = 0
							THEN ([Expense].[Price] / (1 + [Expense].[VATRate])) * (1 + @VATRate)
						ELSE [Expense].[Price] * (1 + @VATRate)
					END
			END AS [PriceWithVAT],
			CASE 
				WHEN [Expense].[Amount] = 0
					THEN 0
				WHEN [Expense].[VATIsIncluded] = 1
					THEN [Expense].[Amount] * [Expense].[Price] - [Expense].[VAT]
				ELSE [Expense].[Amount] * [Expense].[Price]
			END
			AS [Sum],
			0 AS [VATIsIncluded],
			CASE 
				WHEN [Expense].[VATRate] = @VATRate
					THEN [Expense].[VAT]
				ELSE
					CASE
						WHEN [Expense].[VATIsIncluded] = 1 AND [Expense].[Amount] != 0
							THEN [Expense].[Price] - [Expense].[VAT] / [Expense].[Amount]
						WHEN [Expense].[VATIsIncluded] = 1 AND [Expense].[Amount] = 0
							THEN [Expense].[Price] / (1 + [Expense].[VATRate])
						ELSE [Expense].[Price]
					END
			END * @VATRate AS [VAT],
			CASE
				WHEN [Expense].[Amount] = 0
					THEN 0
				WHEN [Expense].[VATIsIncluded] = 1 
					THEN ([Expense].[Amount] * [Expense].[Price] - [Expense].[VAT])
				ELSE [Expense].[Amount] * [Expense].[Price]
			END AS [SumWithoutVAT],
			CASE 
				WHEN [Expense].[Amount] = 0
					THEN 0
				WHEN @VATRate = [Expense].[VATRate]
					THEN 
						CASE
							WHEN [Expense].[VATIsIncluded] = 1
								THEN [Expense].[Price] * [Expense].[Amount]
							ELSE
								[Expense].[Amount] * [Expense].[Price] + [Expense].[VAT]
						END
				ELSE
					CASE
						WHEN [Expense].[VATIsIncluded] = 1
							THEN ([Expense].[Price] * [Expense].[Amount] / (1 + [Expense].[VATRate])) * (1 + @VATRate)
						ELSE
							[Expense].[Price] * [Expense].[Amount] * (1 + @VATRate)
					END	
			END AS [SumWithVAT],
			[Expense].[Comments],
			[Expense].[FromCurrencyCode] AS [CurrencyCode],
			CASE 
				WHEN @VATRate != 0 
					THEN [Expense].[TotalSumProjectCurrency]
				ELSE [Expense].[SumProjectCurrency]
			END AS [TotalSumProjectCurrency],
			dbo.fnPjm5GetEntryDescription(
				CASE @FlagTask WHEN 1 THEN [Task].[FileAs] ELSE NULL END,
				NULL,
				CASE @FlagFileAs WHEN 1 THEN [Expense].[FileAs] ELSE NULL END,
				CASE @FlagComments WHEN 1 THEN [Expense].[Comments] ELSE NULL END,
				CASE @FlagIssue WHEN 1 THEN [Issue].[FileAs] ELSE NULL END,
				CASE @FlagServiceRequest WHEN 1 THEN [ServiceRequest].[FileAs] ELSE NULL END,
				CASE @FlagTaskRequest WHEN 1 THEN [TaskRequest].[FileAs] ELSE NULL END,				
				ISNULL(@Separator1, ' '),
				ISNULL(@Separator2, ' '),
				ISNULL(@Separator3, ' '),
				ISNULL(@IssueSeparator, ' '),
				ISNULL(@ServiceRequestSeparator, ' '),
				ISNULL(@TaskRequestSeparator, ' '),
				[Expense].[FileAs]
			) AS [Description]
		FROM
			[pjm5vwExpense] AS [Expense]
			INNER JOIN [Employee]
				ON [Employee].[ID] = [Expense].[EmployeeID]
			LEFT OUTER JOIN [Task]
				ON [Task].[ID] = [Expense].[TaskID]
			LEFT OUTER JOIN [ServiceRequest]
				ON [ServiceRequest].[Class] = [Expense].[DocumentClass] 
					AND [ServiceRequest].[ID] = [Expense].[DocumentID]
			LEFT OUTER JOIN [Issue]
				ON [Issue].[Class] = [Expense].[DocumentClass] 
					AND [Issue].[ID] = [Expense].[DocumentID]
			LEFT OUTER JOIN [TaskRequest]
				ON [TaskRequest].[Class] = [Expense].[DocumentClass] 
					AND [TaskRequest].[ID] = [Expense].[DocumentID]
			LEFT OUTER JOIN [DocumentContact]
				ON [Expense].[Class] = [DocumentContact].[DocumentClass] 
					AND [Expense].[ID] = [DocumentContact].[DocumentID]
			INNER JOIN [Project]
				ON [Expense].[ProjectID] = [Project].[ID]
		WHERE
			(
				@Task IS NULL OR
				[Expense].[TaskID] = @Task
			) AND
			(
				@Flag IS NULL OR
				[Expense].[Flag] = @Flag
			) AND
			(
				(
					@IncludingRecordsOfSubprojects = 1 AND 
					[Expense].[ProjectID] IN (SELECT [ID] FROM @subprojectsTable)
				) OR
				(
					[Expense].[ProjectID] = @ProjectID
				)
			) AND
			[Expense].[Date] >= @PeriodStart AND 
			[Expense].[Date] < @PeriodEnd AND
			([Expense].[ExpenseCodeID] IS NULL OR [Expense].[ExpenseCodeID] != 1) AND
			(
				[Expense].[State] = 3 OR
				@SentToApprove = 1 AND [Expense].[State] = 2
			) AND
			[Expense].[Billable] = 1 AND
			(@UseVariousCurrency = 1 OR [Expense].[FromCurrencyCode] = @CurrencyCode) AND
			NOT EXISTS(
				SELECT * FROM [Attachment] 
				WHERE 
					[DocumentClass] = [Expense].[Class] AND 
					[DocumentID] = [Expense].[ID] AND 
					[AttachmentTypeID] = 3 AND
					[Attachment].[LinkDocumentClass] IN (@CalculationClass, @StatementClass, @InvoiceClass, @FactureClass)
			) AND
			(@Employee IS NULL OR [Employee].[ID] = @Employee) AND
			(
				@Category IS NULL OR 
				EXISTS (
					SELECT * 
					FROM
						[DocumentCategory]
						INNER JOIN [Category]
							ON ([DocumentCategory].[DocumentClass] = [Category].[DocumentClass] AND 
								[DocumentCategory].[CategoryID] = [Category].[ID])
					WHERE
						[DocumentCategory].[DocumentClass] = [Expense].[Class] AND 
						[DocumentCategory].[DocumentID] = [Expense].[ID] AND
						[Category].[FileAs] LIKE @Category
					)
			) AND
			(
				@JobID IS NULL OR
				[Expense].[DocumentID] = @JobID AND [Expense].[DocumentClass] = @JobClass			
			) AND
			(
				@Contact IS NULL OR 
				([DocumentContact].[BusinessCardID] = @Contact AND [DocumentContact].[BusinessCardClass] = @ContactClass)
			)
	END
	ELSE IF @DocumentClass = dbo.adfGetClassByName('Pjm5.PhoneCall')
	BEGIN

		SET @value = NULL
		EXEC adfParameterGet @Name='DocumentLineContainsTask', @Group='Pjm5', @Value = @value OUTPUT
		SET @FlagTask = ISNULL(CAST(@value as bit), 0)
			
		SET @value = NULL
		EXEC adfParameterGet @Name='DocumentLineContainsService', @Group='Pjm5', @Value = @value OUTPUT
		SET @FlagService = ISNULL(CAST(@value as bit), 0)

		SET @value = NULL
		EXEC adfParameterGet @Name='DocumentLineContainsFileAs', @Group='Pjm5', @Value = @value OUTPUT
		SET @FlagFileAs = ISNULL(CAST(@value as bit), 0)

		SET @value = NULL
		EXEC adfParameterGet @Name='DocumentLineContainsComments', @Group='Pjm5', @Value = @value OUTPUT
		SET @FlagComments = ISNULL(CAST(@value as bit), 0)
		
		SET @value = NULL
		EXEC adfParameterGet @Name='DocumentLineContainsServiceRequest', @Group='Pjm5', @Value = @value OUTPUT
		SET @FlagServiceRequest = ISNULL(CAST(@value as bit), 0)

		SET @value = NULL
		EXEC adfParameterGet @Name='DocumentLineContainsTaskRequest', @Group='Pjm5', @Value = @value OUTPUT
		SET @FlagTaskRequest = ISNULL(CAST(@value as bit), 0)

		SET @value = NULL

		EXEC adfParameterGet @Name='DocumentLineContainsIssue', @Group='Pjm5', @Value = @value OUTPUT
		SET @FlagIssue = ISNULL(CAST(@value as bit), 0)
		SELECT
			DISTINCT            
			CAST(1 AS bit) AS [Selected],
			[Project].[Number] AS [ProjectCode],
			[Expense].[State],
			[Expense].[Class],
			[Expense].[ID],
			[Expense].[DocumentID],
			[Expense].[DocumentClass],			
			[Expense].[Date],
			[Employee].[ID] AS [EmployeeID],
			[Employee].[FileAs] AS [Employee],
			[Expense].[FileAs],
			[Expense].[Amount],
			CASE 
				WHEN [Expense].[VATIsIncluded] = 1 AND [Expense].[Amount] != 0
					THEN [Expense].[Price] - [Expense].[VAT] / [Expense].[Amount]
				WHEN [Expense].[VATIsIncluded] = 1 AND [Expense].[Amount] = 0
					THEN [Expense].[Price] / (1 + [Expense].[VATRate])
				ELSE [Expense].[Price]
			END AS [Price],
			CASE 
				WHEN @VATRate = [Expense].[VATRate]
					THEN CASE
							WHEN [Expense].[VATIsIncluded] = 1
								THEN [Expense].[Price]
							WHEN [Expense].[VATIsIncluded] = 0 AND [Expense].[Amount] != 0
								THEN [Expense].[Price] + [Expense].[VAT] / [Expense].[Amount]
							ELSE [Expense].[Price] * (1 + [Expense].[VATRate])
						END
					ELSE
						CASE
							WHEN [Expense].[VATIsIncluded] = 1 AND [Expense].[Amount] != 0
								THEN ([Expense].[Price] - [Expense].[VAT] / [Expense].[Amount]) * (1 + @VATRate)
							WHEN [Expense].[VATIsIncluded] = 1 AND [Expense].[Amount] = 0
								THEN ([Expense].[Price] / (1 + [Expense].[VATRate])) * (1 + @VATRate)
							ELSE [Expense].[Price] * (1 + @VATRate)
						END
			END AS [PriceWithVAT],
			CASE 
				WHEN [Expense].[Amount] = 0
					THEN 0
				WHEN [Expense].[VATIsIncluded] = 1
					THEN [Expense].[Amount] * [Expense].[Price] - [Expense].[VAT]
				ELSE [Expense].[Amount] * [Expense].[Price]
			END
			AS [Sum],
			0 AS [VATIsIncluded],
			CASE 
				WHEN [Expense].[VATRate] = @VATRate
					THEN [Expense].[VAT]
				ELSE
					CASE
						WHEN [Expense].[VATIsIncluded] = 1 AND [Expense].[Amount] != 0
							THEN [Expense].[Price] - [Expense].[VAT] / [Expense].[Amount]
						WHEN [Expense].[VATIsIncluded] = 1 AND [Expense].[Amount] = 0
							THEN [Expense].[Price] / (1 + [Expense].[VATRate])
						ELSE [Expense].[Price]
					END
			END * @VATRate AS [VAT],
			CASE
				WHEN [Expense].[Amount] = 0
					THEN 0
				WHEN [Expense].[VATIsIncluded] = 1 
					THEN ([Expense].[Amount] * [Expense].[Price] - [Expense].[VAT])
				ELSE [Expense].[Amount] * [Expense].[Price]
			END AS [SumWithoutVAT],
			CASE 
				WHEN [Expense].[Amount] = 0
					THEN 0
				WHEN @VATRate = [Expense].[VATRate]
					THEN 
						CASE
							WHEN [Expense].[VATIsIncluded] = 1
								THEN [Expense].[Price] * [Expense].[Amount]
							ELSE
								[Expense].[Amount] * [Expense].[Price] + [Expense].[VAT]
						END
					ELSE
						CASE
							WHEN [Expense].[VATIsIncluded] = 1
								THEN ([Expense].[Price] * [Expense].[Amount] / (1 + [Expense].[VATRate])) * (1 + @VATRate)
							ELSE
								[Expense].[Price] * [Expense].[Amount] * (1 + @VATRate)
						END	
			END AS [SumWithVAT],
			[Expense].[Comments],
			[Expense].[FromCurrencyCode],
			dbo.fnPjm5GetEntryDescription(
				CASE @FlagTask WHEN 1 THEN [Task].[FileAs] ELSE NULL END,
				NULL,
				CASE @FlagFileAs WHEN 1 THEN [Expense].[FileAs] ELSE NULL END,
				CASE @FlagComments WHEN 1 THEN [Expense].[Comments] ELSE NULL END,
				CASE @FlagIssue WHEN 1 THEN [Issue].[FileAs] ELSE NULL END,
				CASE @FlagServiceRequest WHEN 1 THEN [ServiceRequest].[FileAs] ELSE NULL END,
				CASE @FlagTaskRequest WHEN 1 THEN [TaskRequest].[FileAs] ELSE NULL END,		
				ISNULL(@Separator1, ' '),
				ISNULL(@Separator2, ' '),
				ISNULL(@Separator3, ' '),
				ISNULL(@IssueSeparator, ' '),
				ISNULL(@ServiceRequestSeparator, ' '),
				ISNULL(@TaskRequestSeparator, ' '),
				[Expense].[FileAs]
			) AS [Description]
		FROM
			[pjm5vwExpense] AS [Expense]
			INNER JOIN [Employee]
				ON [Employee].[ID] = [Expense].[EmployeeID]
			LEFT OUTER JOIN [Task]
				ON [Task].[ID] = [Expense].[TaskID]
			LEFT OUTER JOIN [ServiceRequest]
				ON [ServiceRequest].[Class] = [Expense].[DocumentClass] 
					AND [ServiceRequest].[ID] = [Expense].[DocumentID]
			LEFT OUTER JOIN [Issue]
				ON [Issue].[Class] = [Expense].[DocumentClass] 
					AND [Issue].[ID] = [Expense].[DocumentID]
			LEFT OUTER JOIN [TaskRequest]
				ON [TaskRequest].[Class] = [Expense].[DocumentClass] 
					AND [TaskRequest].[ID] = [Expense].[DocumentID]
			LEFT OUTER JOIN [DocumentContact]
				ON [Expense].[class] = [DocumentContact].[DocumentClass] 
					AND [Expense].[ID] = [DocumentContact].[DocumentID]
			INNER JOIN [Project]
				ON [Expense].[ProjectID] = [Project].[ID]
		WHERE
			(
				@Task IS NULL OR
				[Expense].[TaskID] = @Task
			) AND
			(
				@Flag IS NULL OR
				[Expense].[Flag] = @Flag
			) AND
			(
				(
					@IncludingRecordsOfSubprojects = 1 AND 
					[Expense].[ProjectID] IN (SELECT [ID] FROM @subprojectsTable)
				) OR
				(
					[Expense].[ProjectID] = @ProjectID
				)
			) AND
			[Expense].[Date] >= @PeriodStart AND 
			[Expense].[Date] < @PeriodEnd AND
			[Expense].[ExpenseCodeID] = 1 AND
			(
				[Expense].[State] = 3 OR
				@SentToApprove = 1 AND [Expense].[State] = 2
			) AND
			[Expense].[Billable] = 1 AND
			NOT EXISTS(
				SELECT * FROM [Attachment] 
				WHERE 
					[DocumentClass] = [Expense].[Class] AND 
					[DocumentID] = [Expense].[ID] AND 
					[AttachmentTypeID] = 3 AND
					[Attachment].[LinkDocumentClass] IN (@CalculationClass, @StatementClass, @InvoiceClass, @FactureClass)
			) AND
			(@Employee IS NULL OR [Employee].[ID] = @Employee) AND
			(
				@Category IS NULL OR 
				EXISTS (
					SELECT * 
					FROM
						[DocumentCategory]
						INNER JOIN [Category]
							ON ([DocumentCategory].[DocumentClass] = [Category].[DocumentClass] AND 
								[DocumentCategory].[CategoryID] = [Category].[ID])
					WHERE
						[DocumentCategory].[DocumentClass] = [Expense].[Class] AND 
						[DocumentCategory].[DocumentID] = [Expense].[ID] AND
						[Category].[FileAs] LIKE @Category
					)
			) AND
			(
				@JobID IS NULL OR
				[Expense].[DocumentID] = @JobID AND [Expense].[DocumentClass] = @JobClass			
			) AND
			(
				@Contact IS NULL OR 
				([DocumentContact].[BusinessCardID] = @Contact AND [DocumentContact].[BusinessCardClass] = @ContactClass)
			)
	END
	ELSE IF @DocumentClass = dbo.adfGetClassByName('Pjm5.ServiceRequest')
		SELECT
			DISTINCT
			CAST(1 AS bit) AS [Selected],
			[Project].[Number] AS [ProjectCode],
			[ServiceRequest].[State],
			[ServiceRequest].[Class],
			[ServiceRequest].[ID],
			[ServiceRequest].[Date],
			[Employee].[ID] AS [EmployeeID],
			[Employee].[FileAs] AS [Employee],
			[ServiceRequest].[FileAs],
			1 AS [Amount],
			[ServiceRequest].[Total] 
			AS [Price],
			CASE @VATRate 
				WHEN 0 THEN [ServiceRequest].[Total]
				ELSE [ServiceRequest].[TotalWithVAT] 
			END AS [PriceWithVAT],
			[ServiceRequest].[Total] 
			AS [Sum],
			0 AS [VATIsIncluded],
			CASE @VATRate 
				WHEN 0 THEN 0
				ELSE [ServiceRequest].[VAT]
			END AS [VAT],
			[ServiceRequest].[Total] AS [SumWithoutVAT],
			CASE @VATRate
				WHEN 0 THEN [ServiceRequest].[Total]
				ELSE [ServiceRequest].[TotalWithVAT]
			END AS [SumWithVAT],
			[ServiceRequest].[Comments],
			ISNULL([ServiceRequest].[Description], [ServiceRequest].[FileAs]) AS [Description],
			@PCurrencyCode AS [CurrencyCode]
		FROM
			[ServiceRequest]
			INNER JOIN [Employee]
				ON [Employee].[ID] = [ServiceRequest].[EmployeeID]
			LEFT OUTER JOIN [DocumentContact]
				ON [ServiceRequest].[class] = [DocumentContact].[DocumentClass] 
					AND [ServiceRequest].[ID] = [DocumentContact].[DocumentID]
			INNER JOIN [Project]
				ON [ServiceRequest].[ProjectID] = [Project].[ID]
		WHERE
			(
				@Flag IS NULL OR
				[ServiceRequest].[Flag] = @Flag
			) AND
			(
				(
					@IncludingRecordsOfSubprojects = 1 AND 
					[ServiceRequest].[ProjectID] IN (SELECT [ID] FROM @subprojectsTable)
				) OR
				(
					[ServiceRequest].[ProjectID] = @ProjectID
				)
			) AND
			[ServiceRequest].[Date] >= @PeriodStart AND 
			[ServiceRequest].[Date] < @PeriodEnd AND
			(
				[ServiceRequest].[State] = 4 OR
				@SentToApprove = 1 AND [ServiceRequest].[State] = 3
			) AND
			[ServiceRequest].[Billable] = 1 AND
			NOT EXISTS(
				SELECT * FROM [Attachment] 
				WHERE [DocumentClass] = [ServiceRequest].[Class] AND 
					[DocumentID] = [ServiceRequest].[ID] AND 
					[AttachmentTypeID] = 3 AND
					[Attachment].[LinkDocumentClass] IN (@CalculationClass, @StatementClass, @InvoiceClass, @FactureClass)
			) AND
			(@Employee IS NULL OR [Employee].[ID] = @Employee) AND
			(
				@Category IS NULL OR 
				EXISTS (
					SELECT * 
					FROM
						[DocumentCategory]
						INNER JOIN [Category]
							ON ([DocumentCategory].[DocumentClass] = [Category].[DocumentClass] AND 
								[DocumentCategory].[CategoryID] = [Category].[ID])
					WHERE
						[DocumentCategory].[DocumentClass] = [ServiceRequest].[Class] AND 
						[DocumentCategory].[DocumentID] = [ServiceRequest].[ID] AND
						[Category].[FileAs] LIKE @Category
					)
			) AND
			(
				@Contact IS NULL OR 
				([DocumentContact].[BusinessCardID] = @Contact AND [DocumentContact].[BusinessCardClass] = @ContactClass)
			)
	RETURN 0
GO

GRANT EXECUTE ON [pjm5CalculationLinesSelect] TO PUBLIC
GO