IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[pjm5CreditMemoChangeState]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	BEGIN
		PRINT 'Dropping procedure pjm5CreditMemoChangeState'
		DROP PROCEDURE [dbo].[pjm5CreditMemoChangeState]
	END
GO

PRINT 'Creating procedure pjm5CreditMemoChangeState'
GO

/******************************************************************************
**		File: pjm5CreditMemoChangeState.sql
**		Name: pjm5CreditMemoChangeState
**		Desc: this procedure automatically generated by Avicom.Adf.Generator
**
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**      ----------						-----------
**
**		Auth: vladislav.dremin
**		Date: 08/30/2005 12:32:19
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		--------	--------		-------------------------------------------
**    
*******************************************************************************/
CREATE PROCEDURE pjm5CreditMemoChangeState
	@ID TIdentifier,
	@ToState TState
AS
	DECLARE @FromState TState,
			@TransitionTemplateID TIdentifier,
			@RightID TIdentifier,
			@Class TClass,
			@value TVariant,
			@CurrencyCode TCode3,
			@ProjectCurrencyCode TCode3,
			@BaseCurrencyRate TMoney,
			@CurrencyRate TMoney,
			@BaseCurrencyCode TCode3
	
	SET NOCOUNT ON
	
	EXEC adfParameterGet @Name='BaseCurrency', @Group='CommonBusiness', @Value = @value OUTPUT
	SET @BaseCurrencyCode = CAST(@value as varchar(3))
	
	SELECT
		@Class = [CreditMemo].[Class],
		@FromState = [CreditMemo].[State],
		@CurrencyCode = [CreditMemo].[CurrencyCode],
		@BaseCurrencyRate = [CreditMemo].[BaseCurrencyRate],
		@CurrencyRate = [CreditMemo].[CurrencyRate],
		@ProjectCurrencyCode = [Project].[CurrencyCode]
	FROM
		[CreditMemo]
		LEFT JOIN [Project]
			ON [Project].[ID] = [CreditMemo].[ProjectID]
	WHERE
		[CreditMemo].[ID] = @ID
		
	IF @FromState = @ToState
	BEGIN
		RAISERROR('#invalidargument', 18, -1)
		RETURN 1
	END
	
	IF @ToState = 2 -- 
	BEGIN
		IF (@ProjectCurrencyCode IS NOT NULL AND
			@ProjectCurrencyCode != @CurrencyCode AND
			(@CurrencyRate IS NULL OR @CurrencyRate <= 0))
		BEGIN
			RAISERROR('#CurrencyRateCannotBeNull', 18, -1)
			RETURN 1
		END
		IF (@BaseCurrencyCode != @CurrencyCode AND
			(@BaseCurrencyRate IS NULL OR @BaseCurrencyRate <= 0))
		BEGIN
			RAISERROR('#BaseCurrencyRateCannotBeNull', 18, -1)
			RETURN 1
		END
	END
	
	SELECT
		@TransitionTemplateID = [ID],
		@RightID = [RightID]
	FROM
		[TransitionTemplate]
	WHERE
		[TransitionTemplate].[FromState] = @FromState AND [TransitionTemplate].[ToState] = @ToState
	AND
		[TransitionTemplate].[Class] = @Class
		
	IF @TransitionTemplateID IS NULL
	BEGIN
		RAISERROR('#invalidoperation', 18, -1)
		RETURN 1
	END
	
	SET @TransitionTemplateID = dbo.adfCheckTransitionRights(@TransitionTemplateID, @RightID, dbo.adfGetCurrentUserID())
	
	IF @TransitionTemplateID IS NULL
	BEGIN
		RAISERROR('#accessdenied', 18, -1)
		RETURN 1
	END
	
	UPDATE
		[CreditMemo]
	SET
		[CreditMemo].[State] = @ToState,
		[CreditMemo].[Modified] = GETDATE(),
		[CreditMemo].[ModifiedBy] = dbo.adfGetCurrentUserID()
	WHERE
		[CreditMemo].[ID] = @ID
	AND
		[CreditMemo].[State] = @FromState

	IF @@ERROR != 0
		RETURN 1

	RETURN 0
GO

GRANT EXECUTE ON pjm5CreditMemoChangeState TO PUBLIC
GO
 