--pjm5FindDocumentsInFolder
IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[pjm5FindDocumentsInFolder]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	BEGIN
		PRINT 'Dropping procedure pjm5FindDocumentsInFolder'
		DROP PROCEDURE [dbo].[pjm5FindDocumentsInFolder]
	END
GO

PRINT 'Creating procedure pjm5FindDocumentsInFolder'
GO

SET QUOTED_IDENTIFIER ON
GO

/******************************************************************************
**		File: pjm5FindDocumentsInFolder.sql
**		Name: pjm5FindDocumentsInFolder
**		Desc: this procedure automatically generated by Avicom.Adf.Generator
**
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**      ----------						-----------
**
**		Auth: vladislav.dremin
**		Date: 08/30/2005 12:32:19
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		--------	--------		-------------------------------------------
**    
*******************************************************************************/
CREATE PROCEDURE [pjm5FindDocumentsInFolder]
	@FolderID TIdentifier,
	@Criteria XML
AS
	SET NOCOUNT ON
	IF dbo.adfHasAccessRight(dbo.adfGetRightID('AccessToPublicFolders')) = 0
	BEGIN
		RAISERROR('#accessdenied', 18, -1)
		RETURN 1
	END

	DECLARE 
		@UserID TIdentifier,
		@ReadItems TBool,
		@FolderPublication TBool
	SET @UserID = dbo.adfGetCurrentUserID()
	SET @ReadItems = dbo.fnFolderHasRightAccess(@FolderID, @UserID, 'ReadItems') | dbo.fnFolderHasRightAccess(@FolderID, @UserID, 'FolderOwner')
	SET @FolderPublication = dbo.fnFolderHasRightAccess(@FolderID, @UserID, 'FolderPublication')

	DECLARE 
		@Name TName,
		@In int,
		@Class int,
		@Flag TBool,
		@FlagIndex int,
		@UserOption TBool,
		@UserOptionIndex int,
		@TimeType int,
		@TimeInterval int,
		@PeriodStart TDate,
		@PeriodEnd TDate,
		
        @NumberFlag TBool,
        @Number TName,
        @DateFlag TBool,
        @DateFrom TDate,
        @DateTo TDate,
        @CorrespondentFlag TBool,
        @Correspondent TIdentifier,
        @ContactFlag TBool,
        @Contact TIdentifier,
		@TypeFlag TBool,
        @Type TIdentifier,
        @CardState TState,

        @State TState,
        @Version int,
		@SizeType int,
		@SizeFrom int,
		@SizeTo int,
		@_xml xml
	SET @_xml = @Criteria
	SELECT 
		@Name = T.c.value('SearchWord[1]', 'nvarchar(256)'),
		@In = T.c.value('In[1]', 'int'),
		@Class = T.c.value('Class[1]', 'int'),
		@Flag = T.c.value('Flag[1]', 'bit'),
		@FlagIndex = T.c.value('FlagIndex[1]', 'int'),
		@UserOption = T.c.value('UserOption[1]', 'bit'),
		@UserOptionIndex = T.c.value('UserOptionIndex[1]', 'int'),
		@TimeType = T.c.value('TimeType[1]', 'int'),
		@TimeInterval = T.c.value('TimeInterval[1]', 'int'),
		@PeriodStart = CAST(T.c.value('PeriodStart[1]', 'varchar(19)') as datetime),
		@PeriodEnd = CAST(T.c.value('PeriodEnd[1]', 'varchar(19)') as datetime),
		
        @NumberFlag = T.c.value('NumberFlag[1]', 'bit'),
        @Number = T.c.value('Number[1]', 'nvarchar(256)'),
        @DateFlag = T.c.value('DateFlag[1]', 'bit'),
        @DateFrom = CAST(T.c.value('DateStart[1]', 'varchar(10)') as datetime),
        @DateTo = CAST(T.c.value('DateEnd[1]', 'varchar(19)') as datetime),
        @CorrespondentFlag = T.c.value('CorrespondentFlag[1]', 'bit'),
        @Correspondent = T.c.value('Correspondent[1]', 'int'),
        @ContactFlag = T.c.value('ContactFlag[1]', 'bit'),
        @Contact = T.c.value('Contact[1]', 'int'),
		@TypeFlag = T.c.value('TypeFlag[1]', 'bit'),
        @Type = T.c.value('Type[1]', 'int'),
        @CardState = T.c.value('CardState[1]', 'int'),
		
		@State = T.c.value('State[1]', 'int'),
		@Version = T.c.value('Version[1]', 'int'),
		@SizeType = T.c.value('SizeType[1]', 'int'),
		@SizeFrom = T.c.value('SizeFrom[1]', 'int'),
		@SizeTo = T.c.value('SizeTo[1]', 'int')
	FROM
		@_xml.nodes('/SearchCriteriaClass') T(c)

	IF @DateFrom = CAST('19000101' as datetime)
		SET @DateFrom = NULL
	IF @DateTo = CAST('19000101' as datetime)
		SET @DateTo = NULL

	SET @SizeType = ISNULL(@SizeType, 0)
	IF @SizeType = 1
	BEGIN
		SET @SizeType = 2
		SET @SizeTo = 1.1 * ISNULL(1024 * @SizeFrom, 0)
		SET @SizeFrom = 0.9 * ISNULL(1000 * @SizeFrom, 0)
	END
	ELSE
	BEGIN
		SET @SizeFrom = ISNULL(1024 * @SizeFrom, 0)
		SET @SizeTo = ISNULL(1024 * @SizeTo, 0)
	END
	
	-- @In MUST BE ZERO
	SELECT
		[DocumentCard].[Class],
		[DocumentCard].[ID],
		[DocumentCard].[State],
		[DocumentCard].[Flag],
		[DocumentCard].[FileAs] ,
		[DocumentCard].[FolderID],
		[DocumentCard].[Number],
		[DocumentCard].[Date],
		[DocumentCard].[CompanyID],
		[DocumentCard].[ContactID],
		[DocumentCard].[CaseID],
		[DocumentCard].[DocumentSendTypeID],

		[DocumentCard].[DocumentCardClassID],
		[DocumentCard].[DivisionID],
		[DocumentCard].[CustodyPlaceID],
		[DocumentCard].[AppendixCount],
		[DocumentCard].[PageCount],
		[DocumentCard].[Package],
		[DocumentCard].[CardOwnerID],
		[DocumentCard].[Copy],
		[DocumentCard].[StorePeriod],

		[DocumentItem].[ID]		AS [DocumentItemID],
		[DocumentItem].[State]	AS [DocumentItemState],
		[DocumentItem].[Flag]	AS [DocumentItemFlag],
		[DocumentItem].[FileName],
		[DocumentItem].[Extension],
		[DocumentItem].[LatestVersion],
		[DocumentItem].[CheckedOutBy],
		[DocumentVersion].[DataLength],
		[Folder].[FileAs] AS [FolderFileAs],
		[DocumentCard].[Comments],
		[DocumentCard].[Created],
		[DocumentCard].[CreatedBy],
		[DocumentCard].[Modified],
		[DocumentCard].[ModifiedBy],
		[DocumentCard].[Timestamp],
		CAST('6cc877ce-4425-4e49-a3d5-76b01ae709ae' as uniqueidentifier) AS [Guid]
	FROM 
		[DocumentCard]
		INNER JOIN [Folder]
			ON [DocumentCard].[FolderID] = [Folder].[ID]
		INNER JOIN [Case]
			ON [DocumentCard].[CaseID] = [Case].[ID]
		LEFT OUTER JOIN [DocumentItem]
			ON [DocumentItem].[DocumentCardID] = [DocumentCard].[ID]
		LEFT OUTER JOIN [DocumentVersion]
			ON ([DocumentVersion].[DocumentItemID] = [DocumentItem].[ID] AND
				[DocumentVersion].[Version] = [DocumentItem].[LatestVersion])
	WHERE
		[DocumentCard].[FolderID] = @FolderID AND
		(
			@Class = 0 OR
			@Class = 1 AND [Case].[AllowInternal] = 1 OR
			@Class = 2 AND [Case].[AllowIncoming] = 1 OR
			@Class = 3 AND [Case].[AllowOutgoing] = 1
		) AND
		(
			@ReadItems != 0 OR
			[DocumentCard].[CreatedBy] = @UserID
		) AND
		(
			@CardState = 0 OR [DocumentCard].[State] = @CardState
		) AND
		(
			@Flag = 0 OR [DocumentCard].[Flag] = @FlagIndex
		) AND
		(
			@UserOption = 0 OR
			(
				@UserOptionIndex = 0 AND @UserID IN ([DocumentCard].[CreatedBy], [DocumentCard].[ModifiedBy]) 
				OR
				@UserOptionIndex = 1 AND [DocumentCard].[CreatedBy] = @UserID
				OR
				@UserOptionIndex = 2 AND [DocumentCard].[ModifiedBy] = @UserID
			)
		) AND
		(
			@TimeType = 0 OR
			@TimeType = 1 AND [DocumentCard].[Created] BETWEEN @PeriodStart AND @PeriodEnd OR
			@TimeType = 2 AND [DocumentCard].[Modified] BETWEEN @PeriodStart AND @PeriodEnd
		) AND
		(
			@Name IS NULL OR
			(
			[DocumentItem].[FileName] LIKE '%'+@Name+'%' OR
			[DocumentCard].[FileAs] LIKE '%'+@Name+'%' OR
			[DocumentCard].[Comments] LIKE '%'+@Name+'%'
			)
		) AND
		(
			@NumberFlag = 0 OR
			@Number = '' AND [DocumentCard].[Number] IS NULL OR
			@Number != '' AND [DocumentCard].[Number] LIKE '%'+@Number+'%'
		) AND
		(
			@DateFlag = 0 OR
			[DocumentCard].[Date] BETWEEN ISNULL(@DateFrom, [DocumentCard].[Date]) AND ISNULL(@DateTo, [DocumentCard].[Date])
		) AND
		(
			@CorrespondentFlag = 0 OR
			[DocumentCard].[CorrespondentCompanyID] = @Correspondent
		) AND
		(
			@ContactFlag = 0 OR
			[DocumentCard].[CorrespondentContactID] = @Contact
		) AND
		(
			@TypeFlag = 0 OR
			[DocumentCard].[DocumentCardClassID] = @Type
		) AND
		(
			@State = 0 OR [DocumentItem].[State] = @State
		) AND
		(
			@SizeType = 0 OR
			@SizeType = 2 AND ISNULL([DocumentVersion].[DataLength], 0) BETWEEN @SizeFrom AND @SizeTo OR
			@SizeType = 3 AND ISNULL([DocumentVersion].[DataLength], 0) < @SizeFrom OR
			@SizeType = 4 AND ISNULL([DocumentVersion].[DataLength], 0) > @SizeFrom
		)
	IF @Class = 0 AND
		@CardState = 0 AND
		@NumberFlag = 0 AND
		@DateFlag = 0 AND
		@CorrespondentFlag = 0 AND
		@ContactFlag = 0 AND 
		@TypeFlag = 0
			
		SELECT 
			[DocumentItem].[Class],
			[DocumentItem].[ID],
			[DocumentItem].[State],
			[DocumentCard].[Flag],
			[DocumentCard].[FileAs] ,
			[DocumentCard].[FolderID],
			[DocumentCard].[Number],
			[DocumentCard].[Date],
			[DocumentCard].[CompanyID],
			[DocumentCard].[ContactID],
			[DocumentCard].[CaseID],
			[DocumentCard].[DocumentSendTypeID],

			[DocumentCard].[DocumentCardClassID],
			[DocumentItem].[DocumentCardID],
			[DocumentCard].[DivisionID],
			[DocumentCard].[CustodyPlaceID],
			[DocumentCard].[AppendixCount],
			[DocumentCard].[PageCount],
			[DocumentCard].[Package],
			[DocumentCard].[CardOwnerID],
			[DocumentCard].[Copy],
			[DocumentCard].[StorePeriod],

			[DocumentItem].[ID]		AS [DocumentItemID],
			[DocumentItem].[State]	AS [DocumentItemState],
			[DocumentItem].[Flag]	AS [DocumentItemFlag],
			[DocumentItem].[FileName],
			[DocumentItem].[Extension],
			[DocumentItem].[LatestVersion],
			[DocumentItem].[CheckedOutBy],
			[DocumentVersion].[DataLength],
			[Folder].[FileAs] AS [FolderFileAs],
			[DocumentCard].[Comments],
			[DocumentCard].[Created],
			[DocumentCard].[CreatedBy],
			[DocumentCard].[Modified],
			[DocumentCard].[ModifiedBy],
			[DocumentCard].[Timestamp],
			CAST('acb865ab-ae3c-429e-af10-d14d6a46363b' as uniqueidentifier) AS [Guid]
		FROM 
			[DocumentItem]
			INNER JOIN [DocumentCard]
				ON [DocumentItem].[DocumentCardID] = [DocumentCard].[ID]
			INNER JOIN [Folder]
				ON [DocumentCard].[FolderID] = [Folder].[ID]
			LEFT OUTER JOIN [DocumentVersion]
				ON ([DocumentVersion].[DocumentItemID] = [DocumentItem].[ID] AND
					[DocumentVersion].[Version] = [DocumentItem].[LatestVersion])
		WHERE
			@Class = 0 AND
			@CorrespondentFlag = 0 AND
			[DocumentCard].[FolderID] = @FolderID AND
			[DocumentCard].[CaseID] IS NULL AND
			(
				@ReadItems != 0 OR
				[DocumentCard].[CreatedBy] = @UserID
			) AND
			(
				@Flag = 0 OR [DocumentItem].[Flag] = @FlagIndex
			) AND
			(
				@UserOption = 0 OR
				(
					@UserOptionIndex = 0 AND @UserID IN ([DocumentCard].[CreatedBy], [DocumentCard].[ModifiedBy]) 
					OR
					@UserOptionIndex = 1 AND [DocumentCard].[CreatedBy] = @UserID
					OR
					@UserOptionIndex = 2 AND [DocumentCard].[ModifiedBy] = @UserID
				)
			) AND
			(
				@TimeType = 0 OR
				@TimeType = 1 AND [DocumentCard].[Created] BETWEEN @PeriodStart AND @PeriodEnd OR
				@TimeType = 2 AND [DocumentCard].[Modified] BETWEEN @PeriodStart AND @PeriodEnd
			) AND
			(
				@Name IS NULL OR
				(
				[DocumentItem].[FileName] LIKE '%'+@Name+'%' OR
				[DocumentCard].[FileAs] LIKE '%'+@Name+'%' OR
				[DocumentCard].[Comments] LIKE '%'+@Name+'%'
				)
			) AND
			(
				@State = 0 OR [DocumentItem].[State] = @State
			) AND
			(
				@SizeType = 0 OR
				@SizeType = 2 AND ISNULL([DocumentVersion].[DataLength], 0) BETWEEN @SizeFrom AND @SizeTo OR
				@SizeType = 3 AND ISNULL([DocumentVersion].[DataLength], 0) < @SizeFrom OR
				@SizeType = 4 AND ISNULL([DocumentVersion].[DataLength], 0) > @SizeFrom
			) AND
			(
				@FolderPublication = 1 OR
				[DocumentItem].[State] > 1 OR
				[DocumentItem].[CreatedBy] = @UserID OR
				[DocumentItem].[LatestVersion] > 1
			)

	RETURN 0
GO

GRANT EXECUTE ON [pjm5FindDocumentsInFolder] TO PUBLIC
GO
