 IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[fnDocumentItemExtensionValidate]') AND xtype IN (N'FN', N'IF', N'TF'))
	BEGIN
		PRINT 'Dropping function fnDocumentItemExtensionValidate'
		DROP FUNCTION [dbo].[fnDocumentItemExtensionValidate]
	END

GO

SET QUOTED_IDENTIFIER ON
GO

PRINT 'Creating function fnDocumentItemExtensionValidate'
GO
/******************************************************************************
**		File: 
**		Name: fnDocumentItemExtensionValidate
**		Desc: 
**
**		This template can be customized:
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**      ----------						-----------
**
**		Auth: 
**		Date: 
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		--------	--------		-------------------------------------------
**    
*******************************************************************************/
CREATE FUNCTION fnDocumentItemExtensionValidate(
	@FolderID TIdentifier,
	@FileName TName
)
RETURNS BIT
AS
BEGIN
	DECLARE 
		@parameters xml,
		@flag int
		
	SELECT
		@parameters = [Parameters]
	FROM
		[Folder]
	WHERE
		[ID] = @FolderID
	IF @parameters IS NULL
		RETURN 1
	SELECT
		@flag  = T.c.value('Flag[1]', 'int')
	FROM
		@parameters.nodes('/Parameters') T(c)
	IF ISNULL(@flag, 0) = 0
		RETURN 1
	
	IF @flag = 1
	BEGIN
		IF EXISTS(
			SELECT *
			FROM
				@parameters.nodes('/Parameters/Extension') T(c)
			WHERE
				RIGHT(@FileName,1 + LEN(T.c.value('.[1]', 'nvarchar(256)'))) = '.' + T.c.value('.[1]', 'nvarchar(256)')
		)
		RETURN 1
	END

	IF @flag = 2
	BEGIN
		IF NOT EXISTS(
			SELECT *
			FROM
				@parameters.nodes('/Parameters/Extension') T(c)
			WHERE
				RIGHT(@FileName,1 + LEN(T.c.value('.[1]', 'nvarchar(256)'))) = '.' + T.c.value('.[1]', 'nvarchar(256)')
		)
		RETURN 1
	END
	
	RETURN 0
END
GO

GRANT EXEC ON fnDocumentItemExtensionValidate TO PUBLIC
GO
