﻿IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[pjm7ExchangeSyncGetAttributesForSync]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	BEGIN
		PRINT 'Dropping procedure pjm7ExchangeSyncGetAttributesForSync'
		DROP PROCEDURE [dbo].[pjm7ExchangeSyncGetAttributesForSync]
	END
GO

PRINT 'Creating procedure pjm7ExchangeSyncGetAttributesForSync'
GO

/******************************************************************************
**		File: ExchangeSyncGetAttributesForSync.sql
**		Name: pjm7ExchangeSyncGetAttributesForSync
**		Desc: Процедура возвращает список атрибутов, для которых 
**				устанавливается синхронизация с Exchange для пользователя
**
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**      ----------						-----------
**
**		Auth: Anton.Paramonov
**		Date: 21.02.2012 14:38:00
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		--------	--------		-------------------------------------------
**    
*******************************************************************************/
CREATE PROCEDURE pjm7ExchangeSyncGetAttributesForSync
	@ClassName	TName,
	@UserID		TIdentifier = NULL
AS
	SET NOCOUNT ON
	
	DECLARE
		@Class TClass	
	SET @Class = dbo.adfGetClassByName(@ClassName)	

	IF @UserID IS NULL	
		SET @UserID = dbo.adfGetCurrentUserID()
	
	IF @ClassName = 'Adf.ActivityType'
		SELECT
			[ExchangeAttributesForSync].[DocumentID] AS [ID],
			[ActivityType].[FileAs] AS [Name]
		FROM
			[ExchangeAttributesForSync]
			INNER JOIN [ActivityType] 
				ON [ActivityType].[ID] = [ExchangeAttributesForSync].[DocumentID]
		WHERE
			[ExchangeAttributesForSync].[DocumentClass] = @Class
			AND
			[ExchangeAttributesForSync].[UserID] = @UserID

	RETURN 0
GO

GRANT EXECUTE ON pjm7ExchangeSyncGetAttributesForSync TO PUBLIC
GO

