IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[pjm5ExpenseUpdate]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	BEGIN
		PRINT 'Dropping procedure pjm5ExpenseUpdate'
		DROP PROCEDURE [dbo].[pjm5ExpenseUpdate]
	END
GO

PRINT 'Creating procedure pjm5ExpenseUpdate'
GO

/******************************************************************************
**		File: pjm5ExpenseUpdate.sql
**		Name: pjm5ExpenseUpdate
**		Desc: this procedure automatically generated by Avicom.Adf.Generator
**
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**      ----------						-----------
**
**		Auth: pavel.boruroev
**		Date: 01/20/2005 16:11:01
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		--------	--------		-------------------------------------------
**      30.09.10    BVY                ,     .
*******************************************************************************/
CREATE PROCEDURE pjm5ExpenseUpdate
	@Xml XML
AS
	DECLARE
		@ID TIdentifier,
		@FileAs TName,
		@ProjectID TIdentifier,
		@DocumentClass TClass,
		@DocumentID TIdentifier,
		@TaskID TIdentifier,
		@ExpenseCodeID TIdentifier,
		@Date TDateTime,
		@Amount TAmount,
		@Billable TBool,
		@Price TMoney,
		@FromCurrencyCode TCode3,
		@ToCurrencyCode TCode3,
		@CurrencyRate TMoney,
		@VATRate TPercent,
		@VAT TMoney,
		@VATIsIncluded TBool,
		@Comments TNotes,
		@EmployeeID TIdentifier,
		@rv int,
		@MyEmployeeID int,
		@PhoneCallCodeID TIdentifier,
		@State TState,
		@OldAssignmentID TIdentifier,
		@UOMID TIdentifier
		
	SET NOCOUNT ON

	SELECT
		@ID					= @XML.value('(/pjm5ExpenseGet/Expense/ID)[1]','int'),
		@FileAs				= @XML.value('(/pjm5ExpenseGet/Expense/FileAs)[1]','nvarchar(256)'),
		@ProjectID			= @XML.value('(/pjm5ExpenseGet/Expense/ProjectID)[1]','int'), 
		@DocumentClass		= dbo.adfGetClassByName(@XML.value('(/pjm5ExpenseGet/Expense/DocumentClass)[1]','varchar(32)')),
		@DocumentID			= @XML.value('(/pjm5ExpenseGet/Expense/DocumentID)[1]','int'),
		@TaskID				= @XML.value('(/pjm5ExpenseGet/Expense/TaskID)[1]','int'), 
		@ExpenseCodeID		= @XML.value('(/pjm5ExpenseGet/Expense/ExpenseCodeID)[1]','nvarchar(256)'), 
		@Date				= CAST(@XML.value('(/pjm5ExpenseGet/Expense/Date)[1]','varchar(19)') as datetime), 
		@Amount				= @XML.value('(/pjm5ExpenseGet/Expense/Amount)[1]','decimal(18,4)'), 
		@Billable			= CASE WHEN @XML.value('(/pjm5ExpenseGet/Expense/Billable)[1]','varchar(5)') = 'false' THEN 0 ELSE 1 END, 
		@Price				= @XML.value('(/pjm5ExpenseGet/Expense/Price)[1]','money'), 
		@FromCurrencyCode	= @XML.value('(/pjm5ExpenseGet/Expense/FromCurrencyCode)[1]','char(3)'),
		@ToCurrencyCode		= [Project].[CurrencyCode],
		@CurrencyRate		= @XML.value('(/pjm5ExpenseGet/Expense/CurrencyRate)[1]','nvarchar(256)'),
		@VATRate			= @XML.value('(/pjm5ExpenseGet/Expense/VATRate)[1]','decimal(18,4)'),
		@VATIsIncluded		= CASE WHEN @XML.value('(/pjm5ExpenseGet/Expense/VATIsIncluded)[1]','varchar(5)') = 'false' THEN 0 ELSE 1 END,
		@VAT				= @XML.value('(/pjm5ExpenseGet/Expense/VAT)[1]','money'),
		@Comments			= @XML.value('(/pjm5ExpenseGet/Expense/Comments)[1]','nvarchar(max)'),
		@EmployeeID			= @XML.value('(/pjm5ExpenseGet/Expense/EmployeeID)[1]','nvarchar(256)'),
		@PhoneCallCodeID	= @XML.value('(/pjm5ExpenseGet/Expense/PhoneCallCodeID)[1]','int'),
		@UOMID				= @XML.value('(/pjm5ExpenseGet/Expense/UOMID)[1]','int')
	FROM
		[Project]
	WHERE
		[Project].[ID] = @XML.value('(/pjm5ExpenseGet/Expense/ProjectID)[1]','int')

	IF @ExpenseCodeID = 1 AND @PhoneCallCodeID IS NULL
	BEGIN
		RAISERROR('#PhoneCallCodeIsNotDefined', 18, -1)
		RETURN 1
	END
	
IF @DocumentID IS NULL AND @DocumentClass IS NOT NULL
BEGIN
	SET @DocumentClass = NULL 
END
	
	SELECT 
		@State = [State]
	FROM 
		[Expense] 
	WHERE 
		[ID] = @ID
	

	BEGIN TRANSACTION
	IF @State = 5
	BEGIN
		EXEC @rv = pjm5ExpenseChangeState @ID, 1
		IF @rv != 0
		BEGIN
			ROLLBACK TRANSACTION
			RETURN 1
		END
	END

	EXEC @rv = pjm5ExpenseUpdateInternal
		@ID,
		@FileAs,
		@EmployeeID,
		@ProjectID,
		@DocumentClass,
		@DocumentID,
		@TaskID,
		@ExpenseCodeID,
		@Date,
		@UOMID,
		@Amount,
		@Billable,
		@Price,
		@FromCurrencyCode,
		@ToCurrencyCode,
		@CurrencyRate,
		@VATRate,
		@VATIsIncluded,
		@Vat,
		@Comments

	IF @rv != 0
	BEGIN
		ROLLBACK TRANSACTION
		RETURN 1
	END

	IF @ExpenseCodeID = 1 AND @PhoneCallCodeID IS NOT NULL
	BEGIN
		UPDATE 
			[PhoneCall]
		SET
			[PhoneCallCodeID] = @PhoneCallCodeID
		WHERE
			[ExpenseID] = @ID
		IF @@ERROR != 0
		BEGIN
			ROLLBACK TRANSACTION
			RETURN 1
		END
	END

	COMMIT TRANSACTION

	EXEC pjm5ExpenseGet @ID

	RETURN 0
GO



GRANT EXECUTE ON pjm5ExpenseUpdate TO PUBLIC
GO
 