IF EXISTS (SELECT * FROM sysobjects WHERE type = 'TR' AND name = 'pjm5trExpenseInsert')
	BEGIN
		PRINT 'Dropping Trigger pjm5trExpenseInsert'
		DROP  Trigger pjm5trExpenseInsert
	END
GO

/******************************************************************************
**		File: 
**		Name: pjm5trExpenseInsert
**		Desc: 
**
**		This template can be customized:
**              
**
**		Auth: 
**		Date: 
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:				Description:
**		--------		--------				-------------------------------------------
**    
*******************************************************************************/

PRINT 'Creating Trigger pjm5trExpenseInsert'
GO
CREATE Trigger pjm5trExpenseInsert
ON [Expense] FOR INSERT
AS
BEGIN
    IF @@rowcount = 0
       RETURN
       
    IF EXISTS (
		SELECT *
		FROM [inserted]
		WHERE [inserted].[TaskID] IS NOT NULL AND
			dbo.fnPjm5IsTaskAssigned([inserted].[TaskID], [inserted].[EmployeeID]) = 0
	)
	BEGIN
		RAISERROR('#taskassignmentnotfound', 18, -1)
		ROLLBACK TRANSACTION
		RETURN
	END
	
    IF EXISTS (
		SELECT *
		FROM [inserted]
		WHERE 
			[inserted].[VATIsIncluded] = 1 AND 
			[inserted].[Price] * [inserted].[Amount] < [inserted].[VAT]
	)
	BEGIN
		RAISERROR('#wrongvatvalue', 18, -1)
		ROLLBACK TRANSACTION
		RETURN
	END

END
GO
 