 IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[pjm5ExpenseCodeBrowse]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	BEGIN
		PRINT 'Dropping procedure pjm5ExpenseCodeBrowse'
		DROP PROCEDURE [dbo].[pjm5ExpenseCodeBrowse]
	END
GO

PRINT 'Creating procedure pjm5ExpenseCodeBrowse'
GO

/******************************************************************************
**		File: pjm5ExpenseCodeBrowse.sql
**		Name: pjm5ExpenseCodeBrowse
**		Desc: this procedure automatically generated by Avicom.Adf.Generator
**
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**      ----------						-----------
**
**		Auth: Dmitry.Kolchev
**		Date: 01/19/2005 10:53:44
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		--------	--------		-------------------------------------------
**		26.05.14	BAO				     ID = 1, 
									   
*******************************************************************************/
CREATE PROCEDURE [pjm5ExpenseCodeBrowse]
	@StateSelector INT
AS
	SET NOCOUNT ON

	DECLARE @UsePhoneCalls	sql_variant
	SET @UsePhoneCalls = (SELECT [Value] FROM [F41AB0F8-FDF0-4FAD-9B71-8F17B4A51B53] WHERE [Name] = 'UsePhoneCalls' AND [Group] = 'Pjm5')

	SELECT
		[ExpenseCode].[Class],
		[ExpenseCode].[ID],
		[ExpenseCode].[State],
		[ExpenseCode].[Flag],
		[ExpenseCode].[FileAs],
		[ExpenseCode].[Code],
		[ExpenseCode].[UOMID],
		[ExpenseCode].[ProjectTypeID],
		[ExpenseCode].[AddToNewProject],
		[ExpenseCode].[Billable],
		[ExpenseCode].[Comments],
		[ExpenseCode].[Created],
		[ExpenseCode].[CreatedBy],
		[ExpenseCode].[Modified],
		[ExpenseCode].[ModifiedBy],
		[ExpenseCode].[Timestamp]
	FROM
		[ExpenseCode]
	WHERE
		(
			(@StateSelector = 0) OR (@StateSelector != 0 AND [ExpenseCode].[State] = @StateSelector)
		)
		AND
		(
			((@UsePhoneCalls = 0) AND [ExpenseCode].[ID] != 1)
			OR
			(@UsePhoneCalls = 1)
		)
		
	RETURN 0
GO

GRANT EXECUTE ON [pjm5ExpenseCodeBrowse] TO PUBLIC
GO
IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[pjm5ExpenseCodeGet]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	BEGIN
		PRINT 'Dropping procedure pjm5ExpenseCodeGet'
		DROP PROCEDURE [dbo].[pjm5ExpenseCodeGet]
	END
GO

PRINT 'Creating procedure pjm5ExpenseCodeGet'
GO

/******************************************************************************
**		File: pjm5ExpenseCodeGet.sql
**		Name: pjm5ExpenseCodeGet
**		Desc: this procedure automatically generated by Avicom.Adf.Generator
**
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**      ----------						-----------
**
**		Auth: Dmitry.Kolchev
**		Date: 01/19/2005 10:53:44
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		--------	--------		-------------------------------------------
**    
*******************************************************************************/
CREATE PROCEDURE [pjm5ExpenseCodeGet]
	@ID TIdentifier
AS
	SET NOCOUNT ON
	
	SELECT
		[ExpenseCode].[Class],
		[ExpenseCode].[ID],
		[ExpenseCode].[State],
		[ExpenseCode].[Flag],
		[ExpenseCode].[FileAs],
		[ExpenseCode].[Code],
		[ExpenseCode].[UOMID],
		[ExpenseCode].[ProjectTypeID],
		[ExpenseCode].[AddToNewProject],
		[ExpenseCode].[Billable],
		[ExpenseCode].[VATIsIncluded],
		[ExpenseCode].[VATRate],
		[ExpenseCode].[Comments],
		[ExpenseCode].[Created],
		[ExpenseCode].[CreatedBy],
		[ExpenseCode].[Modified],
		[ExpenseCode].[ModifiedBy],
		[ExpenseCode].[Timestamp]
	FROM
		[ExpenseCode]
	WHERE
		[ExpenseCode].[ID] = @ID

	SELECT
		(CASE WHEN [ExpenseCode].[VATIsIncluded] = 1 THEN [ExpenseCodePrice].[Price]
			ELSE CAST(CAST([ExpenseCodePrice].[Price] * (1 + ISNULL([ExpenseCode].[VATRate], 0)) as decimal(19, 2)) as money)
		END) as [PriceWithVAT],
		[ExpenseCodePrice].[CurrencyCode],
		(CASE WHEN [ExpenseCode].[VATIsIncluded] = 0 THEN [ExpenseCodePrice].[Price] 
			ELSE CAST(CAST([ExpenseCodePrice].[Price] / (1 + ISNULL([ExpenseCode].[VATRate], 0)) as decimal(19, 2)) as money) 
		END) as [PriceWOVAT],
		((CASE WHEN [ExpenseCode].[VATIsIncluded] = 1 THEN [ExpenseCodePrice].[Price]
			ELSE CAST(CAST([ExpenseCodePrice].[Price] * (1 + ISNULL([ExpenseCode].[VATRate], 0)) as decimal(19, 2)) as money)
		END) -
		(CASE WHEN [ExpenseCode].[VATIsIncluded] = 0 THEN [ExpenseCodePrice].[Price] 
			ELSE CAST(CAST([ExpenseCodePrice].[Price] / (1 + ISNULL([ExpenseCode].[VATRate], 0)) as decimal(19, 2)) as money) 
		END)) as [VAT]
	FROM
		[ExpenseCodePrice] INNER JOIN [ExpenseCode]
			ON ([ExpenseCodePrice].[ID] = [ExpenseCode].[ID])
	WHERE
		[ExpenseCodePrice].[ID] = @ID

	SELECT
		[LanguageCode].[Code] AS [LanguageCode],
		[LanguageCode].[FileAs] AS [LanguageName],
		[ExpenseCodeDefaults].[Subject],
		[ExpenseCodeDefaults].[Comments]
	FROM
		[ExpenseCodeDefaults]
		INNER JOIN [LanguageCode]
			ON [LanguageCode].[Code] = [ExpenseCodeDefaults].[LanguageCode]
	WHERE
		[ExpenseCodeDefaults].[ExpenseCodeID] = @ID

	RETURN 0
GO

GRANT EXECUTE ON [pjm5ExpenseCodeGet] TO PUBLIC
GO

IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[pjm5ExpenseCodeCreate]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	BEGIN
		PRINT 'Dropping procedure pjm5ExpenseCodeCreate'
		DROP PROCEDURE [dbo].[pjm5ExpenseCodeCreate]
	END
GO

PRINT 'Creating procedure pjm5ExpenseCodeCreate'
GO

/******************************************************************************
**		File: pjm5ExpenseCodeCreate.sql
**		Name: pjm5ExpenseCodeCreate
**		Desc: this procedure automatically generated by Avicom.Adf.Generator
**
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**      ----------						-----------
**
**		Auth: Dmitry.Kolchev
**		Date: 01/19/2005 10:53:44
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		--------	--------		-------------------------------------------
**		11.03.13	MAB				  OPENXML
*******************************************************************************/
CREATE PROCEDURE [pjm5ExpenseCodeCreate]
	@Xml XML
AS
	DECLARE @State				TState,
			@ID					TIdentifier,
			@FileAs				TName,
			@Code				TCode,
			@UOMID				TIdentifier,
			@ProjectTypeID		TIdentifier,
			@AddToNewProject	TBool,
			@Billable			TBool,
			@VATIsIncluded		TBool,
			@VATRate			TPercent,
			@Comments			TNotes
	
	SET NOCOUNT ON
	
	SET @State = dbo.adfwfGetInitialState('53eae288-1403-4cdb-8f57-f2ab107352d5')
	IF @State IS NULL
	BEGIN
		RAISERROR('#accessdenied', 18, -1)
		RETURN 1
	END

	SELECT
		@FileAs				= @XML.value('(/pjm5ExpenseCodeGet/ExpenseCode/FileAs)[1]','nvarchar(256)'),
		@Code				= @XML.value('(/pjm5ExpenseCodeGet/ExpenseCode/Code)[1]','varchar(32)'),
		@UOMID				= @XML.value('(/pjm5ExpenseCodeGet/ExpenseCode/UOMID)[1]','int'),
		@ProjectTypeID		= @XML.value('(/pjm5ExpenseCodeGet/ExpenseCode/ProjectTypeID)[1]','int'),
		@AddToNewProject	= @XML.value('(/pjm5ExpenseCodeGet/ExpenseCode/AddToNewProject)[1]','bit'),
		@Billable			= @XML.value('(/pjm5ExpenseCodeGet/ExpenseCode/Billable)[1]','bit'),
		@VATIsIncluded		= @XML.value('(/pjm5ExpenseCodeGet/ExpenseCode/VATIsIncluded)[1]','bit'),
		@VATRate			= @XML.value('(/pjm5ExpenseCodeGet/ExpenseCode/VATRate)[1]',' decimal(18,4)'),
		@Comments			= @XML.value('(/pjm5ExpenseCodeGet/ExpenseCode/Comments)[1]','nvarchar(max)')

	BEGIN TRANSACTION

	INSERT INTO [ExpenseCode]
		([Flag], [State], [FileAs], [Code], [UOMID], [ProjectTypeID], [AddToNewProject], [Billable], [VATIsIncluded], [VATRate], [Comments])
	VALUES
		(0, @State, @FileAs, @Code, @UOMID, @ProjectTypeID, @AddToNewProject, @Billable, @VATIsIncluded, @VATRate, @Comments)
	IF @@ERROR != 0
	BEGIN
		ROLLBACK TRANSACTION
		RETURN 1
	END

	SET @ID = SCOPE_IDENTITY()

	INSERT INTO [ExpenseCodePrice]
		([ID], [CurrencyCode], [Price])
	SELECT
		@ID,
		T.c.value('CurrencyCode[1]','varchar(3)'),
		(CASE WHEN @VATIsIncluded = 1 THEN T.c.value('PriceWithVAT[1]','money') ELSE T.c.value('PriceWOVAT[1]','money') END)
	FROM
		@XML.nodes('/pjm5ExpenseCodeGet/ExpenseCodePrice') AS T(c)
	WHERE
		T.c IS NOT NULL

	IF @@ERROR != 0
	BEGIN
		ROLLBACK TRANSACTION
		RETURN 1
	END

	COMMIT TRANSACTION

	EXEC pjm5ExpenseCodeGet @ID

	RETURN 0
GO

GRANT EXECUTE ON pjm5ExpenseCodeCreate TO PUBLIC
GO
IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[pjm5ExpenseCodeUpdate]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	BEGIN
		PRINT 'Dropping procedure pjm5ExpenseCodeUpdate'
		DROP PROCEDURE [dbo].[pjm5ExpenseCodeUpdate]
	END
GO

PRINT 'Creating procedure pjm5ExpenseCodeUpdate'
GO

/******************************************************************************
**		File: pjm5ExpenseCodeUpdate.sql
**		Name: pjm5ExpenseCodeUpdate
**		Desc: this procedure automatically generated by Avicom.Adf.Generator
**
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**      ----------						-----------
**
**		Auth: Dmitry.Kolchev
**		Date: 01/19/2005 10:53:44
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		--------	--------		-------------------------------------------
**		11.03.13	MAB				  OPENXML
*******************************************************************************/
CREATE PROCEDURE pjm5ExpenseCodeUpdate
@Xml XML
AS
	DECLARE @State				TState,
			@ID					TIdentifier,
			@FileAs				TName,
			@Code				TCode,
			@UOMID				TIdentifier,
			@ProjectTypeID		TIdentifier,
			@AddToNewProject	TBool,
			@Billable			TBool,
			@VATIsIncluded		TBool,
			@VATRate			TPercent,
			@Comments			TNotes
	
	SET NOCOUNT ON

	SELECT
		@ID					= @XML.value('(/pjm5ExpenseCodeGet/ExpenseCode/ID)[1]','int'),
		@FileAs				= @XML.value('(/pjm5ExpenseCodeGet/ExpenseCode/FileAs)[1]','nvarchar(256)'),
		@Code				= @XML.value('(/pjm5ExpenseCodeGet/ExpenseCode/Code)[1]','varchar(32)'),
		@UOMID				= @XML.value('(/pjm5ExpenseCodeGet/ExpenseCode/UOMID)[1]','int'),
		@ProjectTypeID		= @XML.value('(/pjm5ExpenseCodeGet/ExpenseCode/ProjectTypeID)[1]','int'),
		@AddToNewProject	= @XML.value('(/pjm5ExpenseCodeGet/ExpenseCode/AddToNewProject)[1]','bit'),
		@Billable			= @XML.value('(/pjm5ExpenseCodeGet/ExpenseCode/Billable)[1]','bit'),
		@VATIsIncluded		= @XML.value('(/pjm5ExpenseCodeGet/ExpenseCode/VATIsIncluded)[1]','bit'),
		@VATRate			= @XML.value('(/pjm5ExpenseCodeGet/ExpenseCode/VATRate)[1]',' decimal(18,4)'),
		@Comments			= @XML.value('(/pjm5ExpenseCodeGet/ExpenseCode/Comments)[1]','nvarchar(max)')

	BEGIN TRANSACTION
		
	UPDATE [ExpenseCode]
	SET
		[ExpenseCode].[FileAs] = @FileAs,
		[ExpenseCode].[Code] = @Code,
		[ExpenseCode].[UOMID] = @UOMID,
		[ExpenseCode].[ProjectTypeID] = @ProjectTypeID,
		[ExpenseCode].[AddToNewProject] = @AddToNewProject,
		[ExpenseCode].[Billable] = @Billable,
		[ExpenseCode].[VATIsIncluded] = @VATIsIncluded,
		[ExpenseCode].[VATRate] = @VATRate,
		[ExpenseCode].[Comments] = @Comments,
		[ExpenseCode].[Modified] = DEFAULT,
		[ExpenseCode].[ModifiedBy] = DEFAULT
	WHERE
		[ExpenseCode].[ID] = @ID
	IF @@ERROR != 0
	BEGIN
		ROLLBACK TRANSACTION
		RETURN 1
	END

	DELETE [ExpenseCodePrice] WHERE [ID] = @ID
	IF @@ERROR != 0
	BEGIN
		ROLLBACK TRANSACTION
		RETURN 1
	END

	INSERT INTO [ExpenseCodePrice]
		([ID], [CurrencyCode], [Price])
	SELECT
		@ID,
		T.c.value('CurrencyCode[1]','varchar(3)'),
		(CASE WHEN @VATIsIncluded = 1 THEN T.c.value('PriceWithVAT[1]','money') ELSE T.c.value('PriceWOVAT[1]','money') END)
	FROM
		@XML.nodes('/pjm5ExpenseCodeGet/ExpenseCodePrice') AS T(c)
	WHERE
		T.c IS NOT NULL

	IF @@ERROR != 0
	BEGIN
		ROLLBACK TRANSACTION
		RETURN 1
	END

	COMMIT TRANSACTION

	EXEC pjm5ExpenseCodeGet @ID

	RETURN 0
GO

GRANT EXECUTE ON pjm5ExpenseCodeUpdate TO PUBLIC
GO
IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[pjm5ExpenseCodeDelete]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	BEGIN
		PRINT 'Dropping procedure pjm5ExpenseCodeDelete'
		DROP PROCEDURE [dbo].[pjm5ExpenseCodeDelete]
	END
GO

PRINT 'Creating procedure pjm5ExpenseCodeDelete'
GO

/******************************************************************************
**		File: pjm5ExpenseCodeDelete.sql
**		Name: pjm5ExpenseCodeDelete
**		Desc: this procedure automatically generated by Avicom.Adf.Generator
**
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**      ----------						-----------
**
**		Auth: Dmitry.Kolchev
**		Date: 01/19/2005 10:53:44
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		--------	--------		-------------------------------------------
**    
*******************************************************************************/
CREATE PROCEDURE pjm5ExpenseCodeDelete
	@ID TIdentifier
AS
	SET NOCOUNT ON
	
	BEGIN TRANSACTION
	DELETE [ExpenseCodeDefaults] WHERE [ExpenseCodeID] = @ID
	IF @@ERROR != 0
	BEGIN
		ROLLBACK TRANSACTION
		RETURN 1
	END

	DELETE [ExpenseCodePrice] WHERE [ID] = @ID
	IF @@ERROR != 0
	BEGIN
		ROLLBACK TRANSACTION
		RETURN 1
	END

	DELETE FROM [ExpenseCode] WHERE [ExpenseCode].[ID] = @ID
	IF @@ERROR != 0
	BEGIN
		ROLLBACK TRANSACTION
		RETURN 1
	END
	COMMIT TRANSACTION
	RETURN 0
GO

GRANT EXECUTE ON pjm5ExpenseCodeDelete TO PUBLIC
GO
IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[pjm5ExpenseCodeChangeState]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	BEGIN
		PRINT 'Dropping procedure pjm5ExpenseCodeChangeState'
		DROP PROCEDURE [dbo].[pjm5ExpenseCodeChangeState]
	END
GO

PRINT 'Creating procedure pjm5ExpenseCodeChangeState'
GO

/******************************************************************************
**		File: pjm5ExpenseCodeChangeState.sql
**		Name: pjm5ExpenseCodeChangeState
**		Desc: this procedure automatically generated by Avicom.Adf.Generator
**
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**      ----------						-----------
**
**		Auth: Dmitry.Kolchev
**		Date: 01/19/2005 10:53:44
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		--------	--------		-------------------------------------------
**    
*******************************************************************************/
CREATE PROCEDURE pjm5ExpenseCodeChangeState
	@ID TIdentifier,
	@ToState TState
AS
	DECLARE @FromState TState,
			@TransitionTemplateID TIdentifier,
			@RightID TIdentifier,
			@Class TClass
	
	SET NOCOUNT ON
	
	SELECT
		@Class = [ExpenseCode].[Class],
		@FromState = [ExpenseCode].[State]
	FROM
		[ExpenseCode]
	WHERE
		[ExpenseCode].[ID] = @ID
		
	IF @FromState = @ToState
	BEGIN
		RAISERROR('#invalidargument', 18, -1)
		RETURN 1
	END
	
	SELECT
		@TransitionTemplateID = [ID],
		@RightID = [RightID]
	FROM
		[TransitionTemplate]
	WHERE
		[TransitionTemplate].[FromState] = @FromState AND [TransitionTemplate].[ToState] = @ToState
	AND
		[TransitionTemplate].[Class] = @Class
		
	IF @TransitionTemplateID IS NULL
	BEGIN
		RAISERROR('#invalidoperation', 18, -1)
		RETURN 1
	END
	
	SET @TransitionTemplateID = dbo.adfCheckTransitionRights(@TransitionTemplateID, @RightID, dbo.adfGetCurrentUserID())
	
	IF @TransitionTemplateID IS NULL
	BEGIN
		RAISERROR('#accessdenied', 18, -1)
		RETURN 1
	END
	
	UPDATE [ExpenseCode]
	SET
		[ExpenseCode].[State] = @ToState,
		[ExpenseCode].[Modified] = DEFAULT,
		[ExpenseCode].[ModifiedBy] = DEFAULT
	WHERE
		[ExpenseCode].[ID] = @ID
	AND
		[ExpenseCode].[State] = @FromState

	IF @@ERROR != 0
		RETURN 1

	RETURN 0
GO

GRANT EXECUTE ON pjm5ExpenseCodeChangeState TO PUBLIC
GO

-------------------------------------------------------

IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[pjm6ExpenseCodeDefaultsCreate]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	BEGIN
		PRINT 'Dropping procedure pjm6ExpenseCodeDefaultsCreate'
		DROP PROCEDURE [dbo].[pjm6ExpenseCodeDefaultsCreate]
	END
GO

PRINT 'Creating procedure pjm6ExpenseCodeDefaultsCreate'
GO

/******************************************************************************
**		File: pjm6ExpenseCodeDefaultsCreate.sql
**		Name: pjm6ExpenseCodeDefaultsCreate
**		Desc: this procedure automatically generated by Avicom.Adf.Generator
**
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**      ----------						-----------
**
**		Auth: MAV
**		Date: 10/16/2004 15:00:25
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		--------	--------		-------------------------------------------
**    
*******************************************************************************/
CREATE PROCEDURE pjm6ExpenseCodeDefaultsCreate
	@ID TIdentifier,
	@LanguageCode TCode,
	@Subject TName,
	@Comments TNotes
AS
	
	SET NOCOUNT ON
	INSERT INTO [ExpenseCodeDefaults] ([ExpenseCodeID], [LanguageCode], [Subject], [Comments])
	VALUES (@ID, @LanguageCode, @Subject, @Comments)
	IF @@ERROR != 0
	BEGIN
		RETURN 1
	END
	RETURN 0
GO

GRANT EXECUTE ON pjm6ExpenseCodeDefaultsCreate TO PUBLIC
GO

IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[pjm6ExpenseCodeDefaultsUpdate]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	BEGIN
		PRINT 'Dropping procedure pjm6ExpenseCodeDefaultsUpdate'
		DROP PROCEDURE [dbo].[pjm6ExpenseCodeDefaultsUpdate]
	END
GO

PRINT 'Creating procedure pjm6ExpenseCodeDefaultsUpdate'
GO

/******************************************************************************
**		File: pjm6ExpenseCodeDefaultsUpdate.sql
**		Name: pjm6ExpenseCodeDefaultsUpdate
**		Desc: this procedure automatically generated by Avicom.Adf.Generator
**
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**      ----------						-----------
**
**		Auth: MAV
**		Date: 10/16/2004 15:00:25
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		--------	--------		-------------------------------------------
**    
*******************************************************************************/
CREATE PROCEDURE pjm6ExpenseCodeDefaultsUpdate
	@ID TIdentifier,
	@LanguageCode TCode,
	@Subject TName,
	@Comments TNotes
AS
	
	SET NOCOUNT ON
	
	UPDATE 
		[ExpenseCodeDefaults]
	SET
		[ExpenseCodeDefaults].[Subject] = @Subject,
		[ExpenseCodeDefaults].[Comments] = @Comments
	WHERE
		[ExpenseCodeDefaults].[ExpenseCodeID] = @ID AND
		[ExpenseCodeDefaults].[LanguageCode] = @LanguageCode
	IF @@ERROR != 0
	BEGIN
		RETURN 1
	END
	RETURN 0
GO

GRANT EXECUTE ON pjm6ExpenseCodeDefaultsUpdate TO PUBLIC
GO
 
IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[pjm6ExpenseCodeDefaultsDelete]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	BEGIN
		PRINT 'Dropping procedure pjm6ExpenseCodeDefaultsDelete'
		DROP PROCEDURE [dbo].[pjm6ExpenseCodeDefaultsDelete]
	END
GO

PRINT 'Creating procedure pjm6ExpenseCodeDefaultsDelete'
GO

/******************************************************************************
**		File: pjm6ExpenseCodeDefaultsDelete.sql
**		Name: pjm6ExpenseCodeDefaultsDelete
**		Desc: this procedure automatically generated by Avicom.Adf.Generator
**
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**      ----------						-----------
**
**		Auth: MAV
**		Date: 10/16/2004 15:00:25
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		--------	--------		-------------------------------------------
**    
*******************************************************************************/
CREATE PROCEDURE pjm6ExpenseCodeDefaultsDelete
	@ID TIdentifier,
	@LanguageCode TCode
AS
	
	SET NOCOUNT ON
	
	DELETE FROM
		[ExpenseCodeDefaults]
	WHERE
		[ExpenseCodeID] = @ID AND
		[LanguageCode] = @LanguageCode
	IF @@ERROR != 0
	BEGIN
		RETURN 1
	END

	RETURN 0
GO

GRANT EXECUTE ON pjm6ExpenseCodeDefaultsDelete TO PUBLIC
GO
