 IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[pjm5ProjectFind]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	BEGIN
		PRINT 'Dropping procedure pjm5ProjectFind'
		DROP PROCEDURE [dbo].[pjm5ProjectFind]
	END
GO

PRINT 'Creating procedure pjm5ProjectFind'
GO

/******************************************************************************
**		File: pjm5ProjectFind.sql
**		Name: pjm5ProjectFind
**		Desc: this procedure automatically generated by Avicom.Adf.Generator
**
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**      ----------						-----------
**
**		Auth: Dmitry.Kolchev
**		Date: 01/19/2005 10:53:44
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		--------	--------		-------------------------------------------
**		08.08.12	SOV				     [Project].[FileAs]
*******************************************************************************/
CREATE PROCEDURE [pjm5ProjectFind]
	@Text nvarchar(256), -- NULL -  , 
	@TextField int, -- 0 - FileAs, -- 1 - FileAs, Comments
	@State int, -- NULL - 
	@Flag tinyint, -- NULL -  , 0-7 
	@UserOption int,
	@TimeField int, -- 0 - , 1 - Created, 2 - Modified
	@StartTime datetime,
	@EndTime datetime
AS
	
	SET NOCOUNT ON
	
	DECLARE @UserID TIdentifier, @EmployeeID TIdentifier
	SET @UserID = dbo.adfGetCurrentUserID()
	SET @EmployeeID = dbo.adfGetCurrentEmployeeID()
	
	SELECT
		[Project].[Class],
		[Project].[ID],
		[Project].[State],
		[Project].[Date],
		[Project].[Number],
		[Project].[FileAs],
		[Project].[Comments],
		[Project].[Flag],
		[Project].[Created],
		[Project].[CreatedBy],
		[Project].[Modified],
		[Project].[ModifiedBy]
	FROM
		[Project] INNER JOIN dbo.fnPjm5GetAvailableProjects() as [Available]
			ON ([Project].[ID] = [Available].[ID])
	WHERE
		(
			@Text IS NULL
			OR
			(@TextField = 0 AND [Project].[FileAs] LIKE '%' + @Text + '%')
			OR
			(@TextField = 1 AND ([Project].[FileAs] LIKE '%' + @Text + '%' OR [Project].[Comments] LIKE '%' + @Text + '%'))
			OR
			(@TextField = 2 AND ([Project].[Number] LIKE '%' + @Text + '%' OR [Project].[FileAs] LIKE '%' + @Text + '%' OR [Project].[Comments] LIKE '%' + @Text + '%'))
		)
		AND
		(
			@State IS NULL
			OR
			(@State IS NOT NULL AND [Project].[State] = @State)
		)		
		AND
		(
			@Flag IS NULL
			OR
			(@Flag IS NOT NULL AND [Project].[Flag] = @Flag)
		)
		AND
		(
			@UserOption IS NULL
			OR
			(@UserOption = 0 AND EXISTS(SELECT * FROM [vwAssignment] WHERE [ProjectID] = [Project].[ID] AND [EmployeeID] = @EmployeeID AND [State] = 1))
			OR
			(@UserOption = 1 AND ([CreatedBy] = @UserID OR [ModifiedBy] = @UserID))
			OR
			(@UserOption = 2 AND [CreatedBy] = @UserID)
			OR
			(@UserOption = 3 AND [ModifiedBy] = @UserID)
		)
		AND
		(
			@TimeField = 0
			OR
			(@TimeField = 1 AND [Project].[Created] BETWEEN @StartTime AND @EndTime)
			OR
			(@TimeField = 2 AND [Project].[Modified] BETWEEN @StartTime AND @EndTime)
		)
	ORDER BY
		[Project].[FileAs]
	RETURN 0
GO

GRANT EXECUTE ON [pjm5ProjectFind] TO PUBLIC
GO 