  IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[pjm5TaskRequestFind]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	BEGIN
		PRINT 'Dropping procedure pjm5TaskRequestFind'
		DROP PROCEDURE [dbo].[pjm5TaskRequestFind]
	END
GO

PRINT 'Creating procedure pjm5TaskRequestFind'
GO

/******************************************************************************
**		File: pjm5TaskRequestFind.sql
**		Name: pjm5TaskRequestFind
**		Desc: this procedure automatically generated by Avicom.Adf.Generator
**
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**      ----------						-----------
**
**		Auth: Dmitry.Kolchev
**		Date: 01/19/2005 10:53:44
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		--------	--------		-------------------------------------------
**		07.08.12	SOV				     [TaskRequest].[FileAs]
*******************************************************************************/
CREATE PROCEDURE [pjm5TaskRequestFind]
	@Text nvarchar(256), -- NULL -  , 
	@TextField int, -- 0 - FileAs, -- 1 - FileAs, Comments
	@State int, -- NULL - 
	@Flag tinyint, -- NULL -  , 0-7 
	@UserOption int,
	@TimeField int, -- 0 - , 1 - Created, 2 - Modified
	@StartTime datetime,
	@EndTime datetime,
	@ProjectID TIdentifier
AS
	SET NOCOUNT ON
	DECLARE 
		@CurrentUserID TIdentifier, 
		@CurrentEmployeeID TIdentifier, 
		@AccessToPublicFolders TBool,
		@ManageAllTaskRequest TBool
	
	SET @CurrentUserID = dbo.adfGetCurrentUserID()
	SET @CurrentEmployeeID = dbo.adfGetCurrentEmployeeID()
	SET @AccessToPublicFolders = dbo.adfHasAccessRight(dbo.adfGetRightID('AccessToPublicFolders'))
	SET @ManageAllTaskRequest = dbo.adfHasAccessRight(dbo.adfGetRightID('ManageAllTaskRequest'))
	
	SELECT
		[TaskRequest].[Class],
		[TaskRequest].[ID],
		[TaskRequest].[State],
		[TaskRequest].[DueTime],
		[TaskRequest].[FileAs],
		[TaskRequest].[Comments],
		[TaskRequest].[ProjectID],
		[TaskRequest].[Flag],
		[TaskRequest].[Created],
		[TaskRequest].[CreatedBy],
		[TaskRequest].[Modified],
		[TaskRequest].[ModifiedBy]
	FROM
		[TaskRequest]
	WHERE
		(
			@AccessToPublicFolders = 1 OR [TaskRequest].[DocumentCardID] IS NULL
		) 
		AND
		(
			@ProjectID IS NULL OR (@ProjectID IS NOT NULL AND [TaskRequest].[ProjectID] = @ProjectID)
		)
		AND
		(
			@Text IS NULL
			OR
			(@TextField = 0 AND [TaskRequest].[FileAs] LIKE '%' + @Text + '%')
			OR
			(@TextField IN (1, 2) AND ([TaskRequest].[FileAs] LIKE '%' + @Text + '%' OR [TaskRequest].[Comments] LIKE '%' + @Text + '%'))
		)
		AND
		(
			@State IS NULL
			OR
			(@State IS NOT NULL AND [TaskRequest].[State] = @State)
		)		
		AND
		(
			@Flag IS NULL
			OR
			(@Flag IS NOT NULL AND [TaskRequest].[Flag] = @Flag)
		)
		AND
		(
			@UserOption IS NULL
			OR
			(
				@UserOption = 0 AND 
				(
					[TaskRequest].[SupervisorEmployeeID] = @CurrentEmployeeID OR
					/*(
						@AccessToPublicFolders = 1 AND 
						EXISTS(SELECT * FROM [DocumentCard] as [DC] WHERE [DC].[ID] = [TaskRequest].[DocumentCardID] AND [DC].[CardOwnerID] = @CurrentEmployeeID)
					) OR*/
					EXISTS(SELECT * FROM [TaskRequestAssignment] as [TRA] WHERE [TRA].[TaskRequestID] = [TaskRequest].[ID] AND [TRA].[EmployeeID] = @CurrentEmployeeID)
				)
			)
			OR
			(@UserOption = 1 AND ([CreatedBy] = @CurrentUserID OR [ModifiedBy] = @CurrentUserID))
			OR
			(@UserOption = 2 AND [CreatedBy] = @CurrentUserID)
			OR
			(@UserOption = 3 AND [ModifiedBy] = @CurrentUserID)
		)
		AND
		(
			@TimeField = 0
			OR
			(@TimeField = 1 AND [TaskRequest].[Created] BETWEEN @StartTime AND @EndTime)
			OR
			(@TimeField = 2 AND [TaskRequest].[Modified] BETWEEN @StartTime AND @EndTime)
		)
		AND
		(
			[TaskRequest].[CreatedBy] = @CurrentUserID 
			OR
			[TaskRequest].[SupervisorEmployeeID] = @CurrentEmployeeID 
			OR
			EXISTS(SELECT * FROM [TaskRequestAssignment] WHERE [TaskRequestID]=[ID] AND [EmployeeID] = @CurrentEmployeeID)
			OR
			@ManageAllTaskRequest = 1
			OR
			dbo.fnPjm5IsProjectManager([TaskRequest].[ProjectID], @CurrentEmployeeID) = 1
		)
	ORDER BY 
		[TaskRequest].[FileAs]
	RETURN 0
GO

GRANT EXECUTE ON [pjm5TaskRequestFind] TO PUBLIC
GO 