IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[pjm5FolderMoveTo]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	BEGIN
		PRINT 'Dropping procedure pjm5FolderMoveTo'
		DROP PROCEDURE [dbo].[pjm5FolderMoveTo]
	END
GO

PRINT 'Creating procedure pjm5FolderMoveTo'
GO

/******************************************************************************
**		File: pjm5FolderMoveTo.sql
**		Name: pjm5FolderMoveTo
**		Desc: this procedure automatically generated by Avicom.Adf.Generator
**
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**      ----------						-----------
**
**		Auth: Andrew.Maklakov
**		Date: 06/13/2006 16:59:46
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		--------	--------		-------------------------------------------
**    
*******************************************************************************/
CREATE PROCEDURE [pjm5FolderMoveTo]
	@ID TIdentifier,
	@FolderID TIdentifier
AS
	SET NOCOUNT ON
	DECLARE 
		@UserID TIdentifier,
		@PrevFolderID TIdentifier,
		@CompanyID TIdentifier
		
	IF @ID = @FolderID
	BEGIN
		RAISERROR('#foldercannotcopyormovetoitself', 18, -1)
		RETURN 1
	END
	
	IF dbo.fnFolderIsSubfolder(@FolderID, @ID) = 1
	BEGIN
		RAISERROR('#foldercannotcopyormovetoitself', 18, -1)
		RETURN 1
	END
	
	SELECT 
		@CompanyID = [CompanyID]
	FROM 
		[Folder]
	WHERE 
		[ID] = @ID
	IF NOT EXISTS(SELECT * FROM [Folder] WHERE [ID] = @FolderID AND ISNULL([CompanyID], 0) = ISNULL(@CompanyID, 0))
	BEGIN
		RAISERROR('#foldercannotcopyormovetoothercompany', 18, -1)
		RETURN 1
	END

	SELECT @PrevFolderID = [FolderID] FROM [Folder] WHERE [ID] = @ID
	IF @PrevFolderID != @FolderID
	BEGIN
		SET @UserID = dbo.adfGetCurrentUserID()
		IF dbo.fnFolderHasRightAccess(@PrevFolderID, @UserID, 'CreateSubfolder') = 0
		BEGIN
			RAISERROR('#accessdenied', 18, -1)
			RETURN 1
		END
		IF dbo.fnFolderHasRightAccess(@FolderID, @UserID, 'CreateSubfolder') = 0
		BEGIN
			RAISERROR('#accessdenied', 18, -1)
			RETURN 1
		END
		
		BEGIN TRANSACTION
		UPDATE 
			[Folder]
		SET 
			[FolderID] = @FolderID,
			[Modified] = DEFAULT,
			[ModifiedBy] = DEFAULT
		WHERE
			[ID] = @ID

		IF @@error != 0
		BEGIN
			ROLLBACK TRANSACTION
			RETURN 1
		END
		COMMIT TRANSACTION
	END	
	EXEC pjm5FolderGet @ID
	RETURN 0
GO

GRANT EXECUTE ON [pjm5FolderMoveTo] TO PUBLIC
GO

 