IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[pjm5InvoiceAndStatementBrowse]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
BEGIN
	PRINT 'Dropping procedure pjm5InvoiceAndStatementBrowse'
	DROP PROCEDURE [dbo].[pjm5InvoiceAndStatementBrowse]
END
GO

PRINT 'Creating procedure pjm5InvoiceAndStatementBrowse'
GO

/******************************************************************************
**		File: pjm5InvoiceAndStatementBrowse.sql
**		Name: pjm5InvoiceAndStatementBrowse
**		Desc: this procedure automatically generated by Avicom.Adf.Generator
**
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**      ----------						-----------
**
**		Auth: vladislav.dremin
**		Date: 01/21/2005 15:47:39
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		--------	--------		-------------------------------------------
**    
*******************************************************************************/
CREATE PROCEDURE [pjm5InvoiceAndStatementBrowse]
	@ID TIdentifier
AS
	SET NOCOUNT ON
	DECLARE @Lang TLanguage
	SET @Lang = dbo.adfGetLanguage()
	SELECT
		CASE @Lang
			WHEN 'en' THEN 'Acts'
			ELSE '' 
		END AS [Group],
		[Statement].[Class],
		[Statement].[ID],
		[Statement].[State],
		[Statement].[Date],
		[Statement].[Number],
		[Statement].[FileAs],
		[Statement].[Created],
		[Statement].[CreatedBy],
		[Statement].[Modified],
		[Statement].[ModifiedBy],
		[Statement].[Timestamp],
		[Statement].[CurrencyCode],
		[Statement].[TotalWithVAT],
		[Statement].[VAT],
		[Statement].[TotalWithVATPC],
		[Statement].[VATPC],
		[StatementAdvanceInvoice].[StatementPaymentValue] AS [PaymentValue],
		[StatementAdvanceInvoice].[StatementPaymentVAT] AS [PaymentVAT],
		[StatementAdvanceInvoice].[StatementPaymentValuePC] AS [PaymentValuePC],
		[StatementAdvanceInvoice].[StatementPaymentVATPC] AS [PaymentVATPC]
	FROM
		[StatementAdvanceInvoice]
		INNER JOIN [Statement]
			ON [StatementAdvanceInvoice].[StatementID] = [Statement].[ID]
	WHERE
		[StatementAdvanceInvoice].[AdvanceInvoiceID] = @ID
	UNION
	SELECT
		CASE @Lang
			WHEN 'en' THEN 'Invoices'
			ELSE '' 
		END AS [Group],
		[Invoice].[Class],
		[Invoice].[ID],
		[Invoice].[State],
		[Invoice].[Date],
		[Invoice].[Number],
		[Invoice].[FileAs],
		[Invoice].[Created],
		[Invoice].[CreatedBy],
		[Invoice].[Modified],
		[Invoice].[ModifiedBy],
		[Invoice].[Timestamp],
		[Invoice].[CurrencyCode],
		[Invoice].[TotalWithVAT],
		[Invoice].[VAT],
		[Invoice].[TotalWithVATPC],
		[Invoice].[VATPC],
		[Self].[TotalWithVAT] AS [PaymentValue],
		[Self].[VAT] AS [PaymentVAT],
		[Self].[TotalWithVATPC] AS [PaymentValuePC],
		[Self].[VATPC] AS [PaymentVATPC]
	FROM
		[AdvanceInvoice]
		INNER JOIN [Invoice]
			ON [Invoice].[ID] = [AdvanceInvoice].[InvoiceID]
		INNER JOIN [Invoice] AS [Self]
			ON [Self].[ID] = [AdvanceInvoice].[AdvanceInvoiceID]
	WHERE
		[AdvanceInvoice].[AdvanceInvoiceID] = @ID
	RETURN 0
GO

GRANT EXECUTE ON [pjm5InvoiceAndStatementBrowse] TO PUBLIC
GO

IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[pjm5InvoiceAdvanceBrowse]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
BEGIN
	PRINT 'Dropping procedure pjm5InvoiceAdvanceBrowse'
	DROP PROCEDURE [dbo].[pjm5InvoiceAdvanceBrowse]
END
GO

PRINT 'Creating procedure pjm5InvoiceAdvanceBrowse'
GO

/******************************************************************************
**		File: pjm5InvoiceAdvanceBrowse.sql
**		Name: pjm5InvoiceAdvanceBrowse
**		Desc: this procedure automatically generated by Avicom.Adf.Generator
**
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**      ----------						-----------
**
**		Auth: vladislav.dremin
**		Date: 01/21/2005 15:47:39
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		--------	--------		-------------------------------------------
**    
*******************************************************************************/
CREATE PROCEDURE [pjm5InvoiceAdvanceBrowse]
	@ID TIdentifier
AS
	SET NOCOUNT ON
	DECLARE @Lang TLanguage
	SET @Lang = dbo.adfGetLanguage()
	SELECT
		CASE @Lang
			WHEN 'en' THEN 'Advance Invoices'
			ELSE ' ' 
		END AS [Group],
		[Invoice].[Class],
		[Invoice].[ID],
		[Invoice].[State],
		[Invoice].[Date],
		[Invoice].[Number],
		[Invoice].[FileAs],
		[Invoice].[Created],
		[Invoice].[CreatedBy],
		[Invoice].[Modified],
		[Invoice].[ModifiedBy],
		[Invoice].[Timestamp],
		[Invoice].[CurrencyCode],
		[Invoice].[Total],
		[Invoice].[TotalWithVAT],
		[Invoice].[VAT],
		[Invoice].[TotalPC],
		[Invoice].[TotalWithVATPC],
		[Invoice].[VATPC]
	FROM
		[AdvanceInvoice]
		INNER JOIN [Invoice]
			ON [AdvanceInvoice].[AdvanceInvoiceID] = [Invoice].[ID]
	WHERE
		[AdvanceInvoice].[InvoiceID] = @ID
	RETURN 0
GO

GRANT EXECUTE ON [pjm5InvoiceAdvanceBrowse] TO PUBLIC
GO

IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[pjm5InvoiceAdvanceSelectorDialog]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
BEGIN
	PRINT 'Dropping procedure pjm5InvoiceAdvanceSelectorDialog'
	DROP PROCEDURE [dbo].[pjm5InvoiceAdvanceSelectorDialog]
END
GO

PRINT 'Creating procedure pjm5InvoiceAdvanceSelectorDialog'
GO

/******************************************************************************
**		File: pjm5InvoiceAdvanceSelectorDialog.sql
**		Name: pjm5InvoiceAdvanceSelectorDialog
**		Desc: this procedure automatically generated by Avicom.Adf.Generator
**
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**      ----------						-----------
**
**		Auth: vladislav.dremin
**		Date: 01/21/2005 15:47:39
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		--------	--------		-------------------------------------------
**    
*******************************************************************************/
CREATE PROCEDURE [pjm5InvoiceAdvanceSelectorDialog]
	@ID TIdentifier,
	@Category TName,
	@ProjectID TIdentifier = NULL,
	@CurrencyCode TCode3 = NULL
AS
	SET NOCOUNT ON
	IF @ID IS NOT NULL
		SELECT 
			@ProjectID = [ProjectID],
			@CurrencyCode = [CurrencyCode]
		FROM
			[Invoice]
		WHERE	
			[ID] = @ID

	DECLARE 
		@Lang TLanguage,
		@VAT TName
	SET @Lang = dbo.adfGetLanguage()
	IF @Lang = 'en'
		SET @VAT = ', VAT '
	ELSE
		SET @VAT = ',  '

	SELECT 
		[Invoice].[Class],
		[Invoice].[ID],
		[Invoice].[State],
		[Invoice].[Date],
		[Invoice].[Number],
		[Invoice].[FileAs] + 
			', ' + [Invoice].[CurrencyCode] + ' ' +
			CONVERT(varchar(256), CAST(ISNULL([Invoice].[TotalWithVAT], 0.0) AS money), 1) +
			@VAT + 
			CAST(ISNULL([Invoice].[VAT], 0.0) AS varchar(256))
			AS [FileAs],		
		[Invoice].[Created],
		[Invoice].[CreatedBy],
		[Invoice].[Modified],
		[Invoice].[ModifiedBy],
		[Invoice].[Timestamp],
		[Invoice].[CurrencyCode],
		[Invoice].[TotalWithVAT] AS [Value],
		[Invoice].[VAT]
	FROM
		[Invoice]
	WHERE
		[Invoice].[State] IN (2, 5) AND
		[Invoice].[ProjectID] = @ProjectID AND
		[Invoice].[CurrencyCode] = @CurrencyCode AND
		[Invoice].[Advance] = 1 AND
		NOT EXISTS (SELECT * FROM [AdvanceInvoice] WHERE [AdvanceInvoiceID] = [Invoice].[ID]) AND
		(
			@Category IS NULL OR
			LEN(@Category) = 0 OR
			EXISTS(
				SELECT * 
				FROM [DocumentCategory] 
					INNER JOIN [Category]
						ON [Category].[ID] = [DocumentCategory].[CategoryID] 
				WHERE
					[DocumentCategory].[DocumentClass] = [Invoice].[Class] AND
					[DocumentCategory].[DocumentID] = [Invoice].[ID] AND
					[Category].[FileAs] LIKE @Category
					
			)
		)
	RETURN 0
GO

GRANT EXECUTE ON [pjm5InvoiceAdvanceSelectorDialog] TO PUBLIC
GO

IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[pjm5InvoiceAdvanceAppend]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
BEGIN
	PRINT 'Dropping procedure pjm5InvoiceAdvanceAppend'
	DROP PROCEDURE [dbo].[pjm5InvoiceAdvanceAppend]
END
GO

PRINT 'Creating procedure pjm5InvoiceAdvanceAppend'
GO

/******************************************************************************
**		File: pjm5InvoiceAdvanceAppend.sql
**		Name: pjm5InvoiceAdvanceAppend
**		Desc: this procedure automatically generated by Avicom.Adf.Generator
**
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**      ----------						-----------
**
**		Auth: vladislav.dremin
**		Date: 01/21/2005 15:47:39
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		--------	--------		-------------------------------------------
**    
*******************************************************************************/
CREATE PROCEDURE [pjm5InvoiceAdvanceAppend]
	@ID TIdentifier,
	@AdvanceInvoiceID TIdentifier
AS
	SET NOCOUNT ON
	IF EXISTS (SELECT * FROM [AdvanceInvoice] WHERE [AdvanceInvoiceID] = @AdvanceInvoiceID AND [InvoiceID] != @ID)
	BEGIN
		RAISERROR('#InvoiceAlreadyLinked', 18, -1)
		RETURN 1
	END

	IF NOT EXISTS (SELECT * FROM [AdvanceInvoice] WHERE [AdvanceInvoiceID] = @AdvanceInvoiceID AND [InvoiceID] = @ID)
	BEGIN
		INSERT INTO [AdvanceInvoice]([InvoiceID], [AdvanceInvoiceID]) VALUES (@ID, @AdvanceInvoiceID)
		IF @@error != 0
			RETURN 1
	END
	RETURN 0
GO

GRANT EXECUTE ON [pjm5InvoiceAdvanceAppend] TO PUBLIC
GO

IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[pjm5InvoiceAdvanceRemove]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
BEGIN
	PRINT 'Dropping procedure pjm5InvoiceAdvanceRemove'
	DROP PROCEDURE [dbo].[pjm5InvoiceAdvanceRemove]
END
GO

PRINT 'Creating procedure pjm5InvoiceAdvanceRemove'
GO

/******************************************************************************
**		File: pjm5InvoiceAdvanceRemove.sql
**		Name: pjm5InvoiceAdvanceRemove
**		Desc: this procedure automatically generated by Avicom.Adf.Generator
**
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**      ----------						-----------
**
**		Auth: vladislav.dremin
**		Date: 01/21/2005 15:47:39
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		--------	--------		-------------------------------------------
**    
*******************************************************************************/
CREATE PROCEDURE [pjm5InvoiceAdvanceRemove]
	@ID TIdentifier,
	@AdvanceInvoiceID TIdentifier
AS
	SET NOCOUNT ON
	DELETE [AdvanceInvoice] WHERE [AdvanceInvoiceID] = @AdvanceInvoiceID AND [InvoiceID] = @ID
	IF @@error != 0
	BEGIN
		RETURN 1
	END
	RETURN 0
GO

GRANT EXECUTE ON [pjm5InvoiceAdvanceRemove] TO PUBLIC
GO
