IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[adfLicenseCreate]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	BEGIN
		PRINT 'Dropping procedure adfLicenseCreate'
		DROP PROCEDURE [dbo].[adfLicenseCreate]
	END
GO

PRINT 'Creating procedure adfLicenseCreate'
GO

/******************************************************************************
**		File: adfLicenseCreate.sql
**		Name: adfLicenseCreate
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		--------	--------		-------------------------------------------
**		.
*******************************************************************************/
CREATE PROCEDURE [adfLicenseCreate]
	@Code TCode,
	@Name TName,
	@PerUser TBool,
	@Created TDate,
	@Functions	TNotes,
	@Value TKey,
	@SignedValue TKey
AS
	DECLARE @ID TIdentifier
	SELECT @ID = [ID] FROM [License] WHERE [Value] = @Value
	
	IF @ID IS NULL
	BEGIN
		INSERT INTO [License] 
		(
			[Code], [Name], [PerUser],
			[Created], [Functions], [Value], [SignedValue]
		)
		VALUES 
		(
			@Code, @Name, @PerUser,
			@Created, @Functions, @Value, @SignedValue
		)
	END
	ELSE
	BEGIN
		UPDATE [License]
		SET
			[Code] = @Code,
			[Name] = @Name,
			[Functions] = @Functions,
			[SignedValue] = [SignedValue],
			[PerUser] = @PerUser
		WHERE [ID] = @ID
	END

	RETURN 0
GO

GRANT EXECUTE ON adfLicenseCreate TO PUBLIC
GO
 