IF EXISTS (SELECT * FROM sysobjects WHERE type = 'P' AND name = 'lmCheckTimestamp')
	BEGIN
		PRINT 'Dropping Procedure lmCheckTimestamp'
		DROP  Procedure  lmCheckTimestamp
	END

GO

PRINT 'Creating Procedure lmCheckTimestamp'
GO
/******************************************************************************
**		File: 
**		Name: lmCheckTimestamp
**		Desc: 
**
**		This template can be customized:
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**      ----------						-----------
**
**		Auth: 
**		Date: 
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		--------	--------		-------------------------------------------
**    
*******************************************************************************/
CREATE Procedure lmCheckTimestamp
	@ListName TName,
	@TableName TName
WITH EXECUTE AS OWNER
AS
	SET NOCOUNT ON
	DECLARE 
		@UserID TIdentifier,
		@timestamp bigint,
		@sql nvarchar(max)
	
	EXECUTE AS CALLER
	SET @UserID = dbo.adfGetCurrentUserID()
	REVERT
	
	SELECT
		@timestamp = CAST([Value] AS bigint)
	FROM
		[UserParameter]
	WHERE
		[UserID] = @UserID AND
		[Name] = 'Pjm6ComboDataSource_' + @ListName
	
	SET @timestamp = ISNULL(@timestamp, 0)
	DECLARE @tmp TABLE ([ID] int)
	SET @sql = 'SELECT [ID] FROM [' + @TableName + '] WHERE [Timestamp] > ' + CAST(@timestamp as varchar(512))
	INSERT INTO @tmp EXEC (@sql)
	
	IF EXISTS(SELECT * FROM @tmp)
		RETURN 1
		
	RETURN 0
GO

GRANT EXEC ON lmCheckTimestamp TO PUBLIC
GO
