﻿IF EXISTS (SELECT * FROM sysobjects WHERE type = 'P' AND name = 'lmCompanyManagerEmployee')
	BEGIN
		PRINT 'Dropping Procedure lmCompanyManagerEmployee'
		DROP  Procedure  lmCompanyManagerEmployee
	END

GO

PRINT 'Creating Procedure lmCompanyManagerEmployee'
GO

/******************************************************************************
**		File: 
**		Name: lmCompanyManagerEmployee
**		Desc: 
**
**		This template can be customized:
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**      ----------						-----------
**
**		Auth: 
**		Date: 
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		--------	--------		-------------------------------------------
**    
*******************************************************************************/
CREATE Procedure [dbo].[lmCompanyManagerEmployee]
AS
	SET NOCOUNT ON
	SELECT
		[Employee].[ID],
		[Employee].[FileAs] as [Name],
		[Employee].[CompanyID],
		(CASE WHEN [Employee].[State] = 1 AND [Company].[State] = 1 THEN 1 ELSE 2 END) as [State],
		[Employee].[UserID],
		[Company].[Own],
		[Employee].[Initials] as [Code],
		[Employee].[DivisionID]
	FROM
		[Employee] LEFT JOIN [Company]
			ON ([Employee].[CompanyID] = [Company].[ID])
	WHERE  ([dbo].[adfHasAccessRightByNameForUser] ('ViewAllCompanies',[Employee].[UserID])=1)
			AND
			([dbo].[adfHasAccessRightByNameForUser] ('ManageCompanies',[Employee].[UserID])=1)
RETURN 0
GO

GRANT EXEC ON lmCompanyManagerEmployee TO PUBLIC
GO
