IF EXISTS (SELECT * FROM sysobjects WHERE type = 'P' AND name = 'lmSaveTimestamp')
	BEGIN
		PRINT 'Dropping Procedure lmSaveTimestamp'
		DROP  Procedure  lmSaveTimestamp
	END

GO

PRINT 'Creating Procedure lmSaveTimestamp'
GO
/******************************************************************************
**		File: 
**		Name: lmSaveTimestamp
**		Desc: 
**
**		This template can be customized:
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**      ----------						-----------
**
**		Auth: 
**		Date: 
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		--------	--------		-------------------------------------------
**    
*******************************************************************************/
CREATE Procedure lmSaveTimestamp
	@ListName TName,
	@TableName TName
WITH EXECUTE AS OWNER
AS
	SET NOCOUNT ON
	DECLARE 
		@UserID TIdentifier,
		@param TName,
		@timestamp bigint,
		@sql nvarchar(max)
		
	EXECUTE AS CALLER
	SET @UserID = dbo.adfGetCurrentUserID()
	REVERT
	
	SET @param = 'Pjm6ComboDataSource_' + @ListName
	
	DECLARE @tmp TABLE ([Timestamp] bigint)
	SET @sql = 'SELECT MAX([Timestamp]) FROM [' + @TableName + ']'
	INSERT INTO @tmp EXEC (@sql)
	SELECT @timestamp = [Timestamp] FROM @tmp
	
	BEGIN TRANSACTION

	DELETE [UserParameter] WHERE [UserID] = @UserID AND [Name] = @param
	IF @@error != 0
	BEGIN
		ROLLBACK TRANSACTION
		RETURN 1
	END

	INSERT INTO [UserParameter] ([UserID], [Name], [Value]) VALUES(@UserID, @param, @timestamp)
	IF @@error != 0
	BEGIN
		ROLLBACK TRANSACTION
		RETURN 1
	END

	COMMIT TRANSACTION
	
	RETURN 0
GO

GRANT EXEC ON lmSaveTimestamp TO PUBLIC
GO
