IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[pjm5MeetingResourceDelete]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	BEGIN
		PRINT 'Dropping procedure pjm5MeetingResourceDelete'
		DROP PROCEDURE [dbo].[pjm5MeetingResourceDelete]
	END
GO

PRINT 'Creating procedure pjm5MeetingResourceDelete'
GO

/******************************************************************************
**		File: pjm5MeetingResourceDelete.sql
**		Name: pjm5MeetingResourceDelete
**		Desc: this procedure automatically generated by Avicom.Adf.Generator
**
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**      ----------						-----------
**
**		Auth: Dmitry.Kolchev
**		Date: 05/19/2006 12:50:39
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		--------	--------		-------------------------------------------
**    
*******************************************************************************/
CREATE PROCEDURE pjm5MeetingResourceDelete
	@MeetingRequestID TIdentifier,
	@ResourceID TIdentifier
AS
		
	SET NOCOUNT ON
	
	DECLARE @OriginatorEmployeeID TIdentifier, 
			@CurrentEmployeeID TIdentifier,
			@result int
	
	SET @CurrentEmployeeID = dbo.adfGetCurrentEmployeeID()
			
	SELECT 
		@OriginatorEmployeeID = [OriginatorEmployeeID]
	FROM 
		[MeetingRequest] 
	WHERE 
		[ID] = @MeetingRequestID
	
	IF @OriginatorEmployeeID = @CurrentEmployeeID
	BEGIN
		BEGIN TRANSACTION

		DELETE [MeetingResource] WHERE [MeetingRequestID] = @MeetingRequestID AND [ResourceID] = @ResourceID
		IF @@ERROR != 0
		BEGIN
			ROLLBACK TRANSACTION
			RETURN 1
		END
		
		EXEC @result = pjm5ResourceFree @ResourceID, @MeetingRequestID
		IF @@ERROR != 0 OR @result != 0
		BEGIN
			ROLLBACK TRANSACTION
			RETURN 1
		END

		UPDATE [MeetingRequest]
		SET
			[MeetingRequest].[Modified] = DEFAULT,
			[MeetingRequest].[ModifiedBy] = DEFAULT
		WHERE
			[ID] = @MeetingRequestID
		IF @@ERROR != 0
		BEGIN
			ROLLBACK TRANSACTION
			RETURN 1
		END

		COMMIT TRANSACTION

	END
	ELSE
	BEGIN
		RAISERROR('#accessdenied', 16, -1);
		RETURN 1
	END

	RETURN 0
GO

GRANT EXECUTE ON pjm5MeetingResourceDelete TO PUBLIC
GO
 