 IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[pjm5MeetingRequestCopy]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	BEGIN
		PRINT 'Dropping procedure pjm5MeetingRequestCopy'
		DROP PROCEDURE [dbo].[pjm5MeetingRequestCopy]
	END
GO

PRINT 'Creating procedure pjm5MeetingRequestCopy'
GO

/******************************************************************************
**		File: pjm5MeetingRequestCopy.sql
**		Name: pjm5MeetingRequestCopy
**		Desc: this procedure automatically generated by Avicom.Adf.Generator
**
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**      ----------						-----------
**
**		Auth: Dmitry.Kolchev
**		Date: 09/11/2006 12:50:39
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		--------	--------		-------------------------------------------
**    
*******************************************************************************/
CREATE PROCEDURE [pjm5MeetingRequestCopy]
	@MeetingRequestId TIdentifier,
	@NewTime TDateTime,
	@RecurrenceID TIdentifier
AS
	DECLARE @ID TIdentifier
	SET NOCOUNT ON
	
	INSERT INTO [MeetingRequest]
		([Flag], [State], [FileAs], [ProjectID], [OriginatorEmployeeID], 
		[ActivityTypeID], [PriorityID], [StartTime], [Duration], [Location], [Color], [Comments])
	SELECT
		[Flag],
		Case (SELECT
		Convert(nvarchar,[Value]) 
		FROM [dbo].[UserParameter]
		WHERE Name='MeetingRequestAutoAssign'
		AND UserID=dbo.adfGetCurrentUserID())
		WHEN '0' THEN 1
		WHEN '1' THEN 2
		ELSE 2
		END,
		[FileAs],
		[ProjectID],
		[OriginatorEmployeeID],
		[ActivityTypeID],
		[PriorityID],
		@NewTime,
		[Duration],
		[Location],
		[Color],
		[Comments]
	FROM
		[MeetingRequest]
	WHERE
		[ID] = @MeetingRequestID
		
	IF @@ERROR != 0 RETURN 1
	
	SET @ID = SCOPE_IDENTITY()
	
	UPDATE [Document] 
	SET [RecurrencePatternID] = @RecurrenceID 
	WHERE 
		[Class] = dbo.adfGetClassByName('Pjm5.MeetingRequest') AND [ID] = @ID
	IF @@ERROR != 0 RETURN 1

	INSERT INTO [Attendee] ([MeetingRequestID], [EmployeeID], [Required])
	SELECT
		@ID,
		[EmployeeID],
		[Required]
	FROM
		[Attendee]
	WHERE
		[MeetingRequestID] = @MeetingRequestID
	IF @@ERROR != 0 RETURN 1
	
	INSERT INTO [MeetingResource] ([MeetingRequestID], [ResourceID], [Required])
	SELECT
		@ID,
		[ResourceID],
		[Required]
	FROM
		[MeetingResource]
	WHERE
		[MeetingRequestID] = @MeetingRequestID
	
	IF @@ERROR != 0 RETURN 1
		
	RETURN 0
GO
  