IF EXISTS (SELECT * FROM sysobjects WHERE type = 'TR' AND name = 'pjm5trMeetingResourceInsert')
	BEGIN
		PRINT 'Dropping Trigger pjm5trMeetingResourceInsert'
		DROP  Trigger pjm5trMeetingResourceInsert
	END
GO

/******************************************************************************
**		File: 
**		Name: pjm5trMeetingResourceInsert
**		Desc: 
**
**		This template can be customized:
**              
**
**		Auth: 
**		Date: 
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:				Description:
**		--------		--------				-------------------------------------------
**    
*******************************************************************************/

PRINT 'Creating Trigger pjm5trMeetingResourceInsert'
GO
CREATE TRIGGER pjm5trMeetingResourceInsert ON [MeetingResource] FOR INSERT
AS
	IF @@rowcount = 0 
		RETURN

	SET NOCOUNT ON
	
	
	DECLARE curInserted CURSOR LOCAL FORWARD_ONLY READ_ONLY FOR SELECT [MeetingRequestID], [ResourceID] FROM [inserted]
	OPEN curInserted
	
	DECLARE @MeetingRequestID TIdentifier, @ResourceID TIdentifier, @MeetingRequestState TState,
			@result int
	
	FETCH NEXT FROM curInserted INTO @MeetingRequestID, @ResourceID
	WHILE @@FETCH_STATUS = 0
	BEGIN
		SELECT @MeetingRequestState = [State] FROM [MeetingRequest] WHERE [ID] = @MeetingRequestID
		IF @MeetingRequestState = 2 --  
		BEGIN
			EXEC @result = pjm5ResourceAlloc @ResourceID, @MeetingRequestID
			IF @@ERROR != 0 OR @result != 0
			BEGIN
				ROLLBACK TRANSACTION
				CLOSE curInserted
				DEALLOCATE curInserted
				RETURN 
			END
		END
		FETCH NEXT FROM curInserted INTO @MeetingRequestID, @ResourceID
	END
	
	CLOSE curInserted
	DEALLOCATE curInserted
	
	RETURN
GO  