IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[pjm7NormUpdate]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	BEGIN
		PRINT 'Dropping procedure pjm7NormUpdate'
		DROP PROCEDURE [dbo].[pjm7NormUpdate]
	END
GO

PRINT 'Creating procedure pjm7NormUpdate'
GO

/******************************************************************************
**		File: pjm7NormUpdate.sql
**		Name: pjm7NormUpdate
**		Desc: this procedure automatically generated by Avicom.Adf.Generator
**
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**      ----------						-----------
**
**		Auth: Avgusta.Bekhtina
**		Date: 19/06/2014 12:00:00
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		--------	--------		-------------------------------------------
**    
*******************************************************************************/
CREATE PROCEDURE [dbo].[pjm7NormUpdate]
		@Xml XML
AS
	DECLARE @ID TIdentifier,
			@Code TCode,
			@FileAs TName,
			@Comments TNotes

	SET NOCOUNT ON

	SELECT
		@ID = T.c.value('ID[1]','int'),
		@FileAs = T.c.value('FileAs[1]','nvarchar(256)'),
		@Code = T.c.value('Code[1]','varchar(32)'),
		@Comments = T.c.value('Comments[1]','nvarchar(max)')
	FROM
		@Xml.nodes('/pjm7NormGet/Norm') AS T(c)
	
	BEGIN TRANSACTION

	UPDATE 
		[Norm]
	SET
		[Norm].[Code] = @Code,
		[Norm].[FileAs] = @FileAs,
		[Norm].[Comments] = @Comments,
		[Norm].[Modified] = GETDATE(),
		[Norm].[ModifiedBy] = dbo.adfGetCurrentUserID()
	WHERE
		[Norm].[ID] = @ID
	IF @@ERROR != 0
	BEGIN
		ROLLBACK TRANSACTION
		RETURN 1
	END

	DELETE [NormValue] WHERE [NormID] = @ID
	IF @@ERROR != 0
	BEGIN
		ROLLBACK TRANSACTION
		RETURN 1
	END

	INSERT INTO [NormValue]
		([NormID], [Year], [UtilizationHours], [RealizationHours], [Revenue])
	SELECT
		@ID,
		T.c.value('Year[1]','varchar(4)') AS [Year],
		T.c.value('UtilizationHours[1]','int') AS [UtilizationHours],
		T.c.value('RealizationHours[1]','int') AS [RealizationHours],
		T.c.value('Revenue[1]','money') AS [Revenue]
	FROM
		@Xml.nodes('/pjm7NormGet/NormValue') AS T(c)

	IF @@ERROR != 0
	BEGIN
		ROLLBACK TRANSACTION
		RETURN 1
	END

	COMMIT TRANSACTION

	EXEC pjm7NormGet @ID

	RETURN 0
GO

GRANT EXECUTE ON [pjm7NormUpdate] TO PUBLIC
GO
