﻿IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[pjm7ReminderForUserGet]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	BEGIN
		PRINT 'Dropping procedure pjm7ReminderForUserGet'
		DROP PROCEDURE [dbo].[pjm7ReminderForUserGet]
	END
GO

PRINT 'Creating procedure pjm7ReminderForUserGet'
GO

/******************************************************************************
**		File: pjm7ReminderForUserGet.sql
**		Name: pjm7ReminderForUserGet
**		Desc: Процедура возвращает напоминание для пользователя
**
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**      ----------						-----------
**
**		Auth: Anton.Paramonov
**		Date: 11.04.2012 11:50:00
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		--------	--------		-------------------------------------------
**
*******************************************************************************/
CREATE PROCEDURE [pjm7ReminderForUserGet]
@ReminderID		TIdentifier,
@UserID			TIdentifier
AS
	SET NOCOUNT ON

	SELECT
		[Reminder].[ID],
		[Reminder].[DocumentClass],
		[Reminder].[DocumentID],
		[Reminder].[EventTime],
		[Reminder].[Subtype],
		[ReminderType].[IsTimeFormat],
		[UserReminder].[State],
		[UserReminder].[UserID],
		[UserReminder].[NextInterval],
		[UserReminder].[OriginalInterval],
		[UserReminder].[Description]
	FROM
		[Reminder]
		INNER JOIN [ReminderType]
			ON [ReminderType].[Subtype] = [Reminder].[Subtype]
		INNER JOIN [UserReminder]
			ON [UserReminder].[ReminderID] = [Reminder].[ID]
	WHERE
		[Reminder].[ID] = @ReminderID
		AND
		[UserReminder].[UserID] = @UserID

	RETURN 0
GO

GRANT EXECUTE ON [pjm7ReminderForUserGet] TO PUBLIC
GO
