IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[pjm5PhoneCallGet]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	BEGIN
		PRINT 'Dropping procedure pjm5PhoneCallGet'
		DROP PROCEDURE [dbo].[pjm5PhoneCallGet]
	END
GO

PRINT 'Creating procedure pjm5PhoneCallGet'
GO

/******************************************************************************
**		File: pjm5PhoneCallGet.sql
**		Name: pjm5PhoneCallGet
**		Desc: this procedure automatically generated by Avicom.Adf.Generator
**
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**      ----------						-----------
**
**		Auth: pavel.boruroev
**		Date: 01/20/2005 16:11:01
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		--------	--------		-------------------------------------------
**    
*******************************************************************************/
CREATE PROCEDURE [pjm5PhoneCallGet]
	@ID TIdentifier
AS
	SET NOCOUNT ON
	
	SELECT
		[PhoneCall].[Class],
		[PhoneCall].[ID],
		[PhoneCall].[State],
		[PhoneCall].[Flag],
		[PhoneCall].[FileAs],

		[TimeEntry].[EmployeeID],
		[TimeEntry].[ProjectID],
		[TimeEntry].[TaskID],
		[TimeEntry].[StartTime],
		[TimeEntry].[Duration],
		[TimeEntry].[Billable] as [Billable],
		[TimeEntry].[Overtime],
		[TimeEntry].[ActivityTypeID],
		[Expense].[Billable] as [ExpenseBillable],

		[PhoneCall].[TimeEntryID],
		[PhoneCall].[ExpenseID],
		[PhoneCall].[PhoneCallCodeID],
		[PhoneCall].[Comments],
		[PhoneCall].[Created],
		[PhoneCall].[CreatedBy],
		[PhoneCall].[Modified],
		[PhoneCall].[ModifiedBy],
		[PhoneCall].[Timestamp],
		[Class].[Code] AS [DocumentClass],
		[Expense].[DocumentID]
	FROM
		[PhoneCall]
		INNER JOIN [TimeEntry]
			ON [TimeEntry].[ID] = [PhoneCall].[TimeEntryID]
		INNER JOIN [Expense]
			ON [Expense].[ID] = [PhoneCall].[ExpenseID]
		LEFT OUTER JOIN [Class]
			ON [Expense].[DocumentClass] = [Class].[Class]
	WHERE
		[PhoneCall].[ID] = @ID
		
	IF @@ROWCOUNT = 0
		RETURN 1
	RETURN 0
GO

GRANT EXECUTE ON [pjm5PhoneCallGet] TO PUBLIC
GO

 