 IF EXISTS (SELECT * FROM sysobjects WHERE type = 'P' AND name = 'ExportTask')
	BEGIN
		PRINT 'Dropping Procedure ExportTask'
		DROP  Procedure  ExportTask
	END

GO

IF EXISTS (SELECT * FROM sysobjects WHERE type = 'P' AND name = 'PjmSyncExportTask')
	BEGIN
		PRINT 'Dropping Procedure PjmSyncExportTask'
		DROP  Procedure  PjmSyncExportTask
	END

GO

PRINT 'Creating Procedure PjmSyncExportTask'
GO

--------------------------------------------------------------------------------------
CREATE Procedure PjmSyncExportTask
	@DeviceID varchar(40),
	@DaysBeforeThis int,
	@TimeStamp bigint,
	@CreateDeleted BIT

AS
	SET NOCOUNT ON
	
SELECT
	[ID],
	[Class],
	[ItemID],
	[Body],
	[Categories],
	[Complete],
	[DateCompleted],
	[DueDate],
	[Importance],
	[ReminderTime],
	[ReminderSet],
	[StartDate],
	[Subject],
	[TimeStamp]
FROM dbo.PjmSyncExportTaskFunction(@DeviceID,
	@DaysBeforeThis,
	@TimeStamp,
	@CreateDeleted)

RETURN 0
GO

GRANT EXEC ON PjmSyncExportTask TO PUBLIC
GO

