IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[pjm5CalendarProjectUpdate]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	BEGIN
		PRINT 'Dropping procedure pjm5CalendarProjectUpdate'
		DROP PROCEDURE [dbo].[pjm5CalendarProjectUpdate]
	END
GO

PRINT 'Creating procedure pjm5CalendarProjectUpdate'
GO

/******************************************************************************
**		File: CalendarProjectUpdate.sql
**		Name: pjm5CalendarProjectUpdate
**		Desc: this procedure automatically generated by Avicom.Adf.Generator
**
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**      ----------						-----------
**
**		Auth: Dmitry.Kolchev
**		Date: 02/15/2006 15:32
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		--------	--------		-------------------------------------------
**		20.02.13	SAP				  OPENXML 
*******************************************************************************/
CREATE PROCEDURE [pjm5CalendarProjectUpdate]
	@Xml XML
AS
	DECLARE @UserID TIdentifier
	
	SET NOCOUNT ON

	SET @UserID = dbo.adfGetCurrentUserID()
		
		
	BEGIN TRANSACTION
	
	DELETE [CalendarProject] WHERE [UserID] = @UserID
	IF @@ERROR != 0
	BEGIN
		ROLLBACK TRANSACTION
		RETURN 1
	END
	
	INSERT INTO [CalendarProject] ([UserID], [ProjectID])
	SELECT
		@UserID, 
		T.c.value('.','int')
	FROM
		@Xml.nodes('/Projects/ID') AS T(c)
	WHERE
		T.c IS NOT NULL


	IF @@ERROR != 0
	BEGIN
		ROLLBACK TRANSACTION
		RETURN 1
	END
		
	COMMIT TRANSACTION

	RETURN 0
GO

GRANT EXECUTE ON [pjm5CalendarProjectUpdate] TO PUBLIC
GO
  