IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[pjm5ChangeProjectManager]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	BEGIN
		PRINT 'Dropping procedure pjm5ChangeProjectManager'
		DROP PROCEDURE [dbo].[pjm5ChangeProjectManager]
	END
GO

PRINT 'Creating procedure pjm5ChangeProjectManager'
GO

/******************************************************************************
**		File: ChangeProjectManager.sql
**		Name: pjm5ChangeProjectManager
**		Desc: this procedure automatically generated by Avicom.Adf.Generator
**
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**      ----------						-----------
**
**		Auth: Andrew.Maklakov
**		Date: 01/20/2005 11:01:32
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		--------	--------		-------------------------------------------
**		17.04.13	SOV				     
**		29.08.13	SAP				      AssignProjectManager
**									     
*******************************************************************************/
CREATE PROCEDURE [pjm5ChangeProjectManager]
	@ProjectID TIdentifier,
	@EmployeeID TIdentifier,
	@AddToParticipants TBool = 0
AS
	SET NOCOUNT ON
	
	IF dbo.adfHasAccessRight(dbo.adfGetRightID('AssignProjectManager')) = 0
	BEGIN
		RAISERROR('#NotEnoughPermissions', 18, -1)
		RETURN 2
	END
	
	IF (@EmployeeID IS NULL) OR (@ProjectID IS NULL)
	BEGIN
		RAISERROR('#NotEnoughPermissions', 18, -1)
		RETURN 1
	END
	
	DECLARE @UserID TIdentifier,
			@oldManagerID TIdentifier,
			@CurrencyCode TCode3,
			@AssignmentState TState,
			@AssignmentID TIdentifier,
			@EmployeeName TName,
			@QualificationID TIdentifier,
			@StandardRate TMoney,
			@OvertimeRate TMoney,
			@rv int,
			@RightID int
			
	SET @RightID = dbo.adfGetRightID('ManageProject')
	SELECT @UserID = [UserID] FROM [Employee] WHERE [ID] = @EmployeeID
			
	IF NOT EXISTS(
		SELECT 
			*
		FROM
			[AccessRight] a INNER JOIN
			(SELECT 
				[UserRole].[RoleID]
			FROM
				[UserRole]
			WHERE
				[UserRole].[UserID] = @UserID) p 
			ON (a.[RightID] = @RightID AND a.[TrusteeID] = [p].[RoleID] AND [a].[Allow] = 1))
	BEGIN
		IF NOT EXISTS(
			SELECT 
				*
			FROM
				[AccessRight] a
			WHERE
				[a].[RightID]=@RightID AND [a].[TrusteeID]=@UserID AND [a].[Allow] = 1)
		BEGIN
			RAISERROR('#NotEnoughPermissionsForProjectAssign', 18, -1)
			RETURN 1
		END
	END

	SET @AssignmentState = dbo.adfwfGetInitialState('7797BD53-86CE-415E-9E13-B11BCBD52359')
	IF @AssignmentState IS NULL
	BEGIN
		RAISERROR('#accessdenied', 18, -1)
		RETURN 1
	END
			
	UPDATE [Project]
	SET 
		[ProjectManagerEmployeeID] = @EmployeeID,
		[ModifiedBy] = dbo.adfGetCurrentUserID(),
		[Modified] = GETDATE()
	WHERE 
		[ID] = @ProjectID
	IF @@ERROR != 0
	BEGIN
		RETURN 1
	END

	IF @AddToParticipants = 1 BEGIN
		DECLARE	@Xml Xml =
			'<Employee>
				<Assignments>
				</Assignments>
			</Employee>'
		
		 SET @Xml.modify('
		 insert <ID>{sql:variable("@EmployeeID")}</ID>
		 into (Employee/Assignments)[1]')

		 EXEC pjm6AssignmentsAdd @Xml = @Xml, @ProjectID = @ProjectID, @GetAssignment = 0
	END

	RETURN 0
GO

GRANT EXECUTE ON [pjm5ChangeProjectManager] TO PUBLIC
GO
 