IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[pjm5CreateProjectByTemplate]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	BEGIN
		PRINT 'Dropping procedure pjm5CreateProjectByTemplate'
		DROP PROCEDURE [dbo].[pjm5CreateProjectByTemplate]
	END
GO

PRINT 'Creating procedure pjm5CreateProjectByTemplate'
GO

/******************************************************************************
**		File: ProjectCreateByTemplate.sql
**		Name: pjm5CreateProjectByTemplate
**		Desc: this procedure automatically generated by Avicom.Adf.Generator
**
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**      ----------						-----------
**
**		Auth: Andrew.Maklakov
**		Date: 01/20/2005 11:01:32
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:		Description:
**		--------	--------	-------------------------------------------
**		26.03.10	SYV			  EnabledTasks
**		21.05.10	SYV		      [ExchangeSystemName]   	
**		15.06.10	KOV			  [FolderID]
**		13.11.10	SYV			  [GroupingAdvanceCalculations]
**		24.11.10	SYV			  [StatementCurrencyPoint]
**		22.04.11	SYV			    GroupCalculationLines, ShowActivityTypes
**								GroupingAdvanceCalculations  
**		14.07.11	SYV			 UseSubProjects
**		12.04.13	SOV			   FinanceManagement    ,
**								 OpenXml  Xml
**		21.02.13	MAB			  [GroupByProjects]
**		14.06.13	SAP			  @ParticipantsXML
**		19.06.13	SOV			        
**		25.06.13	SOV			       
**		01.07.13	SOV			         
**		04.07.13	SAP			  @SetBudgetForExecution
**		04.07.13	SOV			       
**								  
**		05.07.13	SOV			      
**		08.07.13	SAP			  @ManagerAssistantID, @FinanceManagerID, @FinanceManagerID
**		08.07.13	SOV			      
**		29.08.13	SAP			  -      
**								 AssignProjectManager
**		12.11.13	SAP			  ,        
**		21.04.14	BAO			     
**		09.06.14	SAP			   fnPjm5ShiftDate
**      05.08.14    VAV            , , ,  , 
**                                     
**		29.09.14	BAO			          
**		12.11.14	SAP			       
**		19.11.14	BAO			         
**								 (    )
**		29.01.15	SAP			      
*******************************************************************************/
CREATE PROCEDURE [pjm5CreateProjectByTemplate]
	@ID	TIdentifier,
	@StartDate TDateTime,
	@SupplierID TIdentifier,
	@ManagerID TIdentifier,
	@ManagerAssistantID TIdentifier,
	@FinanceManagerID TIdentifier,
	@CustomerID TIdentifier,
	@CustomerResponsiblePersonID TIdentifier,
	@CustomerFinanceManagerID  TIdentifier,
	@BookingXml XML,
	@EnabledTasks TBool,
	@CopyDataFromBudget		TBool		= 0,
	@Forced					TBool		= 1,
	@ParticipantsXML XML,
	@SetStateOpen bit,		--  ?
	@AssignTaskRequests bit, --  ?
	@SetBudgetForExecution bit, --   ?
	@ParentProjectID TIdentifier
AS
	SET NOCOUNT ON
	
	DECLARE @State TState,
			@NewProjectID TIdentifier,
			@NewProjectClass TClass = [dbo].[adfGetClassByName]('Pjm5.Project'),
			@TemplateClass TClass = [dbo].[adfGetClassByName]('Pjm5.ProjectTemplate'),
			@CategoryClass TClass = [dbo].[adfGetClassByName]('Adf.Category'),
			@CurrencyCode TCode3,
			@AssignmentState TState,
			@ServiceAssignmentState TState,
			@TaskState TState,
			@InvoiceState TState,
			@BaseDate TDateTime,
			@EmployeeName TName,
			@QualificationID TIdentifier,
			@StandardRate TMoney,
			@OvertimeRate TMoney,
			@ManagerAssignmentID TIdentifier,
			@ApplyVat int,
			@rv int,
			@InvoicePeriodType TCode,
			@InvoiceDayType TCode,
			@InvoiceNextPaymentDate TDate,
			@StatementPeriodType TCode,
			@StatementDayType TCode,
			@StatementNextPaymentDate TDate,
			@CalculationPeriodType TCode,
			@CalculationDayType TCode,
			@CalculationNextPaymentDate TDate,
			@CheckTaskWorkOverdraft TBool,
			@value TVariant,
			@InvoiceExpirationPeriodType TIdentifier,
			@InvoiceExpirationPeriod TCount,
			@StatementCurrencyPoint TIdentifier,
			@BudgetTemplateID TIdentifier,
			@UseBudgetPlanning TBool

			
			
	SET @State = dbo.adfwfGetInitialState('e64c30d7-1ade-4f9e-8bde-c35357ea6e8a')
	IF @State IS NULL
	BEGIN
		RAISERROR('#accessdenied', 18, -1)
		RETURN 1
	END
	
	SET @AssignmentState = dbo.adfwfGetInitialState('7797bd53-86ce-415e-9e13-b11bcbd52359')
	IF @AssignmentState IS NULL
	BEGIN
		RAISERROR('#accessdenied', 18, -1)
		RETURN 1
	END
	
	SET @ServiceAssignmentState = dbo.adfwfGetInitialState('8cece7ca-a901-42cc-bdb8-60b87a26cd1d')
	IF @ServiceAssignmentState IS NULL
	BEGIN
		RAISERROR('#accessdenied', 18, -1)
		RETURN 1
	END
	
	IF(@EnabledTasks = 1)
	BEGIN
		SET @TaskState = 8 --dbo.adfwfGetInitialState('1b62b9f6-1e1c-4f4d-95bc-41484b45741c')
		IF @TaskState IS NULL
		BEGIN
			RAISERROR('#accessdenied', 18, -1)
			RETURN 1
		END
	END
	
	SET @InvoiceState = dbo.adfwfGetInitialState('98b8f49e-202e-4b46-8074-421734078da6')
	IF @State IS NULL
	BEGIN
		RAISERROR('#accessdenied', 18, -1)
		RETURN 1
	END
		
	IF(@EnabledTasks = 1)
	BEGIN
		DECLARE @busyEntry TABLE ([TaskID] int, [AssignmentID] int, [Date] datetime, [Planned] int)
		INSERT INTO @busyEntry ([TaskID], [AssignmentID], [Date], [Planned])
		SELECT
			[XmlTable].value('TaskID[1]', 'int'),
			[XmlTable].value('AssignmentID[1]', 'int'),
			CAST([XmlTable].value('Date[1]', 'varchar(19)') AS datetime), 
			[XmlTable].value('Planned[1]', 'int')
		FROM
			@BookingXml.nodes('/Booking/BusyEntry') AS List(XmlTable)
	END

	SELECT
		@CurrencyCode = [Project].[CurrencyCode],
		@BaseDate = [Project].[Date],
		@InvoicePeriodType = [PaymentPeriod].[InvoicePeriodType],
		@InvoiceDayType = [PaymentPeriod].[InvoiceDayType],
		@InvoiceNextPaymentDate = [PaymentPeriod].[InvoiceNextPaymentDate],
		@StatementPeriodType = [PaymentPeriod].[StatementPeriodType],
		@StatementDayType = [PaymentPeriod].[StatementDayType],
		@StatementNextPaymentDate = [PaymentPeriod].[StatementNextPaymentDate],
		@CalculationPeriodType = [PaymentPeriod].[CalculationPeriodType],
		@CalculationDayType = [PaymentPeriod].[CalculationDayType],
		@CalculationNextPaymentDate = [PaymentPeriod].[CalculationNextPaymentDate],
		@BudgetTemplateID = [ProjectTemplate].[BudgetTemplateID]
	FROM
		[Project]
		INNER JOIN [PaymentPeriod]
			ON [PaymentPeriod].[ProjectID] = [Project].[ID]
		INNER JOIN [ProjectTemplate]
			ON [ProjectTemplate].[ID] = [Project].[ID]
	WHERE
		[Project].[ID] = @ID
		
	--      ,        
	SELECT @BudgetTemplateID = ISNULL(@BudgetTemplateID, [ID]) FROM [Budget] WHERE [DocumentID] = @ID

	DECLARE 
		@ShiftDays TCount,
		@VatRate TAmount
	SELECT 
		@ShiftDays = DATEDIFF(day, @BaseDate, @StartDate),
		@VatRate = CASE @ApplyVat
			WHEN 1 THEN dbo.fnPjm5GetVATRate()
			ELSE 0
			END

	EXEC adfParameterGet 'InvoiceExpirationPeriodType', 'Pjm5', @Value = @value OUTPUT
	SET @InvoiceExpirationPeriodType = ISNULL(CAST(@value as int), 0)
	
	EXEC adfParameterGet 'InvoiceExpirationPeriod', 'Pjm5', @Value = @value OUTPUT
	SET @InvoiceExpirationPeriod = ISNULL(CAST(@value as int), 0)

	EXEC adfParameterGet @Name='CheckTaskWorkOverdraft', @Group='Pjm6', @Value = @value OUTPUT
	SET @CheckTaskWorkOverdraft = ISNULL(CAST(@value as bit), 0)

	EXEC adfParameterGet @Name='StatementCurrencyPoint', @Group='CommonBusiness', @Value = @value OUTPUT
	SET @StatementCurrencyPoint = ISNULL(CAST(@value as bit), 0)

	EXEC adfParameterGet @Name='UseBudgetPlanning', @Group='Pjm6', @Value = @value OUTPUT
	SET @UseBudgetPlanning = CAST(@value as bit)

	BEGIN TRANSACTION
	
	
	INSERT INTO [Project]
		([State], [Flag], [Date], [Number], [FileAs], [ProjectTypeID],
		[SupplierCompanyID], [ProjectManagerEmployeeID], [CustomerCompanyID],
		[CustomerFinanceManagerID], [ResponsiblePersonEmployeeID],
		[PriorityID], 
		[ProjectLanguageCode],
		[CurrencyCode], [CostCenterID], [Budget],
		[ContractNumber], [ContractDate], [ContractEndDate], [ContractSubject], [ApplyVAT],
		[InvoiceExpirationPeriod], [InvoiceExpirationPeriodType],
		[WSSDocumentsURL], [Comments],[ContractComments], [RoundingInterval], [RoundingMode], [Billable],
		[SupportsRequestManagement], [RatesWithVAT],
		[PaymentCurrencyPoint], [InitialBalance], [BaseInitialBalance],
		[InvoiceCurrency], [StatementCurrency], [FactureCurrency], [Scale], [FolderID], [GroupCalculationLines],
		[CheckTaskWorkOverdraft], [ShowActivityTypes], [ExchangeSystemName],
		[GroupingAdvanceCalculations],
		[StatementCurrencyPoint], [ShowPrice], [UseSubProjects],
		[GroupByProjects]
		)
	SELECT
		@State,
		0,
		@StartDate,
		[Number],
		[FileAs],
		[ProjectTypeID],
		@SupplierID,
		dbo.adfGetCurrentEmployeeID(),
		@CustomerID,
		@CustomerFinanceManagerID,
		@CustomerResponsiblePersonID,
		[PriorityID],
		[ProjectLanguageCode],
		[CurrencyCode],
		[CostCenterID],
		[Budget],
		[ContractNumber],
		dbo.fnPjm5ShiftDate([ContractDate], @ShiftDays,1),
		CASE
			WHEN [ContractEndDate] IS NOT NULL THEN
				dbo.fnPjm5ShiftDate([ContractEndDate], @ShiftDays,1)
			ELSE [ContractEndDate]
		END,
		[ContractSubject],
		[ApplyVAT],
		@InvoiceExpirationPeriod,
		@InvoiceExpirationPeriodType,
		[WSSDocumentsURL],
		[Comments],
		[ContractComments],
		[RoundingInterval],
		[RoundingMode],
		[Billable],
		[SupportsRequestManagement],
		[RatesWithVAT],
		[PaymentCurrencyPoint],
		[InitialBalance],
		[BaseInitialBalance],
		[InvoiceCurrency],
		[StatementCurrency],
		[FactureCurrency], 
		[Scale],
		[FolderID],
		[GroupCalculationLines],
		@CheckTaskWorkOverdraft,
		[ShowActivityTypes],
		[ExchangeSystemName],
		[GroupingAdvanceCalculations],
		@StatementCurrencyPoint,
		[ShowPrice],
	    [UseSubProjects],
		[GroupByProjects]
	FROM
		[Project]
	WHERE
		[ID] = @ID
	IF @@ERROR != 0
	BEGIN
		ROLLBACK TRANSACTION
		RETURN 1
	END
	SET @NewProjectID = SCOPE_IDENTITY()

	INSERT INTO [ProjectDetail] 
		([ID], [DueDate],
		
		[DiscountTypeByTime],
		[DiscountViewByTime],
		[DiscountByTime],
				
		[DiscountTypeByExpense],
		[DiscountViewByExpense],
		[DiscountByExpense],
				
		[DiscountTypeByPhone],
		[DiscountViewByPhone],
		[DiscountByPhone],	
				
		[DiscountTypeByServiceRequest],
		[DiscountViewByServiceRequest],
		[DiscountByServiceRequest])
	SELECT
		@NewProjectID, 
		@StartDate,
		
		[DiscountTypeByTime],
		[DiscountViewByTime],
		[DiscountByTime],
				
		[DiscountTypeByExpense],
		[DiscountViewByExpense],
		[DiscountByExpense],
				
		[DiscountTypeByPhone],
		[DiscountViewByPhone],
		[DiscountByPhone],	
				
		[DiscountTypeByServiceRequest],
		[DiscountViewByServiceRequest],
		[DiscountByServiceRequest]
	FROM
		[ProjectDetail]
	WHERE
		[ID] = @ID
	IF @@ERROR != 0
	BEGIN
		ROLLBACK TRANSACTION
		RETURN 1
	END
	
	UPDATE
		[PaymentPeriod]
	SET
		[InvoicePeriodType] = @InvoicePeriodType,
		[InvoiceDayType] = @InvoiceDayType,
		[StatementPeriodType] = @StatementPeriodType,
		[StatementDayType] = @StatementDayType,
		[CalculationPeriodType] = @CalculationPeriodType,
		[CalculationDayType] = @CalculationDayType
	WHERE
		[ProjectID] = @NewProjectID
	IF @@ERROR != 0
	BEGIN
		ROLLBACK TRANSACTION
		RETURN 1
	END

	INSERT INTO [ProjectActivityType] ([ProjectID], [ActivityTypeID], [Billable], [Actively])
	SELECT @NewProjectID, [ActivityTypeID], [Billable], [Actively]
	FROM [ProjectActivityType] 
	WHERE[ProjectID] = @ID
	IF @@ERROR != 0
	BEGIN
		ROLLBACK TRANSACTION
		RETURN 1
	END
	
	INSERT INTO [ProjectExpenseCode] ([ProjectID], [ExpenseCodeID], [Billable], [Actively])
	SELECT @NewProjectID, [ExpenseCodeID], [Billable], [Actively]
	FROM [ProjectExpenseCode]
	WHERE [ProjectID] = @ID
	IF @@ERROR != 0
	BEGIN
		ROLLBACK TRANSACTION
		RETURN 1
	END
	
	DECLARE @inTemplateID INT, @inProjectID INT

	DECLARE @ParticipantTable TABLE
	(
		[AssignmentID] int,
		[EmployeeID] int,
		[QualificationID] int,
		[MappedEmployeeID] int,
		[ToDelete] bit	
	)
	
	--    ()     , 
	--       
	INSERT INTO @ParticipantTable
	SELECT
		[XmlTable].value('AssignmentID[1]', 'int'),
		[XmlTable].value('EmployeeID[1]', 'int'),
		[XmlTable].value('QualificationID[1]', 'int'),
		[XmlTable].value('MappedEmployeeID[1]', 'int'),
		[XmlTable].value('ToDelete[1]', 'int')
	FROM 
		@ParticipantsXML.nodes('ProjectParticipants/Participants') AS List(XmlTable)

	--          
	IF (@SetStateOpen = 1)
		EXEC pjm5ProjectChangeState @ID = @NewProjectID, @ToState = 2
	ELSE
	BEGIN
		SET @AssignTaskRequests = 0
		SET @SetBudgetForExecution = 0
	END

	-- Assignments
	DECLARE @assignmenttable TABLE ([InTemplateID] int, [InProjectID] int, [EmployeeID] int)
	DECLARE assignments CURSOR LOCAL FAST_FORWARD READ_ONLY FOR
		SELECT
			[vwAssignment].[ID],
			ISNULL([vwAssignment].[Flag], 0),
			[Employee].[FileAs],
			ISNULL([MappedEmployeeID],[Participants].[EmployeeID]),
			ISNULL([vwAssignment].[QualificationID], [Participants].[QualificationID]),
			ISNULL([StandardRate], [Rate].[Standard]),
			ISNULL([OvertimeRate], [Rate].[Overtime]),
			ISNULL([RateVisible], 0),
			ISNULL([Approver], 0),
			ISNULL([Administrator], 0),
			ISNULL([AlwaysUseRate], 0),
			ISNULL([ReceiveTaskStatusReports], 0),
			ISNULL([ReceiveIssueStatusReports], 0),
			[vwAssignment].[Comments],
			ISNULL([FinanceManagement], 0)
		FROM
			[vwAssignment]
			RIGHT JOIN (
				SELECT * FROM @ParticipantTable AS [P]
				WHERE [P].[EmployeeID] IS NULL OR 
					[P].[EmployeeID] NOT IN (
					SELECT [MappedEmployeeID] FROM @ParticipantTable WHERE [MappedEmployeeID] IS NOT NULL)
			) AS [Participants]
				ON [Participants].[AssignmentID] = [vwAssignment].[ID]
			LEFT JOIN [QualificationRate] AS [Rate]
				ON [Rate].[QualificationID] = ISNULL([vwAssignment].[QualificationID], [Participants].[QualificationID]) AND [CurrencyCode] = @CurrencyCode
			LEFT JOIN [Employee]
				ON  [Participants].[MappedEmployeeID] = [Employee].[ID] OR 
					([Participants].[EmployeeID] = [Employee].[ID] AND [Participants].[MappedEmployeeID] IS NULL)
		WHERE
			[ToDelete] != 1

	OPEN assignments
	DECLARE 
		@assflag TFlag,
		@assfileas TName, @assemployeeID TIdentifier,
		@assqualificationID TIdentifier, @assstandardRate TMoney,
		@assovertimeRate TMoney, @assratevisible TBool,
		@assapprover TBool,	@assadministrator TBool, @taskreport TBool,
		@issuereport TBool, @asscomments TNotes, @AlwaysUseRate TBool,
		@assFinanceManagement TBool
	
	FETCH NEXT FROM assignments INTO @inTemplateID, @assflag, @assfileas, @assemployeeID,
		@assqualificationID, @assstandardRate, @assovertimeRate, @assratevisible,
		@assapprover, @assadministrator, @AlwaysUseRate, @taskreport, @issuereport, @asscomments, @assFinanceManagement
	WHILE @@FETCH_STATUS = 0
	BEGIN
		EXEC @rv = pjm5AssignmentCreateInternal
			@ID = @inProjectID OUTPUT,
			@Flag = @assflag,
			@State = @AssignmentState,
			@FileAs = @assfileas,
			@EmployeeID = @assemployeeid,
			@ProjectID = @NewProjectID,
			@QualificationID = @assqualificationID,
			@StandardRate = @assstandardRate,
			@OvertimeRate = @assovertimeRate,
			@RateVisible = @assratevisible,
			@Approver = @assapprover,
			@Administrator = @assadministrator,
			@FinanceManagement = @assFinanceManagement,
			@TaskReport = @taskreport,
			@IssueReport = @issuereport,
			@Comments = @asscomments,
			@AlwaysUseRate = @AlwaysUseRate
			
		IF @@ERROR != 0 OR @rv != 0
		BEGIN
			ROLLBACK TRANSACTION
			RETURN 1
		END

		INSERT INTO @assignmenttable ([InTemplateID], [InProjectID], [EmployeeID])
			VALUES(@inTemplateID, @inProjectID, @assemployeeid)
		IF @@ERROR != 0
		BEGIN
			ROLLBACK TRANSACTION
			RETURN 1
		END
		
		FETCH NEXT FROM assignments INTO @inTemplateID, @assflag, @assfileas, @assemployeeID,
			@assqualificationID, @assstandardRate, @assovertimeRate, @assratevisible,
			@assapprover, @assadministrator, @AlwaysUseRate, @taskreport, @issuereport, 
			@asscomments, @assFinanceManagement
	END
	CLOSE assignments
	DEALLOCATE assignments

	-- ServiceAssignments
	DECLARE @services TABLE ([InTemplateID] int, [InProjectID] int)
	DECLARE service CURSOR LOCAL FAST_FORWARD READ_ONLY FOR
		SELECT [ID] 
		FROM [ServiceAssignment] 
		WHERE [ServiceAssignment].[ProjectID] = @ID
	OPEN service
	FETCH NEXT FROM service INTO @inTemplateID
	WHILE @@FETCH_STATUS = 0
	BEGIN
		INSERT INTO [ServiceAssignment]
			([Flag], [State], [FileAs], 
			[ProjectID], [ServiceID], 
			[RateMultiplier], [Price], [VATIsIncluded],
			[PaymentTermID],
			[Comments], [ContractAddendumID],
			[ServiceTypeID])
		SELECT
			[Flag],
			@ServiceAssignmentState,
			[FileAs],
			@NewProjectID,
			[ServiceID],
			[RateMultiplier],
			[Price],
			[VATIsIncluded],
			[PaymentTermID],
			[Comments],
			[ContractAddendumID],
			[ServiceTypeID]
		FROM
			[ServiceAssignment]
		WHERE
			[ID] = @inTemplateID
		IF @@ERROR != 0
		BEGIN
			ROLLBACK TRANSACTION
			RETURN 1
		END
		SET @inProjectID = SCOPE_IDENTITY()

		INSERT INTO @services ([InTemplateID], [InProjectID]) 
		VALUES (@inTemplateID, @inProjectID)
		IF @@ERROR != 0
		BEGIN
			ROLLBACK TRANSACTION
			RETURN 1
		END
		FETCH NEXT FROM service INTO @inTemplateID
	END
	CLOSE service
	DEALLOCATE service

	-- Invoices
	DECLARE @invoices TABLE ([InTemplateID] int,[InProjectID] int)
	DECLARE invoice CURSOR LOCAL FAST_FORWARD READ_ONLY FOR
		SELECT [ID] FROM [Invoice] WHERE [Invoice].[ProjectID] = @ID

	OPEN invoice
	FETCH NEXT FROM invoice INTO @inTemplateID
	WHILE @@FETCH_STATUS = 0
	BEGIN
		INSERT INTO [Invoice]
			([Flag], [State], [Date], [Number], [FileAs], 
			[ProjectID], 
			[SupplierBankAccountID],
			[CurrencyRate], [CurrencyCode], [Comments])
		SELECT
			[Flag],
			@InvoiceState,
			dbo.fnPjm5ShiftDate([Date], @ShiftDays,1),
			[Number],
			[FileAs],
			@NewProjectID,
			[SupplierBankAccountID],
			[CurrencyRate],
			[CurrencyCode],
			[Comments]
		FROM
			[Invoice]
		WHERE
			[ID] = @inTemplateID
		IF @@ERROR != 0
		BEGIN
			ROLLBACK TRANSACTION
			RETURN 1
		END
		SET @InProjectID = SCOPE_IDENTITY()

		INSERT INTO @invoices ([InTemplateID], [InProjectID]) VALUES(@inTemplateID, @inProjectID)
		IF @@ERROR != 0
		BEGIN
			ROLLBACK TRANSACTION
			RETURN 1
		END
		FETCH NEXT FROM invoice INTO @inTemplateID
	END
	CLOSE invoice
	DEALLOCATE invoice
	
	INSERT INTO [InvoiceLine] (
		[InvoiceID], 
		[DocumentClass], 
		[DocumentID], 
		[Description], 
		[Amount], 
		[Price],
		[VAT],
		[VATRate],
		[VATIsIncluded])
	SELECT
		t.[InProjectID],
		l.[DocumentClass],
		s.[InProjectID],
		l.[Description],
		l.[Amount],
		l.[Price],
		l.[VAT],
		l.[VATRate],
		l.[VATIsIncluded]
	FROM
		[Invoice] i
		INNER JOIN [InvoiceLine] l
			ON i.[ID] = l.[InvoiceID]
		INNER JOIN @invoices t
			ON l.[InvoiceID] = t.[inTemplateID]
		LEFT OUTER JOIN [ServiceAssignment]
			ON [ServiceAssignment].[Class] = l.[DocumentClass] AND [ServiceAssignment].[ID] = l.[DocumentID]
		LEFT OUTER JOIN @services s
			ON [ServiceAssignment].[ID] = s.[InTemplateID]
	WHERE
		i.[ProjectID] = @ID
	IF @@ERROR != 0
	BEGIN
		ROLLBACK TRANSACTION
		RETURN 1
	END

	-- Tasks
	IF(@EnabledTasks = 1 AND (@UseBudgetPlanning = 0 OR (@UseBudgetPlanning = 1 AND @BudgetTemplateID IS NULL)))
	BEGIN
		DECLARE @inProjectTaskStartDate datetime,
				@inProjectTaskDueDate datetime,
				@TaskDuration TAmount
		DECLARE tasks CURSOR LOCAL FAST_FORWARD READ_ONLY FOR
		SELECT [ID], CAST([Duration] as decimal(18,4)) FROM [Task] WHERE [Task].[ProjectID] = @ID

		OPEN tasks
		FETCH NEXT FROM tasks INTO @inTemplateID, @TaskDuration
		WHILE @@FETCH_STATUS = 0
		BEGIN
			SELECT @inProjectTaskStartDate = MIN([Date]) FROM @busyEntry WHERE [TaskID] = @inTemplateID
			IF @inProjectTaskStartDate IS NULL
				SELECT @inProjectTaskStartDate = dbo.fnPjm5ShiftDate([StartDate], @ShiftDays,1) FROM [Task] WHERE [ID] = @inTemplateID
			SELECT @inProjectTaskDueDate = dbo.fnPjm5AddWorkingDays(@inProjectTaskStartDate, @TaskDuration)
			
			INSERT INTO [Task]
				([State], [Flag], [FileAs], [ProjectID], 
				[PriorityID], 
				[StartDate], [DueDate], [EndDate], [Duration], 
				[ManHour], [Budget],
				[PercentComplete], 
				[Milestone], [SendStatusReport], 
				[Comments])
			SELECT
				@TaskState,
				[Flag],
				[FileAs],
				@NewProjectID,
				[PriorityID], 
				@inProjectTaskStartDate, @inProjectTaskDueDate, NULL, [Duration],
				[ManHour], [Budget],
				CAST([PercentComplete] as decimal(5, 2)) / CAST(100 as decimal(5, 2)),
				[Milestone], [SendStatusReport],
				[Comments] 
			FROM
				[Task]
			WHERE
				[ID] = @inTemplateID
			IF @@ERROR != 0
			BEGIN
				ROLLBACK TRANSACTION
				RETURN 1
			END
			SET @inProjectID = SCOPE_IDENTITY()
			
			DECLARE @TaskIndex TCount, @Wbs TName
			SELECT @TaskIndex =	[TaskIndex], @Wbs = [Wbs] FROM [TaskWbs] WHERE [TaskID] = @inTemplateID
			UPDATE [TaskWbs] SET [TaskIndex] = @TaskIndex, [Wbs] = @Wbs WHERE [TaskID] = @inProjectID
			IF @@ERROR != 0
			BEGIN
				ROLLBACK TRANSACTION
				RETURN 1
			END
			
			INSERT INTO [TaskAssignment] ([TaskID], [AssignmentID], [Units], [Work], [RemainingWork])
			SELECT  @inProjectID, [A].[InProjectID],
					[TaskAssignment].[Units],
					[TaskAssignment].[Work],
					[TaskAssignment].[Work]
			FROM
				[TaskAssignment]
				INNER JOIN @assignmenttable AS [A]
					ON [TaskAssignment].[AssignmentID] = [A].[InTemplateID]
			WHERE
				[TaskAssignment].[TaskID] = @inTemplateID
			IF @@ERROR != 0
			BEGIN
				ROLLBACK TRANSACTION
				RETURN 1
			END
			
			INSERT INTO [BusyEntry] ([ProjectID], [TaskID], [AssignmentID], [Date], [EmployeeID], [Planned], [Committed])
			SELECT
				@NewProjectID,
				@inProjectID,
				[a].[InProjectID],
				[b].[Date],
				[vwAssignment].[EmployeeID],
				[b].[Planned],
				0
			FROM 
				@busyEntry AS [b]
				INNER JOIN @assignmenttable [a]
					ON [a].[InTemplateID] = [b].[AssignmentID]
				LEFT OUTER JOIN [vwAssignment]
					ON [vwAssignment].[ID] = [a].[InProjectID]
			WHERE
				[b].[TaskID] = @inTemplateID
			IF @@ERROR != 0
			BEGIN
				ROLLBACK TRANSACTION
				RETURN 1
			END

			FETCH NEXT FROM tasks INTO @inTemplateID, @TaskDuration
		END

		CLOSE tasks
		DEALLOCATE tasks
	END
	
	--TaskRequest
	DECLARE @TRXml						XML,
			@TRError					bit,
			@TRFileAs					TName,
			@TREmployeeID				TIdentifier,
			@TRSupervisorEmployeeID		TIdentifier,
			@TRPriorityID				TIdentifier,
			@TRDueTime					TDateTime,
			@TRStartTime				TDateTime,
			@TRSendStatusReport			TBool,
			@TRTaskRequestStatusID		TIdentifier,
			@TRDocumentEditAccess		TBool,
			@TRComments					TNotes,
			@TRManHour					TCount,
			@TRBudget					TMoney,
			@TRAssEmployeeID			TIdentifier,
			@TRAssAssignmentID			TIdentifier,
			@TRID						TIdentifier,

			@TRCreatedID TIdentifier,
			@TRClass TClass = [dbo].[adfGetClassByName]('Pjm5.TaskRequest')
			

	DECLARE
		@TRCategories TABLE
		(
			[CategoryID] TIdentifier
		)
	DECLARE
		@TRContacts TABLE
		(
			[BusinessCardClass] TClass,
			[BusinessCardID] TIdentifier
		)
	DECLARE
		@TRAttachments TABLE
		(
			[AttachmentID] TIdentifier,
			[AttachmentTypeID] TIdentifier,
			[Name] TName,
			[LinkDocumentClass] TClass null,
			[LinkDocumentID] TIdentifier null
		)

	DECLARE
		@TRTempCategoryID TIdentifier,

		@TRTempBusinessCardClass TClass,
		@TRTempBusinessCardID TIdentifier,

		@TRTempAttachmentID TIdentifier,
		@TRTempAttachmentTypeID TIdentifier,
		@TRTempName TName,
		@TRTempLinkDocumentClass TClass,
		@TRTempLinkDocumentID TIdentifier

	--            
	DECLARE taskrequest_cursor CURSOR LOCAL FAST_FORWARD READ_ONLY FOR
	SELECT
		[ID],
		[FileAs],
		[A].[EmployeeID],
		[B].[EmployeeID],
		[PriorityID],
		dbo.fnPjm5ShiftDate([DueTime], @ShiftDays,0),
		dbo.fnPjm5ShiftDate([StartTime], @ShiftDays,0),
		[SendStatusReport],
		[TaskRequestStatusID],
		[DocumentEditAccess],
		[Comments],
		[ManHour],
		[Budget]
	FROM
		[TaskRequest]
		--        
		LEFT JOIN @assignmenttable AS [A]
			ON [TaskRequest].[AssignmentID] = [A].[InTemplateID]
		LEFT JOIN @assignmenttable AS [B]
			ON [TaskRequest].[SupervisorAssignmentID] = [B].[InTemplateID]
	WHERE
		[ProjectID] = @ID			
	
	DECLARE 
		@ReminderInterval int, 
		@UserID int, 
		@ReminderState nvarchar(5)

	SET @UserID = dbo.adfGetCurrentUserID()		
			
	SELECT 
		@ReminderState = 
		CASE 
			WHEN [ReminderSetting].[InitialState] = 0
			THEN 'false'
			ELSE 'true'
		END,
		@ReminderInterval = [ReminderSetting].[InitialInterval]
	FROM 
		[ReminderSetting]
	WHERE 
		[ReminderSetting].[UserID] = @UserID AND
			[ReminderSetting].[Subtype] = 'RD'
	
	SELECT
		@ReminderState = ISNULL(@ReminderState,'true'),
		@ReminderInterval = ISNULL(@ReminderInterval,60)

	OPEN taskrequest_cursor
	FETCH NEXT FROM taskrequest_cursor INTO @TRID, @TRFileAs, @TREmployeeID,
		@TRSupervisorEmployeeID, @TRPriorityID,
		@TRDueTime,	@TRStartTime, @TRSendStatusReport, @TRTaskRequestStatusID,
		@TRDocumentEditAccess, @TRComments, @TRManHour, @TRBudget
			
	WHILE @@FETCH_STATUS = 0
	BEGIN
		SET @TRXml = CONVERT(xml,N'
		<pjm5TaskRequestGet>
			<TaskRequest>				
				<PercentComplete>0</PercentComplete>
			</TaskRequest>
		</pjm5TaskRequestGet>')

		
		SET @TRXml.modify('
		insert <ReminderState>{sql:variable("@ReminderState")}</ReminderState>
		into (/pjm5TaskRequestGet/TaskRequest)[1]
		')
		SET @TRXml.modify('
		insert <ReminderInterval>{sql:variable("@ReminderInterval")}</ReminderInterval>
		into (/pjm5TaskRequestGet/TaskRequest)[1]
		')		
		SET @TRXml.modify('
		insert <FileAs>{sql:variable("@TRFileAs")}</FileAs>
		into (/pjm5TaskRequestGet/TaskRequest)[1]
		')
		SET @TRXml.modify('
		insert <ProjectID>{sql:variable("@NewProjectID")}</ProjectID>
		into (/pjm5TaskRequestGet/TaskRequest)[1]
		')

		IF (@TREmployeeID IS NOT NULL)
			SET @TRXml.modify('
			insert <EmployeeID>{sql:variable("@TREmployeeID")}</EmployeeID>
			into (/pjm5TaskRequestGet/TaskRequest)[1]
			')
		
		IF (@TRSupervisorEmployeeID IS NOT NULL)
			SET @TRXml.modify('
			insert <SupervisorEmployeeID>{sql:variable("@TRSupervisorEmployeeID")}</SupervisorEmployeeID>
			into (/pjm5TaskRequestGet/TaskRequest)[1]
			')

		SET @TRXml.modify('
		insert <PriorityID>{sql:variable("@TRPriorityID")}</PriorityID>
		into (/pjm5TaskRequestGet/TaskRequest)[1]
		')
		SET @TRXml.modify('
		insert <DueTime>{sql:variable("@TRDueTime")}</DueTime>
		into (/pjm5TaskRequestGet/TaskRequest)[1]
		')
		SET @TRXml.modify('
		insert <StartTime>{sql:variable("@TRStartTime")}</StartTime>
		into (/pjm5TaskRequestGet/TaskRequest)[1]
		')
		SET @TRXml.modify('
		insert <SendStatusReport>{sql:variable("@TRSendStatusReport")}</SendStatusReport>
		into (/pjm5TaskRequestGet/TaskRequest)[1]
		')
		SET @TRXml.modify('
		insert <TaskRequestStatusID>{sql:variable("@TRTaskRequestStatusID")}</TaskRequestStatusID>
		into (/pjm5TaskRequestGet/TaskRequest)[1]
		')
		SET @TRXml.modify('
		insert <DocumentEditAccess>{sql:variable("@TRDocumentEditAccess")}</DocumentEditAccess>
		into (/pjm5TaskRequestGet/TaskRequest)[1]
		')
		SET @TRXml.modify('
		insert <Comments>{sql:variable("@TRComments")}</Comments>
		into (/pjm5TaskRequestGet/TaskRequest)[1]
		')
		SET @TRXml.modify('
		insert <ManHour>{sql:variable("@TRManHour")}</ManHour>
		into (/pjm5TaskRequestGet/TaskRequest)[1]
		')
		SET @TRXml.modify('
		insert <Budget>{sql:variable("@TRBudget")}</Budget>
		into (/pjm5TaskRequestGet/TaskRequest)[1]
		')
		
		--      
		DECLARE taskrequest_assignment_cursor CURSOR LOCAL FAST_FORWARD READ_ONLY FOR
		SELECT
			[AssignmentID],
			ISNULL([TR].[EmployeeID], [A].[EmployeeID])
		FROM
			[TaskRequestAssignment] AS [TR]
			INNER JOIN @assignmenttable AS [A]
				ON [A].[InTemplateID] = [AssignmentID]
		WHERE
			[TaskRequestID] = @TRID
		OPEN taskrequest_assignment_cursor
		
		FETCH NEXT FROM taskrequest_assignment_cursor INTO @TRAssAssignmentID, @TRAssEmployeeID
		WHILE @@FETCH_STATUS = 0
		BEGIN
			SET @TRXml.modify('
			insert <TaskRequestAssignment>
						<PercentComplete>0</PercentComplete>
						<Accepted>false</Accepted>
						<EmployeeID>{sql:variable("@TRAssEmployeeID")}</EmployeeID>
						<AssignmentID>{sql:variable("@TRAssAssignmentID")}</AssignmentID>
					</TaskRequestAssignment>
			into (/pjm5TaskRequestGet)[1]
			')
			
			FETCH NEXT FROM taskrequest_assignment_cursor INTO @TRAssAssignmentID, @TRAssEmployeeID
		END
		CLOSE taskrequest_assignment_cursor
		DEALLOCATE taskrequest_assignment_cursor
		
		EXEC @TrError = pjm5TaskRequestCreate @TRXml, 0,
			@AssignTaskRequests, @TRCreatedID OUTPUT
		
		IF @TrError != 0
		BEGIN
			ROLLBACK TRANSACTION
			RETURN 1
		END

--/////////////////////////////////////////////////////////////////////////////////////////////////////
		--      
		INSERT INTO @TRCategories
		SELECT
			[CategoryID]
		FROM
			[DocumentCategory]
		WHERE
			[DocumentClass] = @TRClass
			AND
			[DocumentID] = @TRID

		DECLARE taskrequest_category_cursor CURSOR LOCAL FAST_FORWARD FOR
		SELECT
			[CategoryID]
		FROM
			@TRCategories

		OPEN taskrequest_category_cursor
		
		FETCH NEXT FROM taskrequest_category_cursor INTO @TRTempCategoryID
		WHILE @@FETCH_STATUS = 0
		BEGIN
			
			INSERT INTO [DocumentCategory]
			SELECT
				@TRClass,
				@TRCreatedID,
				@TRTempCategoryID
			
			
			IF @@ERROR != 0
			BEGIN
				ROLLBACK TRANSACTION
				RETURN 1
			END

			FETCH NEXT FROM taskrequest_category_cursor INTO @TRTempCategoryID
		END
		CLOSE taskrequest_category_cursor
		DEALLOCATE taskrequest_category_cursor
			

		DELETE FROM @TRCategories


		--      
		INSERT INTO @TRContacts
		SELECT
			[BusinessCardClass],
			[BusinessCardID]
		FROM
			[DocumentContact]
		WHERE
			[DocumentClass] = @TRClass
			AND
			[DocumentID] = @TRID

		DECLARE taskrequest_contact_cursor CURSOR LOCAL FAST_FORWARD FOR
		SELECT
			[BusinessCardClass],
			[BusinessCardID]
		FROM
			@TRContacts

		OPEN taskrequest_contact_cursor

		FETCH NEXT FROM taskrequest_contact_cursor INTO @TRTempBusinessCardClass, @TRTempBusinessCardID
		WHILE @@FETCH_STATUS = 0
		BEGIN
			
			INSERT INTO [DocumentContact]
			SELECT
				@TRClass,
				@TRCreatedID,
				@TRTempBusinessCardClass,
				@TRTempBusinessCardID
			
			
			IF @@ERROR != 0
			BEGIN
				ROLLBACK TRANSACTION
				RETURN 1
			END

			FETCH NEXT FROM taskrequest_contact_cursor INTO @TRTempBusinessCardClass, @TRTempBusinessCardID
		END
		CLOSE taskrequest_contact_cursor
		DEALLOCATE taskrequest_contact_cursor

		DELETE FROM @TRContacts


		--      
		INSERT INTO @TRAttachments
		SELECT
			[ID],
			[AttachmentTypeID],
			[Name],
			[LinkDocumentClass],
			[LinkDocumentID]
		FROM
			[Attachment]
		WHERE
			[DocumentClass] = @TRClass
			AND
			[DocumentID] = @TRID


		DECLARE taskrequest_attachment_cursor CURSOR LOCAL FAST_FORWARD FOR
		SELECT
			[AttachmentID],
			[AttachmentTypeID],
			[Name],
			[LinkDocumentClass],
			[LinkDocumentID]
		FROM
			@TRAttachments

		OPEN taskrequest_attachment_cursor

		FETCH NEXT FROM taskrequest_attachment_cursor INTO @TRTempAttachmentID, @TRTempAttachmentTypeID, @TRTempName, @TRTempLinkDocumentClass, @TRTempLinkDocumentID
		WHILE @@FETCH_STATUS = 0
		BEGIN
			
			INSERT INTO [Attachment] ([DocumentClass],[DocumentID],[AttachmentTypeID],[Name],[LinkDocumentClass],[LinkDocumentID],[Value])
			VALUES(@TRClass,@TRCreatedID,@TRTempAttachmentTypeID,@TRTempName,@TRTempLinkDocumentClass,@TRTempLinkDocumentID, (SELECT [Value] FROM [Attachment] WHERE [ID] = @TRTempAttachmentID))
					
			
			IF @@ERROR != 0
			BEGIN
				ROLLBACK TRANSACTION
				RETURN 1
			END

			FETCH NEXT FROM taskrequest_attachment_cursor INTO @TRTempAttachmentID, @TRTempAttachmentTypeID, @TRTempName, @TRTempLinkDocumentClass, @TRTempLinkDocumentID
		END
		CLOSE taskrequest_attachment_cursor
		DEALLOCATE taskrequest_attachment_cursor

		DELETE FROM @TRAttachments
		
		FETCH NEXT FROM taskrequest_cursor INTO @TRID, @TRFileAs, @TREmployeeID,
			@TRSupervisorEmployeeID, @TRPriorityID,
			@TRDueTime,	@TRStartTime, @TRSendStatusReport, @TRTaskRequestStatusID,
			@TRDocumentEditAccess, @TRComments, @TRManHour, @TRBudget
	END
	CLOSE taskrequest_cursor
	DEALLOCATE taskrequest_cursor

	-- Budget

	IF @UseBudgetPlanning = 1 AND @BudgetTemplateID IS NOT NULL
	BEGIN
		DECLARE
			@BudgetType			TIdentifier,
			@PeriodStart		TDate,
			@PeriodEnd			TDate,
			@Now				TDate

		SELECT
			@BudgetType = [BudgetTypeID]
		FROM
			[Budget]
		WHERE
			[Budget].[ID] = @BudgetTemplateID

		IF @BudgetType = 1
		BEGIN
			EXEC @rv = pjm6BudgetCreateByTemplate @NewProjectID, @BudgetTemplateID, 0, 0, NULL, NULL, NULL, NULL, NULL, @CopyDataFromBudget, @Forced, @ParticipantsXML,
				@SetBudgetForExecution
			IF @@ERROR != 0 OR @rv != 0
			BEGIN
				ROLLBACK TRANSACTION
				RETURN 1
			END
		END
		ELSE
		BEGIN
			SET @Now = GETDATE()
			EXEC @rv = Pjm6GetCurrentPeriod @Now, @BudgetType, @PeriodStart = @PeriodStart OUTPUT, @PeriodEnd = @PeriodEnd OUTPUT
			IF @@ERROR != 0 OR @rv != 0
			BEGIN
				ROLLBACK TRANSACTION
				RETURN 1
			END
			EXEC @rv = pjm6BudgetCreateByTemplate @NewProjectID, @BudgetTemplateID, 0, 0, @PeriodStart, @PeriodEnd, @BudgetType, NULL, 0, @CopyDataFromBudget, @Forced,
				@ParticipantsXML, @SetBudgetForExecution
			IF @@ERROR != 0 OR @rv != 0
			BEGIN
				ROLLBACK TRANSACTION
				RETURN 1
			END
		END
	END

	--    : - , . -  . -
	DECLARE @Error int
	
	BEGIN TRY
		EXEC @Error = pjm5ChangeProjectManager @NewProjectID, @ManagerID
	END TRY
	BEGIN CATCH		
		IF @Error = 1
		BEGIN
			ROLLBACK TRANSACTION
			RETURN 1
		END
	END CATCH
	
	IF @FinanceManagerID IS NOT NULL
	BEGIN
		EXEC @Error = pjm7ChangeFinanceManager @NewProjectID, @FinanceManagerID
		
		IF @Error != 0
		BEGIN
			ROLLBACK TRANSACTION
			RETURN 1
		END
	END
	
	IF @ManagerAssistantID IS NOT NULL
	BEGIN
		EXEC @Error = pjm7ChangeManagerAssistant @NewProjectID, @ManagerAssistantID
		
		IF @Error != 0
		BEGIN
			ROLLBACK TRANSACTION
			RETURN 1
		END
	END	
	
	--       
	;
	WITH [TemplateAttachments](
		[ID],
		[AttachmentTypeID],
		[Name],
		[LinkDocumentClass],
		[LinkDocumentID])
	AS 
	(
		SELECT
			[ID],
			[AttachmentTypeID],
			[Name],
			[LinkDocumentClass],
			[LinkDocumentID]
		FROM
			[Attachment]
		WHERE
			[DocumentClass] = @TemplateClass
			AND
			[DocumentID] = @ID
    )
    INSERT INTO [Attachment] 
    (
		[DocumentClass],
		[DocumentID],
		[AttachmentTypeID],
		[Name],
		[LinkDocumentClass],
		[LinkDocumentID],
		[Value]
	)
    SELECT 
       	@NewProjectClass,@NewProjectID,
		[TemplateAttachments].[AttachmentTypeID],
		[TemplateAttachments].[Name],
		[TemplateAttachments].[LinkDocumentClass],
		[TemplateAttachments].[LinkDocumentID],
		(SELECT [Value] FROM [Attachment] WHERE [ID] = [TemplateAttachments].[ID])
	FROM
		[TemplateAttachments]
	
	--       
	;
	WITH [TemplateContacts](
		[BusinessCardClass],
		[BusinessCardID])
	AS 
	(
		SELECT
			[BusinessCardClass],
			[BusinessCardID]
		FROM
			[DocumentContact]
		WHERE
			[DocumentClass] = @TemplateClass
			AND
			[DocumentID] = @ID
    )
    INSERT INTO [DocumentContact] 
    (
		[DocumentClass],
		[DocumentID],
		[BusinessCardClass],
		[BusinessCardID]
	)
    SELECT 
       	@NewProjectClass,@NewProjectID,
		[BusinessCardClass],
		[BusinessCardID]
	FROM
		[TemplateContacts]
		
	--       
	;
	WITH [TemplateCategories](
		[CategoryID])
	AS 
	(
		SELECT
			[CategoryID]
		FROM
			[DocumentCategory]
		WHERE
			[DocumentClass] = @TemplateClass
			AND
			[DocumentID] = @ID
    )
    INSERT INTO [DocumentCategory] 
    (
		[DocumentClass],
		[DocumentID],
		[CategoryID]
	)
    SELECT 
       	@NewProjectClass,@NewProjectID,
		[CategoryID]
	FROM
		[TemplateCategories]
	;	
	
    --        
	WITH [TemplateNoProjectProperty]
	AS
	(
		SELECT 
			[Name],[Type],[Format]
		FROM 
			[PropertyValue]
		INNER JOIN 
			[Property]
		ON 
			[PropertyValue].[PropertyId] = [Property].[ID]
		WHERE
			[PropertyValue].[DocumentClass] = @TemplateClass
		AND
			[PropertyValue].[DocumentID] = @ID		
		AND NOT ([Property].[Name] IN (
			SELECT
				[Name]
			FROM
				[Property]
			WHERE
				[Class] = @NewProjectClass
				))
	)
	INSERT INTO 
		[Property] ([Class],[Name],[Type],[Format])
	SELECT 
		@NewProjectClass,[Name],[Type],[Format]
	FROM 
		[TemplateNoProjectProperty]
	;
	WITH [TemplateNoProjectPropertyGlobal]
	AS (
		SELECT 
			[Property].[ID],
			[Property].[Name],
			[Property].[Format]
		FROM 
			[Property]
		LEFT OUTER JOIN
			[PropertyGlobal]
		ON 
			[Property].[ID] = [PropertyGlobal].[ID]
		WHERE
			[PropertyGlobal].[Name] IS NULL
	)
	INSERT INTO 
		[PropertyGlobal] ([ID],[Language],[Name],[Format])
	SELECT 
		[ID],
		'ru',
		[Name],
		[Format]
	FROM
		[TemplateNoProjectPropertyGlobal]
	;
	WITH [TemplateProperty]
	AS
	(
		SELECT 
			[ID],
			[Class],
			[Name],
			[Type],
			[Format],
			[Value]
		FROM 
			[PropertyValue]
		INNER JOIN
			[Property]
		ON
			[PropertyId] = [ID]
		WHERE
			[DocumentClass] = @TemplateClass
			AND
			[DocumentID] = @ID
			AND
			[Value] IS NOT NULL			
	)
	INSERT INTO [PropertyValue] ([DocumentClass],[DocumentID],[PropertyID],[Value])
	SELECT
		@NewProjectClass,
		@NewProjectID,
		(SELECT	
			[ID]
		FROM
			[Property]
		WHERE
			[Class] = @NewProjectClass
			AND
			[Property].[Name] = [TemplateProperty].[Name]
		),
		[TemplateProperty].[Value]
	FROM
		[TemplateProperty]
	;
	
	--         
	UPDATE [ProjectDetail]
	SET
		[ProjectDetail].[DiscountTypeByTime] = [PD].[DiscountTypeByTime],
		[ProjectDetail].[DiscountViewByTime] = [PD].[DiscountViewByTime],
		[ProjectDetail].[DiscountByTime] = [PD].[DiscountByTime],
		[ProjectDetail].[DiscountTypeByExpense] = [PD].[DiscountTypeByExpense],
		[ProjectDetail].[DiscountViewByExpense] = [PD].[DiscountViewByExpense],
		[ProjectDetail].[DiscountByExpense] = [PD].[DiscountByExpense],
		[ProjectDetail].[DiscountTypeByPhone] = [PD].[DiscountTypeByPhone],
		[ProjectDetail].[DiscountViewByPhone] = [PD].[DiscountViewByPhone],
		[ProjectDetail].[DiscountByPhone] = [PD].[DiscountByPhone],
		[ProjectDetail].[DiscountTypeByServiceRequest] = [PD].[DiscountTypeByServiceRequest],
		[ProjectDetail].[DiscountViewByServiceRequest] = [PD].[DiscountViewByServiceRequest],
		[ProjectDetail].[DiscountByServiceRequest] = [PD].[DiscountByServiceRequest] 
	FROM
		(SELECT 	
		[ID],
		[DiscountTypeByTime],[DiscountViewByTime],[DiscountByTime],
		[DiscountTypeByExpense],[DiscountViewByExpense],[DiscountByExpense],
		[DiscountTypeByPhone],[DiscountViewByPhone],[DiscountByPhone],
		[DiscountTypeByServiceRequest],[DiscountViewByServiceRequest],[DiscountByServiceRequest] 
		FROM [ProjectDetail]) AS [PD]
	WHERE
		[ProjectDetail].[ID] = @NewProjectID
		AND
		[PD].[ID] = @ID
	
	
	COMMIT TRANSACTION

	IF(@ParentProjectID IS NOT NULL)
	BEGIN
		exec pjm6SubProjectInsert @ParentProjectID, @NewProjectID
	END

	SELECT @NewProjectID AS [ID]
	
	RETURN 0
	
GO

GRANT EXECUTE ON pjm5CreateProjectByTemplate TO PUBLIC
GO
 