﻿IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[pjm7SubProjectCreate]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	BEGIN
		PRINT 'Dropping procedure pjm7SubProjectCreate'
		DROP PROCEDURE [dbo].[pjm7SubProjectCreate]
	END
GO

PRINT 'Creating procedure pjm7SubProjectCreate'
GO

/******************************************************************************
**		File: pjm7SubProjectCreate.sql
**		Name: pjm7SubProjectCreate
**		Desc: 
**
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**      ----------						-----------
**
**		Auth: 
**		Date: 
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		--------	--------		-------------------------------------------
**		
*******************************************************************************/
CREATE PROCEDURE [pjm7SubProjectCreate]
@Xml	XML
AS
	DECLARE @State TState,
			@ID TIdentifier,
			@Date TDate,
			@Number TCode,
			@FileAs TName,
			@SupplierCompanyID TIdentifier,
			@CustomerCompanyID TIdentifier,
			@ResponsiblePersonEmployeeID TIdentifier,
			@PriorityID TIdentifier,
			@StartDate TDate,
			@DueDate TDate,
			@EndDate TDate,
			@CurrencyCode TCode3,
			@CostCenterID TIdentifier,
			@ManHour TAmount,
			@Budget TMoney,
			@ContractNumber TCode,
			@ContractDate TDate,
			@ContractSubject TName,
			@ServiceLevelID TIdentifier,
			@WSSDocumentsURL THref,
			@Comments TNotes,			
			@AssignmentState TState,
			@AssignmentID TIdentifier,
			@EmployeeName TName,
			@QualificationID TIdentifier,
			@StandardRate TMoney,
			@OvertimeRate TMoney,
			@rv int,
			@value TVariant,
			@InvoiceExpirationPeriodType TIdentifier,
			@ProjectTypeID TIdentifier,
			@PaymentCurrencyPoint TIdentifier,
			@GroupCalculationLines TBool,
			@Flag TFlag,
			@ProjectManagerEmployeeID TIdentifier,
			@CustomerFinanceManagerID TIdentifier,
			@Color TColor,
			@ParentProjectID 		TIdentifier			
	
	SET NOCOUNT ON

	SET @State = dbo.adfwfGetInitialState('e64c30d7-1ade-4f9e-8bde-c35357ea6e8a')
	IF @State IS NULL
	BEGIN
		RAISERROR('#accessdenied', 18, -1)
		RETURN 1
	END
				
	-- Global parameters
	DECLARE 
			@RoundingMode						int,
			@DefaultMoneyScale					TCount,
			@StatementPrintCurrency				TCount,
			@InvoicePrintCurrency				TCount,
			@FacturePrintCurrency				TCount,
			@ApplyVAT							TBool,
			@CheckTaskWorkOverdraft				TBool,
			@GroupingAdvanceCalculations		TCount,
			@SupportsRequestManagement			bit,
			@ShowActivityTypes					TBool,
			@ShowPrice							TBool,
			@ProjectLanguageCode				TCode,
			@ManagerAssistantEmployeeID			TIdentifier,
			@AddManagerAssistantToParticipants	TBool,
			@AddManagerToParticipants			TBool,
			@BankAccountDefault					TIdentifier,
			@StatementCurrencyPoint				TIdentifier,
			@InvoiceExpirationPeriod			TCount,
			@InvoiceCurrency					TIdentifier,
			@StatementCurrency					TIdentifier,
			@FactureCurrency					TIdentifier,
			@RatesWithVAT						TBool,
			@NumerationCode						TCode,
			@GroupByProjects					TBool,
			@CalculationNextPaymentDate			TDate,
			@StatementNextPaymentDate			TDate,
			@InvoiceNextPaymentDate				TDate,
			@DiscountTypeByTime					TIdentifier,
			@DiscountTypeByExpense				TIdentifier,
			@DiscountTypeByPhone				TIdentifier,
			@DiscountTypeByServiceRequest		TIdentifier,
			@DiscountViewByTime					TBool,
			@DiscountViewByExpense				TBool,
			@DiscountViewByPhone				TBool,
			@DiscountViewByServiceRequest		TBool,
			@DiscountByTime						TMoney,
			@DiscountByExpense					TMoney,
			@DiscountByPhone					TMoney,
			@DiscountByServiceRequest			TMoney,
			@ExternalNotificationOpenIssue		bit,
			@ExternalNotificationResolveIssue	bit,
			@ExternalNotificationCloseIssue		bit,
			@ExternalNotificationPostponeIssue	bit,
			@RoundingInterval					TCount,
			@InvoicePeriodType					TCode,
			@InvoiceDayType						TCode,
			@StatementPeriodType				TCode,
			@StatementDayType					TCode,
			@CalculationPeriodType				TCode,
			@CalculationDayType					TCode,
			@CalculationRecurrencePatternID		TIdentifier,
			@StatementRecurrencePatternID		TIdentifier,
			@InvoiceRecurrencePatternID			TIdentifier,
			@ContractEndDate					TDate,
			@FinanceManagerEmployeeID			TIdentifier

	SELECT
		@ParentProjectID					= @Xml.value('(/pjm5ProjectGet/Project/ParentProjectID)[1]','int'),
		@Date								= CAST(@Xml.value('(/pjm5ProjectGet/Project/Date)[1]','varchar(19)') as datetime),
		@Number								= @Xml.value('(/pjm5ProjectGet/Project/Number)[1]','varchar(32)'),
		@FileAs								= @Xml.value('(/pjm5ProjectGet/Project/FileAs)[1]','nvarchar(256)'),
		@ProjectTypeID						= @Xml.value('(/pjm5ProjectGet/Project/ProjectTypeID)[1]','int'),
		@SupplierCompanyID					= @Xml.value('(/pjm5ProjectGet/Project/SupplierCompanyID)[1]','int'),
		@ProjectManagerEmployeeID			= @Xml.value('(/pjm5ProjectGet/Project/ProjectManagerEmployeeID)[1]','int'),
		@Comments							= @Xml.value('(/pjm5ProjectGet/Project/Comments)[1]','nvarchar(max)'),
		
		@PriorityID							= @Xml.value('(/pjm5ProjectGet/Project/PriorityID)[1]','int'),
		@CurrencyCode						= @Xml.value('(/pjm5ProjectGet/Project/CurrencyCode)[1]','char(3)'),
		@CostCenterID						= @Xml.value('(/pjm5ProjectGet/Project/CostCenterID)[1]','int'),

		@Color								= @Xml.value('(/pjm5ProjectGet/Project/Color)[1]','int'),
		@ManagerAssistantEmployeeID			= @Xml.value('(/pjm5ProjectGet/Project/ManagerAssistantEmployeeID)[1]','int'),

		@ContractNumber						= @Xml.value('(/pjm5ProjectGet/Project/ContractNumber)[1]','varchar(32)'),
		@ContractSubject					= @Xml.value('(/pjm5ProjectGet/Project/ContractSubject)[1]','nvarchar(256)'),
		@ContractDate						= CAST(@Xml.value('(/pjm5ProjectGet/Project/ContractDate)[1]','varchar(19)') as datetime),
		@ContractEndDate					= CAST(@Xml.value('(/pjm5ProjectGet/Project/ContractEndDate)[1]','varchar(19)') as datetime),
		@FinanceManagerEmployeeID			= @Xml.value('(/pjm5ProjectGet/Project/FinanceManagerEmployeeID)[1]','int'),
		@ResponsiblePersonEmployeeID		= @Xml.value('(/pjm5ProjectGet/Project/ResponsiblePersonEmployeeID)[1]','int'),
		@BankAccountDefault					= @Xml.value('(/pjm5ProjectGet/Project/BankAccountDefault)[1]','int'),
		@CustomerCompanyID					= @Xml.value('(/pjm5ProjectGet/Project/CustomerCompanyID)[1]','int'),
		@CustomerFinanceManagerID			= @Xml.value('(/pjm5ProjectGet/Project/CustomerFinanceManagerID)[1]','int'),
		@StatementCurrencyPoint				= @Xml.value('(/pjm5ProjectGet/Project/StatementCurrencyPoint)[1]','int'),
		@InvoiceExpirationPeriod			= @Xml.value('(/pjm5ProjectGet/Project/InvoiceExpirationPeriod)[1]','int'),
		@InvoiceExpirationPeriodType		= @Xml.value('(/pjm5ProjectGet/Project/InvoiceExpirationPeriodType)[1]','int'),
		@PaymentCurrencyPoint				= @Xml.value('(/pjm5ProjectGet/Project/PaymentCurrencyPoint)[1]','int'),
		@InvoiceCurrency					= @Xml.value('(/pjm5ProjectGet/Project/InvoiceCurrency)[1]','int'),
		@StatementCurrency					= @Xml.value('(/pjm5ProjectGet/Project/StatementCurrency)[1]','int'),
		@FactureCurrency					= @Xml.value('(/pjm5ProjectGet/Project/FactureCurrency)[1]','int'),

		@ApplyVAT							=	(CASE @Xml.value('(/pjm5ProjectGet/Project/ApplyVAT)[1]','varchar(5)')
													WHEN 'false' THEN 
														0 
													ELSE 
														1 
												END),
		@RatesWithVAT						=	(CASE @Xml.value('(/pjm5ProjectGet/Project/RatesWithVAT)[1]','varchar(5)')
													WHEN 'false' THEN 
														0 
													ELSE 
														1 
												END),
		@NumerationCode						= @Xml.value('(/pjm5ProjectGet/Project/NumerationCode)[1]','varchar(32)'),	
		@GroupingAdvanceCalculations		= @Xml.value('(/pjm5ProjectGet/Project/GroupingAdvanceCalculations)[1]','int'),		
		@GroupCalculationLines				=	(CASE @Xml.value('(/pjm5ProjectGet/Project/GroupCalculationLines)[1]','varchar(5)')
													WHEN 'false' THEN 
														0 
													ELSE 
														1 
												END),
		@ShowActivityTypes					=	(CASE @Xml.value('(/pjm5ProjectGet/Project/ShowActivityTypes)[1]','varchar(5)')
													WHEN 'false' THEN 
														0 
													ELSE 
														1 
												END),
		@ShowPrice							=	(CASE @Xml.value('(/pjm5ProjectGet/Project/ShowPrice)[1]','varchar(5)')
													WHEN 'false' THEN 
														0 
													ELSE 
														1 
												END),
		@GroupByProjects					= @Xml.value('(/pjm5ProjectGet/Project/GroupByProjects)[1]','bit'),
		@CalculationPeriodType				= @Xml.value('(/pjm5ProjectGet/Project/CalculationPeriodType)[1]','varchar(32)'),
		@CalculationDayType					= @Xml.value('(/pjm5ProjectGet/Project/CalculationDayType)[1]','varchar(32)'),
		@CalculationNextPaymentDate			= CAST(@Xml.value('(/pjm5ProjectGet/Project/CalculationNextPaymentDate)[1]','varchar(19)') AS datetime),
		@StatementPeriodType				= @Xml.value('(/pjm5ProjectGet/Project/StatementPeriodType)[1]','varchar(32)'),
		@StatementDayType					= @Xml.value('(/pjm5ProjectGet/Project/StatementDayType)[1]','varchar(32)'),
		@StatementNextPaymentDate			= CAST(@Xml.value('(/pjm5ProjectGet/Project/StatementNextPaymentDate)[1]','varchar(19)') AS datetime),
		@InvoicePeriodType					= @Xml.value('(/pjm5ProjectGet/Project/InvoicePeriodType)[1]','varchar(32)'),
		@InvoiceDayType						= @Xml.value('(/pjm5ProjectGet/Project/InvoiceDayType)[1]','varchar(32)'),
		@InvoiceNextPaymentDate				= CAST(@Xml.value('(/pjm5ProjectGet/Project/InvoiceNextPaymentDate)[1]','varchar(19)') AS datetime),
		@DiscountTypeByTime					= @Xml.value('(/pjm5ProjectGet/Project/DiscountTypeByTime)[1]','int'),
		@DiscountTypeByExpense				= @Xml.value('(/pjm5ProjectGet/Project/DiscountTypeByExpense)[1]','int'),
		@DiscountTypeByPhone				= @Xml.value('(/pjm5ProjectGet/Project/DiscountTypeByPhone)[1]','int'),
		@DiscountTypeByServiceRequest		= @Xml.value('(/pjm5ProjectGet/Project/DiscountTypeByServiceRequest)[1]','int'),
		@DiscountViewByTime					= @Xml.value('(/pjm5ProjectGet/Project/DiscountViewByTime)[1]','bit'),
		@DiscountViewByExpense				= @Xml.value('(/pjm5ProjectGet/Project/DiscountViewByExpense)[1]','bit'),
		@DiscountViewByPhone				= @Xml.value('(/pjm5ProjectGet/Project/DiscountViewByPhone)[1]','bit'),
		@DiscountViewByServiceRequest		= @Xml.value('(/pjm5ProjectGet/Project/DiscountViewByServiceRequest)[1]','bit'),
		@DiscountByTime						= @Xml.value('(/pjm5ProjectGet/Project/DiscountByTime)[1]','decimal(18,4)'),
		@DiscountByExpense					= @Xml.value('(/pjm5ProjectGet/Project/DiscountByExpense)[1]','decimal(18,4)'),
		@DiscountByPhone					= @Xml.value('(/pjm5ProjectGet/Project/DiscountByPhone)[1]','decimal(18,4)'),
		@DiscountByServiceRequest			= @Xml.value('(/pjm5ProjectGet/Project/DiscountByServiceRequest)[1]','decimal(18,4)'),

		@SupportsRequestManagement			= @Xml.value('(/pjm5ProjectGet/Project/SupportsRequestManagement)[1]','bit'),
		@ExternalNotificationOpenIssue		=	(CASE @Xml.value('(/pjm5ProjectGet/Project/ExternalNotificationOpenIssue)[1]','varchar(5)') 
													WHEN 'false' THEN 
														0 
													ELSE 
														1 
												END),
		@ExternalNotificationResolveIssue	=	(CASE @Xml.value('(/pjm5ProjectGet/Project/ExternalNotificationResolveIssue)[1]','varchar(5)') 
												WHEN 'false' THEN 
													0 
												ELSE 
													1 
												END),
		@ExternalNotificationCloseIssue		=	(CASE @Xml.value('(/pjm5ProjectGet/Project/ExternalNotificationCloseIssue)[1]','varchar(5)') 
													WHEN 'false' THEN 
														0 
													ELSE 
														1 
												END),
		@ExternalNotificationPostponeIssue	=	(CASE @Xml.value('(/pjm5ProjectGet/Project/ExternalNotificationPostponeIssue)[1]','varchar(5)') 
													WHEN 'false' THEN 
														0 
													ELSE 
														1 
												END),
		@RoundingInterval					= @Xml.value('(/pjm5ProjectGet/Project/RoundingInterval)[1]','int'),
		@RoundingMode						= @Xml.value('(/pjm5ProjectGet/Project/RoundingMode)[1]','int'),
		@ProjectLanguageCode				= @Xml.value('(/pjm5ProjectGet/Project/ProjectLanguageCode)[1]','varchar(32)')

	BEGIN TRANSACTION
	
	INSERT INTO [Project]
		([State], [Date], [FileAs],

		[Number], 
		[CostCenterID],
		[SupplierCompanyID],
		[ProjectManagerEmployeeID],
		[Comments],
		[ManagerAssistantEmployeeID],
		[PriorityID],
		[CurrencyCode],
		[ProjectTypeID],
		[ContractNumber],
		[ContractSubject],
		[ContractDate],
		[ContractEndDate],
		[FinanceManagerEmployeeID],
		[CustomerCompanyID],
		[CustomerFinanceManagerID],
		[ResponsiblePersonEmployeeID],
		[BankAccountID],
		[StatementCurrencyPoint],
		[InvoiceExpirationPeriod],
		[InvoiceExpirationPeriodType],
		[PaymentCurrencyPoint],
		[InvoiceCurrency],
		[StatementCurrency],
		[FactureCurrency],
		[ApplyVAT],
		[RatesWithVAT],
		[NumerationCode],
		[GroupingAdvanceCalculations],
		[GroupCalculationLines],
		[ShowActivityTypes],
		[ShowPrice],
		[GroupByProjects],

		[SupportsRequestManagement],
		[RoundingInterval],
		[RoundingMode],
		[Color],
		[ProjectLanguageCode],
		[Billable])
	VALUES
		(@State, @Date, @FileAs,

		@Number, 
		@CostCenterID,
		@SupplierCompanyID,
		@ProjectManagerEmployeeID,
		@Comments,
		@ManagerAssistantEmployeeID,
		@PriorityID,
		@CurrencyCode,
		@ProjectTypeID,

		@ContractNumber,
		@ContractSubject,
		@ContractDate,
		@ContractEndDate,
		@FinanceManagerEmployeeID,
		@CustomerCompanyID,
		@CustomerFinanceManagerID,
		@ResponsiblePersonEmployeeID,
		@BankAccountDefault,
		@StatementCurrencyPoint,
		@InvoiceExpirationPeriod,
		@InvoiceExpirationPeriodType,
		@PaymentCurrencyPoint,
		@InvoiceCurrency,
		@StatementCurrency,
		@FactureCurrency,
		@ApplyVAT,
		@RatesWithVAT,
		@NumerationCode,
		@GroupingAdvanceCalculations,
		@GroupCalculationLines,
		@ShowActivityTypes,
		@ShowPrice,
		@GroupByProjects,

		@SupportsRequestManagement,
		@RoundingInterval,
		@RoundingMode,
		@Color,
		@ProjectLanguageCode,
		(CASE  WHEN @ProjectTypeID IN (1) THEN 1 ELSE 0 END))
		
	IF @@ERROR != 0
	BEGIN
		ROLLBACK TRANSACTION
		RETURN 1
	END

	SET @ID = SCOPE_IDENTITY()
		
	--Скидки/ наценки
	INSERT INTO [ProjectDetail] 
		([ID], 
		[DueDate],
		[DiscountByServiceRequest],
		[DiscountByPhone],
		[DiscountByExpense],
		[DiscountByTime],
		[DiscountViewByServiceRequest],
		[DiscountViewByPhone],
		[DiscountViewByExpense],
		[DiscountViewByTime],
		[DiscountTypeByServiceRequest],
		[DiscountTypeByPhone],
		[DiscountTypeByExpense],
		[DiscountTypeByTime]
		)
	SELECT
		@ID,
		CAST(@Xml.value('(/pjm5ProjectGet/Project/DueDate)[1]','varchar(19)') as datetime),
		@DiscountByServiceRequest,
		@DiscountByPhone,
		@DiscountByExpense,
		@DiscountByTime,
		@DiscountViewByServiceRequest,
		@DiscountViewByPhone,
		@DiscountViewByExpense,
		@DiscountViewByTime,
		@DiscountTypeByServiceRequest,
		@DiscountTypeByPhone,	
		@DiscountTypeByExpense,
		@DiscountTypeByTime

	IF @@ERROR != 0
	BEGIN
		ROLLBACK TRANSACTION
		RETURN 1
	END


	UPDATE
		[PaymentPeriod]
	SET
		
		[InvoicePeriodType] = @InvoicePeriodType,
		[InvoiceDayType] = @InvoiceDayType,
		
		[StatementPeriodType] = @StatementPeriodType,
		[StatementDayType] = @StatementDayType,
		
		[CalculationPeriodType] = @CalculationPeriodType,
		[CalculationDayType] = @CalculationDayType,

		[CalculationNextPaymentDate]	= @CalculationNextPaymentDate,
		[StatementNextPaymentDate]		= @StatementNextPaymentDate,
		[InvoiceNextPaymentDate]		= @InvoiceNextPaymentDate
	WHERE
		[ProjectID] = @ID

	--Параметры оповещания внешних инициаторов по электронной почте
	DECLARE 
		@SubscriptionRuleID	TIdentifier,
		@UserID				TIdentifier,
		@OpenIssueID		TIdentifier,
		@ResolveIssueID		TIdentifier,
		@PostponeIssueID	TIdentifier,
		@CloseIssueID		TIdentifier

	SELECT	
		@UserID				= dbo.adfGetCurrentUserID(),
		@OpenIssueID		= dbo.fnPjm5GetSubscriptionTypeByCode('ExternalOpenIssue'),
		@ResolveIssueID		= dbo.fnPjm5GetSubscriptionTypeByCode('ExternalResolveIssue'),
		@CloseIssueID		= dbo.fnPjm5GetSubscriptionTypeByCode('ExternalCloseIssue'),
		@PostponeIssueID	= dbo.fnPjm5GetSubscriptionTypeByCode('ExternalPostponeIssue')

	EXEC @rv = dbo.pjm5ExternalSubscriptionRuleCreate @SubscriptionRuleID OUTPUT, @ID, @UserID
	IF @rv != 0 OR @SubscriptionRuleID IS NULL
	BEGIN
		ROLLBACK TRANSACTION
		RETURN @rv
	END

	----Оповещение об открытии запроса
	IF @ExternalNotificationOpenIssue = 1
	BEGIN
		EXEC @rv = dbo.pjm5ExternalSubscriptionCreate @SubscriptionRuleID, @OpenIssueID
		IF @rv != 0
		BEGIN
			ROLLBACK TRANSACTION
			RETURN @rv
		END
	END

	----Оповещение об исполнении запроса
	IF @ExternalNotificationResolveIssue = 1
	BEGIN
		EXEC @rv = dbo.pjm5ExternalSubscriptionCreate @SubscriptionRuleID, @ResolveIssueID
		IF @rv != 0
		BEGIN
			ROLLBACK TRANSACTION
			RETURN @rv
		END
	END

	---Оповещение о закрытии запроса
	IF @ExternalNotificationCloseIssue = 1
	BEGIN
		EXEC @rv = dbo.pjm5ExternalSubscriptionCreate @SubscriptionRuleID, @CloseIssueID
		IF @rv != 0
		BEGIN
			ROLLBACK TRANSACTION
			RETURN @rv
		END
	END

	----Оповещение о переводе запроса в отложенные
	IF @ExternalNotificationPostponeIssue = 1
	BEGIN
		EXEC @rv = dbo.pjm5ExternalSubscriptionCreate @SubscriptionRuleID, @PostponeIssueID
		IF @rv != 0
		BEGIN
			ROLLBACK TRANSACTION
			RETURN @rv
		END
	END

	--Виды деятельности
	INSERT INTO [ProjectActivityType] 
		([ProjectID], [ActivityTypeID], [Billable], [Actively])
	SELECT 
		@ID, [ActivityTypeID], [Billable], [Actively]
	FROM
		[ProjectActivityType]
	WHERE
		[ProjectID] = @ParentProjectID

	IF @@ERROR != 0
	BEGIN
		ROLLBACK TRANSACTION		
		RETURN 1
	END

	--Типы затрат
	INSERT INTO [ProjectExpenseCode] 
		([ProjectID], [ExpenseCodeID], [Billable], [Actively])
	SELECT 
		@ID, [ExpenseCodeID], [Billable], [Actively]
	FROM 
		[ProjectExpenseCode]
	WHERE 
		[ProjectID] = @ParentProjectID

	IF @@ERROR != 0
	BEGIN
		ROLLBACK TRANSACTION
		RETURN 1
	END

	--Участники проекта
	DECLARE 
		@inParentProjectID		TIdentifier, 
		@inProjectID			TIdentifier,
		@assflag				TFlag,
		@assfileas				TName, 
		@assemployeeID			TIdentifier,
		@assqualificationID		TIdentifier, 
		@assstandardRate		TMoney,
		@assovertimeRate		TMoney,
		@assratevisible			TBool,
		@assapprover			TBool,	
		@assadministrator		TBool, 
		@taskreport				TBool,
		@issuereport			TBool, 
		@asscomments			TNotes, 
		@AlwaysUseRate			TBool,
		@assFinanceManagement	TBool

	DECLARE 
		Assignment CURSOR LOCAL FAST_FORWARD READ_ONLY FOR

		SELECT
			[ID],
			[Flag],
			[FileAs],
			[EmployeeID],
			[QualificationID],
			[StandardRate],
			[OvertimeRate],
			[RateVisible],
			[Approver],
			[Administrator],
			[AlwaysUseRate],
			[ReceiveTaskStatusReports],
			[ReceiveIssueStatusReports],
			[Comments],
			[FinanceManagement]
		FROM
			[vwAssignment]
		WHERE 
			[ProjectID] = @ParentProjectID AND
			[State] = 1

		OPEN Assignment

		FETCH NEXT FROM Assignment INTO 
			@inParentProjectID, @assflag, @assfileas, @assemployeeID,
			@assqualificationID, @assstandardRate, @assovertimeRate, @assratevisible,
			@assapprover, @assadministrator, @AlwaysUseRate, @taskreport, @issuereport, @asscomments, @assFinanceManagement
		WHILE @@FETCH_STATUS = 0
		BEGIN
			EXEC @rv = pjm5AssignmentCreateInternal
				@ID = @inProjectID OUTPUT,
				@Flag = @assflag,
				@State = 1,
				@FileAs = @assfileas,
				@EmployeeID = @assemployeeid,
				@ProjectID = @ID,
				@QualificationID = @assqualificationID,
				@StandardRate = @assstandardRate,
				@OvertimeRate = @assovertimeRate,
				@RateVisible = @assratevisible,
				@Approver = @assapprover,
				@Administrator = @assadministrator,
				@FinanceManagement = @assFinanceManagement,
				@TaskReport = @taskreport,
				@IssueReport = @issuereport,
				@Comments = @asscomments,
				@AlwaysUseRate = @AlwaysUseRate
			
			IF @@ERROR != 0 OR @rv != 0
			BEGIN
				ROLLBACK TRANSACTION
				RETURN 1
			END
		
			FETCH NEXT FROM Assignment INTO 
				@inParentProjectID, @assflag, @assfileas, @assemployeeID,
				@assqualificationID, @assstandardRate, @assovertimeRate, @assratevisible,
				@assapprover, @assadministrator, @AlwaysUseRate, @taskreport, @issuereport, 
				@asscomments, @assFinanceManagement
		END
		CLOSE Assignment
		DEALLOCATE Assignment	

	--Периодичность
	DECLARE @Scope TIdentifier

	SELECT
		@CalculationRecurrencePatternID		= [CalculationRecurrencePatternID],	
		@StatementRecurrencePatternID		= [StatementRecurrencePatternID],
		@InvoiceRecurrencePatternID			= [InvoiceRecurrencePatternID]
	FROM
		[Project]
	WHERE
		[Project].[ID] = @ParentProjectID

	----Калькуляции
	INSERT INTO [AssistantRecurrencePattern]
	(
		[StartDate], [EndDate], [Occurrences], [RecurrenceType], [Interval], [DayOfWeekMask],
		[Instance], [MonthOfYear], [DayOfMonth], [DayTransferRule]
	)
	SELECT
		[StartDate], [EndDate], [Occurrences], [RecurrenceType], [Interval], [DayOfWeekMask],
		[Instance], [MonthOfYear], [DayOfMonth], [DayTransferRule]
	FROM 
		[AssistantRecurrencePattern]
	WHERE
		[AssistantRecurrencePattern].[ID] = @CalculationRecurrencePatternID

	SET @Scope = SCOPE_IDENTITY()
	UPDATE [Project] 
	SET [Project].[CalculationRecurrencePatternID] = @Scope
	WHERE [Project].[ID] = @ID 

	----Акты
	INSERT INTO [AssistantRecurrencePattern]
	(
		[StartDate], [EndDate], [Occurrences], [RecurrenceType], [Interval], [DayOfWeekMask],
		[Instance], [MonthOfYear], [DayOfMonth], [DayTransferRule]
	)
	SELECT
		[StartDate], [EndDate], [Occurrences], [RecurrenceType], [Interval], [DayOfWeekMask],
		[Instance], [MonthOfYear], [DayOfMonth], [DayTransferRule]
	FROM 
		[AssistantRecurrencePattern]
	WHERE
		[AssistantRecurrencePattern].[ID] = @StatementRecurrencePatternID

	SET @Scope = SCOPE_IDENTITY()
	UPDATE [Project] 
	SET [Project].[StatementRecurrencePatternID] = @Scope
	WHERE [Project].[ID] = @ID 

	----Счета
	INSERT INTO [AssistantRecurrencePattern]
	(
		[StartDate], [EndDate], [Occurrences], [RecurrenceType], [Interval], [DayOfWeekMask],
		[Instance], [MonthOfYear], [DayOfMonth], [DayTransferRule]
	)
	SELECT
		[StartDate], [EndDate], [Occurrences], [RecurrenceType], [Interval], [DayOfWeekMask],
		[Instance], [MonthOfYear], [DayOfMonth], [DayTransferRule]
	FROM 
		[AssistantRecurrencePattern]
	WHERE
		[AssistantRecurrencePattern].[ID] = @InvoiceRecurrencePatternID

	SET @Scope = SCOPE_IDENTITY()
	UPDATE [Project] 
	SET [Project].[InvoiceRecurrencePatternID] = @Scope
	WHERE [Project].[ID] = @ID 

	DECLARE @Error INT
	
	DECLARE @result INT	
	
	--Открыть проект
	EXEC @result = pjm7ProjectAutoAssign @ID
	IF @result != 0
	BEGIN
		ROLLBACK TRANSACTION
		RETURN @result
	END

	--Вложить проект
	EXEC @result = pjm6SubProjectInsert @ParentProjectID, @ID
	IF @result != 0
	BEGIN
		ROLLBACK TRANSACTION
		RETURN @result
	END

	COMMIT TRANSACTION

	RETURN @ID
GO

GRANT EXECUTE ON pjm7SubProjectCreate TO PUBLIC
GO
