 IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[ReportMeetingRequest]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	BEGIN
		PRINT 'Dropping procedure ReportMeetingRequest'
		DROP PROCEDURE [dbo].[ReportMeetingRequest]
	END
GO

PRINT 'Creating procedure ReportMeetingRequest'
GO

/******************************************************************************
**		File: ReportMeetingRequest.sql
**		Name: ReportMeetingRequest
**		Desc: this procedure automatically generated by Avicom.Adf.Generator
**
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**      ----------						-----------
**
**		Auth: Dmitry.Kolchev
**		Date: 05/19/2006 12:50:39
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		--------	--------		-------------------------------------------
**    
*******************************************************************************/
CREATE PROCEDURE [ReportMeetingRequest]
	@ID TIdentifier
AS
	SET NOCOUNT ON
	DECLARE @EmployeeID TIdentifier, @UserID TIdentifier, @UserName TName
	
	SET @EmployeeID = dbo.adfGetCurrentEmployeeID();
	SET @UserID = dbo.adfGetCurrentUserID();
	SELECT @UserName = [Trustee].[DisplayName] FROM [Trustee] WHERE [Trustee].[ID] = @UserID
	
	SELECT
		[MeetingRequest].[Class],
		[MeetingRequest].[ID],
		[MeetingRequest].[State],
		[MeetingRequest].[Flag],
		[MeetingRequest].[FileAs],
		[MeetingRequest].[ProjectID],
		[Project].[Number] AS [ProjectNumber],
		[Project].[FileAs] AS [ProjectFileAs],
		[MeetingRequest].[OriginatorEmployeeID],
		[Employee].[FileAs] AS [EmployeeFileAs],
		[MeetingRequest].[ActivityTypeID],
		[ActivityType].[Code] AS [ActivityTypeCode],
		[ActivityType].[FileAs] AS [ActivityTypeFileAs],
		[MeetingRequest].[PriorityID],
		[Priority].[Code] AS [PriorityCode],
		[Priority].[FileAs] AS [PriorityFileAs],
		[MeetingRequest].[StartTime],
		[MeetingRequest].[Duration] / 60.0 AS [Duration],
		[MeetingRequest].[Location],
		[MeetingRequest].[Comments],
		[MeetingRequest].[Created],
		[MeetingRequest].[CreatedBy],
		[MeetingRequest].[Modified],
		[MeetingRequest].[ModifiedBy],
		[Creator].[FileAs] AS [CreatorFileAs],
		@UserName AS [UserName]
	FROM
		[MeetingRequest]
		INNER JOIN [Employee]
			ON [Employee].[ID] = [MeetingRequest].[OriginatorEmployeeID]
		INNER JOIN [Priority]
			ON [Priority].[ID] = [MeetingRequest].[PriorityID]
		INNER JOIN [Employee] AS [Creator]
			ON [Creator].[UserID] = [MeetingRequest].[CreatedBy]
		LEFT OUTER JOIN [Project]
			ON [Project].[ID] = [MeetingRequest].[ProjectID]
		LEFT OUTER JOIN [ActivityType]
			ON [ActivityType].[ID] = [MeetingRequest].[ActivityTypeID]
	WHERE
		[MeetingRequest].[ID] = @ID
		
	SELECT
		[EmployeeID],
		[Employee].[FileAs] AS [EmployeeFileAs],
		[Required],
		[Present],
		[ResponseType]
	FROM
		[Attendee]
		INNER JOIN [Employee]
			ON [Employee].[ID] = [Attendee].[EmployeeID]
	WHERE
		[MeetingRequestID] = @ID
	
	SELECT
		[MeetingResource].[ResourceID],
		[Resource].[ResourceTypeID],
		[Resource].[Code],
		[Resource].[FileAs],
		[MeetingResource].[Required]
	FROM
		[MeetingResource] 
		INNER JOIN [Resource]
			ON [MeetingResource].[ResourceID] = [Resource].[ID]
	WHERE
		[MeetingRequestID] = @ID
		
	SELECT
		[AttendeeResponse].[ID],
		[AttendeeResponse].[EmployeeID],
		[Employee].[FileAs] AS [EmployeeFileAs],
		[AttendeeResponse].[FileAs],
		[AttendeeResponse].[Comments],
		[AttendeeResponse].[Created]
	FROM
		[AttendeeResponse]
		INNER JOIN [Employee]
			ON [Employee].[ID] = [AttendeeResponse].[EmployeeID]
	WHERE
		[MeetingRequestID] = @ID
		
	SELECT
		[Note].[Created],
		[Note].[Text],
		[Employee].[FileAs]
	FROM
		[MeetingRequest]
		INNER JOIN [Note]
			ON [MeetingRequest].[ID] = [Note].[DocumentID] AND
			   [MeetingRequest].[Class] = [Note].[DocumentClass]
		INNER JOIN [Employee]
			ON ([Note].[CreatedBy] = [Employee].[UserID])
	WHERE
		[MeetingRequest].[ID] = @ID 
	ORDER BY
		[Note].[Created]
	RETURN 0
GO

GRANT EXECUTE ON [ReportMeetingRequest] TO PUBLIC
GO
