IF EXISTS (SELECT * FROM sysobjects WHERE type = 'P' AND name = 'ReportTimeEntryOfTask')
	BEGIN
		PRINT 'Dropping Procedure ReportTimeEntryOfTask'
		DROP  Procedure  ReportTimeEntryOfTask
	END

GO

PRINT 'Creating Procedure ReportTimeEntryOfTask'
GO
--------------------------------------------------------------------------------------
-- Copyright (c) 2003 by Avicom
--------------------------------------------------------------------------------------
-- $Archive: $
-- $Author: $
-- $Revision: $
-- $Modtime: $
-- $Date: $
--
-- Description: this stored procedure ...........
-- Input:	.........
-- Output:      0 - success, negative number - otherwise
--
-- Notes:       no
--
--
/* $Log: $ 
   $NoKeywords: $ 
--------------------------------------------------------------------------------------*/


CREATE Procedure ReportTimeEntryOfTask
	@Date			TDateTime,
	@ProjectID		TIdentifier,
	@EntrySelector  int
AS
	IF @ProjectID IS NULL
	BEGIN
		RAISERROR('#ProjectIsNotSelected', 16, -1)
		RETURN 1
	END
	
	SET NOCOUNT ON
	
	DECLARE
		@value			TVariant,
		@WorkTime		decimal(18,2)
	
	EXEC adfParameterGet 'WorkTime', 'Pjm5', @value OUTPUT  
	SET @WorkTime = CAST(@value AS decimal(18,2))
		
	EXECUTE ReportTimeEntryOfTaskHeader @Date, @ProjectID

	SELECT
		[Task].[FileAs] AS [TaskName],
		ISNULL([Task].[Duration],0) AS [PlanDuration],
		ISNULL(SUM([TimeEntry].[RoundedDuration] / 60.00),0) AS [FactDuration]
	FROM 
		[Task]
		LEFT OUTER JOIN [TimeEntry]
			ON [TimeEntry].[TaskID] = [Task].[ID] AND
			   CAST(CONVERT(varchar(8), [TimeEntry].[StartTime], 112) AS datetime) <= @Date
	WHERE
		CAST(CONVERT(varchar(8), [Task].[StartDate], 112) AS datetime) <= @Date AND
		[Task].[ProjectID] = @ProjectID AND
		((@EntrySelector = 1 AND [TimeEntry].[State]in(3,6)) OR (@EntrySelector = 2 AND [TimeEntry].[State] = 6) OR @EntrySelector = 0)
	GROUP BY
		[Task].[FileAs],
		[Task].[Duration]
		
	
RETURN 0
GO

GRANT EXEC ON ReportTimeEntryOfTask TO PUBLIC

GO
