IF EXISTS (SELECT * FROM sysobjects WHERE type = 'P' AND name = 'ReportTimesheetOfContractHeader')
	BEGIN
		PRINT 'Dropping Procedure ReportTimesheetOfContractHeader'
		DROP  Procedure  ReportTimesheetOfContractHeader
	END

GO

PRINT 'Creating Procedure ReportTimesheetOfContractHeader'
GO

--------------------------------------------------------------------------------------
-- Copyright (c) 2003 by Avicom
--------------------------------------------------------------------------------------
-- $Archive: $
-- $Author: $
-- $Revision: $
-- $Modtime: $
-- $Date: $
--
-- Description: this stored procedure ...........
-- Input:	.........
-- Output:      0 - success, negative number - otherwise
--
-- Notes:       no
--
--
/* $Log: $ 
   $NoKeywords: $ 
--------------------------------------------------------------------------------------*/
CREATE Procedure ReportTimesheetOfContractHeader
	@WeekStart			Tdatetime,
	@NextDate			Tdatetime,
	@ProjectID			TIdentifier
AS
	SET NOCOUNT ON
	DECLARE
		@UserID			TIdentifier,
		@UserName		TName		
							
	SET @UserID = dbo.adfGetCurrentUserID()
		
	SELECT
		@UserName = [Trustee].[DisplayName]
	FROM
		[Trustee]
	WHERE
		[Trustee].[ID] = @UserID
		
	SELECT
		[Project].[ContractSubject] AS [ContractName],
		[Project].[ContractNumber] AS [ContractNumber],
		--[Project].[ContractDate] AS [ContractDate],
		[CustomerCompany].[LegalName] AS [CustomerCompanyName],
		[SupplierCompany].[LegalName] AS [SupplierCompanyName],
		@WeekStart AS [WeekStart],
		DATEADD(second, -1, DATEADD(week, 1, @WeekStart)) AS [WeekEnd],
		@UserName AS [UserName]	
	FROM 
		[Project]
		LEFT OUTER JOIN [Company] AS [CustomerCompany]
			ON [Project].[CustomerCompanyID] = [CustomerCompany].[ID]
		LEFT OUTER JOIN [Company] AS [SupplierCompany]
			ON [Project].[SupplierCompanyID] = [SupplierCompany].[ID]		
	WHERE
		[Project].[ID] = @ProjectID

RETURN 0
GO

GRANT EXEC ON ReportTimesheetOfContractHeader TO PUBLIC

GO
