SET QUOTED_IDENTIFIER ON
GO 

IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[pjm5ResourceBrowse]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	BEGIN
		PRINT 'Dropping procedure pjm5ResourceBrowse'
		DROP PROCEDURE [dbo].[pjm5ResourceBrowse]
	END
GO

PRINT 'Creating procedure pjm5ResourceBrowse'
GO

/******************************************************************************
**		File: pjm5ResourceBrowse.sql
**		Name: pjm5ResourceBrowse
**		Desc: this procedure automatically generated by Avicom.Adf.Generator
**
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**      ----------						-----------
**
**		Auth: Dmitry.Kolchev
**		Date: 05/12/2006 17:37:34
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		--------	--------		-------------------------------------------
**    
*******************************************************************************/
CREATE PROCEDURE [pjm5ResourceBrowse]
	@StateSelector INT
AS
	SET NOCOUNT ON
	SELECT
		[Resource].[Class],
		[Resource].[ID],
		[Resource].[State],
		[Resource].[Flag],
		[Resource].[Code],
		[Resource].[FileAs],
		[Resource].[ResourceTypeID],
		[Resource].[ResponsibleEmployeeID],
		[Resource].[AutoSubmit],
		[Resource].[Comments],
		[Resource].[Created],
		[Resource].[CreatedBy],
		[Resource].[Modified],
		[Resource].[ModifiedBy],
		[Resource].[Timestamp]
	FROM
		[Resource]
	WHERE
		((@StateSelector = 0) OR (@StateSelector != 0 AND [Resource].[State] = @StateSelector))
		
	RETURN 0
GO

GRANT EXECUTE ON [pjm5ResourceBrowse] TO PUBLIC
GO

IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[pjm5ResourceGet]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	BEGIN
		PRINT 'Dropping procedure pjm5ResourceGet'
		DROP PROCEDURE [dbo].[pjm5ResourceGet]
	END
GO

PRINT 'Creating procedure pjm5ResourceGet'
GO

/******************************************************************************
**		File: pjm5ResourceGet.sql
**		Name: pjm5ResourceGet
**		Desc: this procedure automatically generated by Avicom.Adf.Generator
**
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**      ----------						-----------
**
**		Auth: Dmitry.Kolchev
**		Date: 05/12/2006 17:37:34
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		--------	--------		-------------------------------------------
**    
*******************************************************************************/
CREATE PROCEDURE [pjm5ResourceGet]
	@ID TIdentifier
AS
	SET NOCOUNT ON
	
	SELECT
		[Resource].[Class],
		[Resource].[ID],
		[Resource].[State],
		[Resource].[Flag],
		[Resource].[Code],
		[Resource].[FileAs],
		[Resource].[ResourceTypeID],
		[Resource].[ResponsibleEmployeeID],
		[Resource].[AutoSubmit],
		[Resource].[Comments],
		[Resource].[Created],
		[Resource].[CreatedBy],
		[Resource].[Modified],
		[Resource].[ModifiedBy],
		[Resource].[Timestamp]
	FROM
		[Resource]
	WHERE
		[Resource].[ID] = @ID
		
	SELECT
		[ID],
		[AvailableFrom],
		[AvailableTo]
	FROM
		[ResourceAvailability]
	WHERE
		[ResourceID] = @ID
		
	RETURN 0
GO

GRANT EXECUTE ON [pjm5ResourceGet] TO PUBLIC
GO

IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[pjm5ResourceCreate]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	BEGIN
		PRINT 'Dropping procedure pjm5ResourceCreate'
		DROP PROCEDURE [dbo].[pjm5ResourceCreate]
	END
GO

PRINT 'Creating procedure pjm5ResourceCreate'
GO


/******************************************************************************
**		File: pjm5ResourceCreate.sql
**		Name: pjm5ResourceCreate
**		Desc: this procedure automatically generated by Avicom.Adf.Generator
**
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**      ----------						-----------
**
**		Auth: Dmitry.Kolchev
**		Date: 05/12/2006 17:37:34
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		--------	--------		-------------------------------------------
**    
*******************************************************************************/
CREATE PROCEDURE [pjm5ResourceCreate]
	@Xml XML
AS
	DECLARE @State TState,
			@ID TIdentifier,
			@_xml xml
	
	SET NOCOUNT ON
		
	SET @State = dbo.adfwfGetInitialState('23bba6a8-a954-4749-b0f6-721cdae2ea43')
	IF @State IS NULL
	BEGIN
		RAISERROR('#accessdenied', 18, -1)
		RETURN 1
	END

	SET @_xml = @Xml


	BEGIN TRANSACTION
	
	INSERT INTO [Resource] 
		([Flag], [State], [Code], [FileAs], [ResourceTypeID], [ResponsibleEmployeeID], [AutoSubmit], [Comments])
	SELECT 
		0,
		@State,
		T.c.value('Code[1]', 'nvarchar(32)'),
		T.c.value('FileAs[1]', 'nvarchar(256)'),
		T.c.value('ResourceTypeID[1]', 'int'),
		T.c.value('ResponsibleEmployeeID[1]', 'int'),
		T.c.value('AutoSubmit[1]', 'bit'),
		T.c.value('Comments[1]', 'nvarchar(max)')
	FROM
		@_xml.nodes('/pjm5ResourceGet/Resource') T(c)
		
	IF @@ERROR != 0
	BEGIN
		ROLLBACK TRANSACTION
		RETURN 1
	END

	SET @ID = SCOPE_IDENTITY()

	INSERT INTO [ResourceAvailability] 
		([ResourceID], [AvailableFrom], [AvailableTo])
	SELECT
		@ID,
		CAST(T.c.value('AvailableFrom[1]', 'varchar(19)') as datetime),
		CAST(T.c.value('AvailableTo[1]', 'varchar(19)') as datetime)
	FROM
		@_xml.nodes('/pjm5ResourceGet/ResourceAvailability') T(c)
		
	IF @@ERROR != 0
	BEGIN
		ROLLBACK TRANSACTION
		RETURN 1
	END
	
	COMMIT TRANSACTION

	EXEC pjm5ResourceGet @ID

	RETURN 0
GO

GRANT EXECUTE ON pjm5ResourceCreate TO PUBLIC
GO

IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[pjm5ResourceUpdate]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	BEGIN
		PRINT 'Dropping procedure pjm5ResourceUpdate'
		DROP PROCEDURE [dbo].[pjm5ResourceUpdate]
	END
GO

PRINT 'Creating procedure pjm5ResourceUpdate'
GO

/******************************************************************************
**		File: pjm5ResourceUpdate.sql
**		Name: pjm5ResourceUpdate
**		Desc: this procedure automatically generated by Avicom.Adf.Generator
**
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**      ----------						-----------
**
**		Auth: Dmitry.Kolchev
**		Date: 05/12/2006 17:37:34
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		--------	--------		-------------------------------------------
**		05.06.14	SAP				      
*******************************************************************************/
CREATE PROCEDURE pjm5ResourceUpdate
	@Xml XML
AS
	DECLARE @ID TIdentifier,
			@_xml xml
	
	SET NOCOUNT ON
	
	SET @_xml = @Xml
	
	BEGIN TRANSACTION
	
	UPDATE [Resource]
	SET
		@ID = [S].[ID],
		[Code] = [S].[Code],
		[FileAs] = [S].[FileAs],
		[ResourceTypeID] = [S].[ResourceTypeID],
		[ResponsibleEmployeeID] = [S].[ResponsibleEmployeeID],
		[AutoSubmit] = [S].[AutoSubmit],
		[Comments] = [S].[Comments],
		[Modified] = DEFAULT,
		[ModifiedBy] = DEFAULT
	FROM
		(SELECT 
			T.c.value('ID[1]', 'int') as [ID],
			T.c.value('Code[1]', 'nvarchar(32)') as [Code],
			T.c.value('FileAs[1]', 'nvarchar(256)') as [FileAs],
			T.c.value('ResourceTypeID[1]', 'int') as [ResourceTypeID],
			T.c.value('ResponsibleEmployeeID[1]', 'int') as [ResponsibleEmployeeID],
			T.c.value('AutoSubmit[1]', 'bit') as [AutoSubmit],
			T.c.value('Comments[1]', 'nvarchar(max)') as [Comments]
		FROM
			@_xml.nodes('/pjm5ResourceGet/Resource') T(c)) as S INNER JOIN [Resource] as D
				ON ([S].[ID] = [D].[ID])
	IF @@ERROR != 0
	BEGIN
		ROLLBACK TRANSACTION
		RETURN 1
	END

	DELETE [ResourceAvailability] WHERE [ResourceID] = @ID
	
	IF @@ERROR != 0
	BEGIN
		ROLLBACK TRANSACTION
		RETURN 1
	END

	DECLARE 
		@AvailableFrom datetime,
		@AvailableTo datetime

	SELECT
		@AvailableFrom = CAST(T.c.value('AvailableFrom[1]', 'varchar(19)') as datetime),
		@AvailableTo = CAST(T.c.value('AvailableTo[1]', 'varchar(19)') as datetime)
	FROM
		@_xml.nodes('/pjm5ResourceGet/ResourceAvailability') as T(c)

	IF(@AvailableFrom IS NOT NULL)
	BEGIN
		INSERT INTO [ResourceAvailability] 
			([ResourceID], [AvailableFrom], [AvailableTo])
		SELECT
			@ID,
			@AvailableFrom,
			@AvailableTo
		
		IF @@ERROR != 0
		BEGIN
			ROLLBACK TRANSACTION
			RETURN 1
		END
	END
	
	COMMIT TRANSACTION

	EXEC pjm5ResourceGet @ID

	RETURN 0
GO

GRANT EXECUTE ON pjm5ResourceUpdate TO PUBLIC
GO

IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[pjm5ResourceDelete]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	BEGIN
		PRINT 'Dropping procedure pjm5ResourceDelete'
		DROP PROCEDURE [dbo].[pjm5ResourceDelete]
	END
GO

PRINT 'Creating procedure pjm5ResourceDelete'
GO

/******************************************************************************
**		File: pjm5ResourceDelete.sql
**		Name: pjm5ResourceDelete
**		Desc: this procedure automatically generated by Avicom.Adf.Generator
**
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**      ----------						-----------
**
**		Auth: Dmitry.Kolchev
**		Date: 05/12/2006 17:37:34
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		--------	--------		-------------------------------------------
**    28.06.10		KOV				    
*******************************************************************************/
CREATE PROCEDURE pjm5ResourceDelete
	@ID TIdentifier
AS
	SET NOCOUNT ON
	IF EXISTS(SELECT * FROM [SuperTimer] 
					WHERE [SuperTimer].[DocumentClass] = dbo.adfGetClassByName('Pjm5.Resource') AND [SuperTimer].[DocumentID] = @ID AND 
					([SuperTimer].[State] in (1,2) OR ([SuperTimer].[State] = 3 AND [SuperTimer].[Persistent] = 1)))
	BEGIN
		RAISERROR('#CannotDeleteDocumentWithActiveTimer', 18, -1)
		RETURN 1
	END
	BEGIN TRANSACTION

	DELETE FROM [ResourceAvailability] WHERE [ResourceID] = @ID
	IF @@ERROR != 0
	BEGIN
		ROLLBACK TRANSACTION
		RETURN 1
	END
			
	DELETE FROM [Resource] WHERE [Resource].[ID] = @ID
	IF @@ERROR != 0
	BEGIN
		ROLLBACK TRANSACTION
		RETURN 1
	END


	
	COMMIT TRANSACTION
	RETURN 0
GO

GRANT EXECUTE ON pjm5ResourceDelete TO PUBLIC
GO

IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[pjm5ResourceChangeState]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	BEGIN
		PRINT 'Dropping procedure pjm5ResourceChangeState'
		DROP PROCEDURE [dbo].[pjm5ResourceChangeState]
	END
GO

PRINT 'Creating procedure pjm5ResourceChangeState'
GO

/******************************************************************************
**		File: pjm5ResourceChangeState.sql
**		Name: pjm5ResourceChangeState
**		Desc: this procedure automatically generated by Avicom.Adf.Generator
**
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**      ----------						-----------
**
**		Auth: Dmitry.Kolchev
**		Date: 05/12/2006 17:37:34
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		--------	--------		-------------------------------------------
**    
*******************************************************************************/
CREATE PROCEDURE pjm5ResourceChangeState
	@ID TIdentifier,
	@ToState TState
AS
	DECLARE @FromState TState,
			@TransitionTemplateID TIdentifier,
			@RightID TIdentifier,
			@Class TClass
	
	SET NOCOUNT ON
	
	SELECT
		@Class = [Resource].[Class],
		@FromState = [Resource].[State]
	FROM
		[Resource]
	WHERE
		[Resource].[ID] = @ID
		
	IF @FromState = @ToState
	BEGIN
		RAISERROR('#invalidargument', 18, -1)
		RETURN 1
	END
	
	SELECT
		@TransitionTemplateID = [ID],
		@RightID = [RightID]
	FROM
		[TransitionTemplate]
	WHERE
		[TransitionTemplate].[FromState] = @FromState AND [TransitionTemplate].[ToState] = @ToState
	AND
		[TransitionTemplate].[Class] = @Class
		
	IF @TransitionTemplateID IS NULL
	BEGIN
		RAISERROR('#invalidoperation', 18, -1)
		RETURN 1
	END
	
	SET @TransitionTemplateID = dbo.adfCheckTransitionRights(@TransitionTemplateID, @RightID, dbo.adfGetCurrentUserID())
	
	IF @TransitionTemplateID IS NULL
	BEGIN
		RAISERROR('#accessdenied', 18, -1)
		RETURN 1
	END
	
	UPDATE
		[Resource]
	SET
		[Resource].[State] = @ToState,
		[Resource].[Modified] = DEFAULT,
		[Resource].[ModifiedBy] = DEFAULT
	WHERE
		[Resource].[ID] = @ID
	AND
		[Resource].[State] = @FromState

	IF @@ERROR != 0
		RETURN 1

	RETURN 0
GO

GRANT EXECUTE ON pjm5ResourceChangeState TO PUBLIC
GO
