IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[pjm5ServiceRequestLineUpdate]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
BEGIN
	PRINT 'Dropping procedure pjm5ServiceRequestLineUpdate'
	DROP PROCEDURE [dbo].[pjm5ServiceRequestLineUpdate]
END
GO

PRINT 'Creating procedure pjm5ServiceRequestLineUpdate'
GO

/******************************************************************************
**		File: pjm5ServiceRequestLineUpdate.sql
**		Name: pjm5ServiceRequestLineUpdate
**		Desc: this procedure automatically generated by Avicom.Adf.Generator
**
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**      ----------						-----------
**
**		Auth: vladislav.dremin
**		Date: 01/20/2005 15:20:31
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		--------	--------		-------------------------------------------
**    
*******************************************************************************/
CREATE PROCEDURE [pjm5ServiceRequestLineUpdate]
	@ID	TIdentifier,
	@ServiceRequestID TIdentifier,
	@ServiceAssignmentID TIdentifier,
	@RequestAmount TAmount,
	@FactAmount TAmount,
	@Price TMoney,
	@Description TName
AS
	IF @ID IS NULL -- 
	BEGIN
		IF @Price < 0
		BEGIN
			DECLARE
				@PriceWithVAT TMoney,
				@PriceWithoutVAT TMoney,
				@RatesWithVAT TBool,
				@VATIsIncluded TBool
				
			DECLARE @VATRate TPercent
			SET @VATRate = dbo.fnPjm5GetVATRate()
			
			SELECT
				@PriceWithoutVAT =
					CASE 
						WHEN [ServiceAssignment].[VATIsIncluded] != 1
							THEN [ServiceAssignment].[Price]
						ELSE [ServiceAssignment].[Price] / (1 + @VATRate)
					END ,
				@PriceWithVAT = CASE 
						WHEN [ServiceAssignment].[VATIsIncluded] != 1
							THEN [ServiceAssignment].[Price] * (1 + @VATRate)
						ELSE [ServiceAssignment].[Price]
					END,
				@RatesWithVAT = [Project].[RatesWithVAT]
			FROM
				[ServiceAssignment]
				INNER JOIN [Project]
					ON [Project].[ID] = [ServiceAssignment].[ProjectID]
			WHERE
				[ServiceAssignment].[ID] = @ServiceAssignmentID
			
			SELECT @VATIsIncluded = [VATIsIncluded] FROM [ServiceRequestID] WHERE [ServiceRequest].[ID] = @ServiceRequestID
			
			IF @RatesWithVAT = 1 AND @VATIsIncluded = 1
				SET @Price = @PriceWithVAT
			ELSE
				SET @Price = @PriceWithoutVAT
		END
		
		INSERT INTO [ServiceRequestLine] 
			([ServiceRequestID], [ServiceAssignmentID], [Description],
			 [RequestAmount], [FactAmount], [Price])
		VALUES 
			(@ServiceRequestID, @ServiceAssignmentID, @Description, @RequestAmount,
			 @FactAmount, @Price)
		IF @@ERROR != 0
			RETURN 1
	END
	ELSE
	BEGIN
		IF @Price >= 0
		BEGIN
			UPDATE 
				[ServiceRequestLine] 
			SET
				[ServiceAssignmentID] = @ServiceAssignmentID,
				[Description] =  @Description,
				[RequestAmount] = @RequestAmount,
				[FactAmount] = @FactAmount,
				[Price] = @Price
			WHERE
				[ID] = @ID
			IF @@ERROR != 0
				RETURN 1
		END
		ELSE
		BEGIN
			UPDATE 
				[ServiceRequestLine] 
			SET
				[ServiceAssignmentID] = @ServiceAssignmentID,
				[Description] =  @Description,
				[RequestAmount] = @RequestAmount,
				[FactAmount] = @FactAmount
			WHERE
				[ID] = @ID
			IF @@ERROR != 0
				RETURN 1

		END
	END
	RETURN 0
GO

GRANT EXECUTE ON pjm5ServiceRequestLineUpdate TO PUBLIC
GO

IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[pjm5ServiceRequestLineDelete]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
BEGIN
	PRINT 'Dropping procedure pjm5ServiceRequestLineDelete'
	DROP PROCEDURE [dbo].[pjm5ServiceRequestLineDelete]
END
GO

PRINT 'Creating procedure pjm5ServiceRequestLineDelete'
GO

/******************************************************************************
**		File: pjm5ServiceRequestLineDelete.sql
**		Name: pjm5ServiceRequestLineDelete
**		Desc: this procedure automatically generated by Avicom.Adf.Generator
**
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**      ----------						-----------
**
**		Auth: vladislav.dremin
**		Date: 01/20/2005 15:20:31
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		--------	--------		-------------------------------------------
**    
*******************************************************************************/
CREATE PROCEDURE pjm5ServiceRequestLineDelete
	@ID TIdentifier
AS
	SET NOCOUNT ON
	
	DELETE FROM [ServiceRequestLine] WHERE [ID] = @ID

	IF @@ERROR != 0
		RETURN 1

	RETURN 0
GO

GRANT EXECUTE ON pjm5ServiceRequestLineDelete TO PUBLIC
GO
 