IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[pjm5StatementCreateSimple]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	BEGIN
		PRINT 'Dropping procedure pjm5StatementCreateSimple'
		DROP PROCEDURE [dbo].[pjm5StatementCreateSimple]
	END
GO

IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[pjm5StatementCreate]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	BEGIN
		PRINT 'Dropping procedure pjm5StatementCreate'
		DROP PROCEDURE [dbo].[pjm5StatementCreate]
	END
GO

PRINT 'Creating procedure pjm5StatementCreate'
GO

/******************************************************************************
**		File: pjm5StatementCreate.sql
**		Name: pjm5StatementCreate
**		Desc: this procedure automatically generated by Avicom.Adf.Generator
**
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**      ----------						-----------
**
**		Auth: 
**		Date: 01/21/2005 15:47:39
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		--------	--------		-------------------------------------------
**		11.03.13	MAB				  OPENXML
*******************************************************************************/
CREATE PROCEDURE [pjm5StatementCreate]
	@Xml XML
AS
	DECLARE @State TState,
			@ID TIdentifier,
			@ProjectID TIdentifier,
			@PeriodStart TDate,
			@PeriodEnd TDate,
			@Date TDate,
			@FileAs TName,
			@Number TName,
			@Comments TNotes,
			@ApplyVAT bit,
			@VATRate TPercent,
			@ProjectType TIdentifier,
			@value TVariant,
			@rv int,
			@ProjectCurrencyCode TCode3,
			@CurrencyCode TCode3,
			@CurrencyRate TMoney,
			@BaseCurrencyRate TMoney,
			@ReminderState TState,
			@ReminderInterval TTimeSpan,
			@ReminderTime TDateTime,
			@ReturnDate TDate,
			@UserID TIdentifier,
			@StatementClass TClass,
			@SupplierCompanyID TIdentifier,
			@CustomerCompanyID TIdentifier,
			@Scale TCount
	
	SET NOCOUNT ON
	
	SET @State = dbo.adfwfGetInitialState('5f1bcdeb-edaf-44ae-bcc0-3d37e6516a60')
	IF @State IS NULL
	BEGIN
		RAISERROR('#accessdenied', 18, -1)
		RETURN 1
	END

	DECLARE @BaseCurrencyCode TCode3
	EXEC adfParameterGet @Name='BaseCurrency', @Group='CommonBusiness', @Value = @value OUTPUT
	SET @BaseCurrencyCode = CAST(@value as varchar(3))

	SELECT
		@Date					= @Xml.value('(/pjm5StatementGet/Statement/Date)[1]','nvarchar(19)'),
		@ProjectID				= @Xml.value('(/pjm5StatementGet/Statement/ProjectID)[1]','int'),
		@Number					= ISNULL(@Xml.value('(/pjm5StatementGet/Statement/Number)[1]','varchar(32)'), ''),
		@FileAs					= @Xml.value('(/pjm5StatementGet/Statement/FileAs)[1]','nvarchar(512)'),
		@PeriodStart			= ISNULL(@Xml.value('(/pjm5StatementGet/Statement/PeriodStart)[1]','nvarchar(19)'), @Date),
		@PeriodEnd				= ISNULL(@Xml.value('(/pjm5StatementGet/Statement/PeriodEnd)[1]','nvarchar(19)'), @Date),
		@Comments				= @Xml.value('(/pjm5StatementGet/Statement/Comments)[1]','nvarchar(max)'),
		@ApplyVAT				= [Project].[ApplyVAT],
		@VATRate				= 0,
		@ProjectType			= [Project].[ProjectTypeID],
		@CurrencyCode			= @Xml.value('(/pjm5StatementGet/Statement/CurrencyCode)[1]','char(3)'),
		@CurrencyRate			= @Xml.value('(/pjm5StatementGet/Statement/CurrencyRate)[1]','decimal(18, 4)'),
		@BaseCurrencyRate		= @Xml.value('(/pjm5StatementGet/Statement/BaseCurrencyRate)[1]','decimal(18, 4)'),
		@ProjectCurrencyCode	= [Project].[CurrencyCode],
		@ReturnDate				= CONVERT(datetime, @Xml.value('(/pjm5StatementGet/Statement/ReturnDate)[1]','varchar(19)')),
		@ReminderState			= CASE @Xml.value('(/pjm5StatementGet/Statement/ReminderState)[1]','varchar(5)') WHEN 'false' THEN 0 ELSE 1 END,
		@ReminderTime			= CONVERT(datetime, @Xml.value('(/pjm5StatementGet/Statement/ReminderTime)[1]','varchar(19)')),
		@SupplierCompanyID		= @Xml.value('(/pjm5StatementGet/Statement/SupplierCompanyID)[1]','int'),
		@CustomerCompanyID		= @Xml.value('(/pjm5StatementGet/Statement/CustomerCompanyID)[1]','int'),
		@Scale					= [Project].[Scale]
	FROM
		[Project]
	WHERE
		[Project].[ID] = @Xml.value('(/pjm5StatementGet/Statement/ProjectID)[1]','int')

	
	DECLARE @EmployeeID TIdentifier
	SET @EmployeeID = dbo.adfGetCurrentEmployeeID()
	IF dbo.adfHasAccessRight(dbo.adfGetRightID('ManageAllStatements')) = 0 AND
		dbo.fnPjm5HasFinansDataAccess(@ProjectID, @EmployeeID, NULL, NULL) = 0
	BEGIN
		RAISERROR('#accessdenied', 18, -1)
		RETURN 1
	END	
	
	IF @ProjectType NOT IN (1, 2)
	BEGIN
		RAISERROR('#wrongprojecttype', 18, -1)
		RETURN 1
	END

	SELECT
		@Date = CAST(CONVERT(varchar(8), @Date, 112) AS DATETIME),
		@PeriodStart = CAST(CONVERT(varchar(8), @PeriodStart, 112) AS DATETIME),
		@PeriodEnd = CAST(CONVERT(varchar(8), @PeriodEnd, 112) AS DATETIME)
		
	IF @BaseCurrencyCode = @ProjectCurrencyCode
		SET @BaseCurrencyRate = 1.0
	IF @ProjectCurrencyCode = @CurrencyCode
		SET @CurrencyRate = 1.0
	
	DECLARE @DefaultReturnDays int
	SET @value = 5
	EXEC adfParameterGet @Name='StatementReturnPeriod', @Group='Pjm5', @Value = @value OUTPUT
	SET @DefaultReturnDays = CAST(@value as int)
	IF @ReturnDate IS NULL
	BEGIN
		SET @ReturnDate = DATEADD(day, @DefaultReturnDays, @Date)
	END
	
	SELECT
		@UserID = dbo.adfGetCurrentUserID(),
		@StatementClass = dbo.adfGetClassByName('Pjm5.Statement'),
		@ReminderState = dbo.fnPjm5GetUserInitialReminderState(@StatementClass, 'MD', @UserID),
		@ReminderInterval = dbo.fnPjm5GetReminderInterval(@StatementClass, 'MD', @UserID)

	BEGIN TRANSACTION
	-----------------------------------------rec-----------------------------------------------------
	DECLARE
		@RecurrenceID TIdentifier,
		@RStartDate TDatetime, 
		@REndDate TDatetime, 
		@RRecurrenceType TIdentifier, 
		@ROccurrences TCount,
		@RInterval TCount, 
		@RDayOfWeekMask TIdentifier, 
		@RInstance TIdentifier, 
		@RMonthOfYear TCount, 
		@RDayOfMonth TCount
	SELECT
		@RStartDate			= CAST(@Xml.value('(/pjm5StatementGet/RecurrencePattern/StartDate)[1]','varchar(19)') as datetime),
		@REndDate			= CAST(@Xml.value('(/pjm5StatementGet/RecurrencePattern/EndDate)[1]','varchar(19)') as datetime),
		@RRecurrenceType	= @Xml.value('(/pjm5StatementGet/RecurrencePattern/RecurrenceType)[1]','int'),
		@ROccurrences		= @Xml.value('(/pjm5StatementGet/RecurrencePattern/Occurrences)[1]','int'),
		@RInterval			= @Xml.value('(/pjm5StatementGet/RecurrencePattern/Interval)[1]','int'),
		@RDayOfWeekMask		= @Xml.value('(/pjm5StatementGet/RecurrencePattern/DayOfWeekMask)[1]','int'),
		@RInstance			= @Xml.value('(/pjm5StatementGet/RecurrencePattern/Instance)[1]','int'),
		@RMonthOfYear		= @Xml.value('(/pjm5StatementGet/RecurrencePattern/MonthOfYear)[1]','int'),
		@RDayOfMonth		= @Xml.value('(/pjm5StatementGet/RecurrencePattern/DayOfMonth)[1]','int')

	IF @RRecurrenceType IS NOT NULL
	BEGIN
		INSERT INTO [RecurrencePattern]
			([StartDate], [EndDate], [RecurrenceType], [Occurrences],
			[Interval], [DayOfWeekMask], [Instance], [MonthOfYear], [DayOfMonth])
		VALUES
			(@RStartDate, @REndDate, @RRecurrenceType, @ROccurrences,
			@RInterval, @RDayOfWeekMask, @RInstance, @RMonthOfYear, @RDayOfMonth)
		IF @@ERROR != 0
		BEGIN
			ROLLBACK TRANSACTION
			RETURN 1
		END
		SET @RecurrenceID = SCOPE_IDENTITY()
	END
	--------------------------------------------------------------------------

	INSERT INTO [Statement]
		([Flag], [State], [Date], [Number], [FileAs], [ProjectID],
		 [Periodical], 
		 [CurrencyCode], [CurrencyRate], [BaseCurrencyRate],
		 [PeriodStart], [PeriodEnd], 
		 [Comments],
		 [TotalPC], [TotalWithVATPC], [TotalBC], [TotalWithVATBC], [ReturnDate],
		 [SupplierCompanyID], [CustomerCompanyID],
		 [Scale])
	VALUES
		(0, @State, @Date, @Number, @FileAs, @ProjectID,
		0,
		@CurrencyCode, @CurrencyRate, @BaseCurrencyRate,
		@PeriodStart, @PeriodEnd, 
		@Comments,
		0,0,0,0, @ReturnDate,
		@SupplierCompanyID, @CustomerCompanyID,
		@Scale)
	IF @@ERROR != 0
	BEGIN
		ROLLBACK TRANSACTION
		RETURN 1
	END
	SET @ID = SCOPE_IDENTITY()

	IF @RecurrenceID IS NOT NULL
	BEGIN
		UPDATE
			[Document]
		SET
			[RecurrencePatternID] = @RecurrenceID
		WHERE
			[Class] = @StatementClass AND [ID] = @ID
		IF @@ERROR != 0
		BEGIN
			ROLLBACK TRANSACTION
			RETURN 1
		END
	END
	
	EXEC @rv = pjm7StatementReminderCreate @ID,
		@ReturnDate, @ReminderState, @ReminderInterval
	IF @rv != 0
	BEGIN
		ROLLBACK TRANSACTION
		RETURN @rv
	END
	
	COMMIT TRANSACTION

	EXEC pjm5StatementGet @ID
	RETURN 0
GO

GRANT EXECUTE ON pjm5StatementCreate TO PUBLIC
GO

