﻿IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[pjm7StatementInvoiceAdvanceSearch]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
BEGIN
	PRINT 'Dropping procedure pjm7StatementInvoiceAdvanceSearch'
	DROP PROCEDURE [dbo].[pjm7StatementInvoiceAdvanceSearch]
END
GO

PRINT 'Creating procedure pjm7StatementInvoiceAdvanceSearch'
GO

/******************************************************************************
**		File: pjm7StatementInvoiceAdvanceSearch.sql
**		Name: pjm7StatementInvoiceAdvanceSearch
**		Desc: this procedure automatically generated by Avicom.Adf.Generator
**
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**      ----------						-----------
**
**		Auth: MAB
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		--------	--------		-------------------------------------------   
*******************************************************************************/
CREATE PROCEDURE [dbo].[pjm7StatementInvoiceAdvanceSearch] 
	@ID TIdentifier,
	@Category TName = NULL
AS
	SET NOCOUNT 
ON

	DECLARE
		@ProjectID		TIdentifier,
		@CurrencyCode	TCode3,
		@Lang			TLanguage,
		@VAT			TName,
		@Date			TDate

	IF @ID IS NOT NULL
		SELECT 
			@ProjectID = [ProjectID],
			@CurrencyCode = [CurrencyCode],
			@Date = [Date]
		FROM
			[Statement]
		WHERE	
			[ID] = @ID
 
	SET @Lang = dbo.adfGetLanguage()

	IF @Lang = 'en'
		SET @VAT = ', VAT '
	ELSE
		SET @VAT = ', НДС '

	SELECT
		[Invoice].[Class],
		[Invoice].[ID],
		[Invoice].[State],
		[Invoice].[Date],
		[Invoice].[Number],
		[Invoice].[FileAs],		
		[Invoice].[Created],
		[Invoice].[CreatedBy],
		[Invoice].[Modified],
		[Invoice].[ModifiedBy],
		[Invoice].[Timestamp],
		(CASE 
			WHEN (ISNULL([Invoice].[TotalWithVAT], 0.0) - ISNULL(SUM([StatementAdvanceInvoice].[StatementPaymentValue]),0) = [Invoice].[TotalWithVAT])
				THEN ISNULL([Invoice].[TotalWithVAT], 0.0)
			ELSE  (ISNULL([Invoice].[TotalWithVAT], 0.0) - ISNULL(SUM([StatementAdvanceInvoice].[StatementPaymentValue]),0))
		END) AS [StatementNotClosed],
		[Invoice].[CurrencyCode],
		ISNULL([Invoice].[TotalWithVAT], 0.0) AS [Value],
		ISNULL([Invoice].[VAT], 0.0) AS [VAT],
		SUM([StatementAdvanceInvoice].[StatementPaymentValue]) AS [StatementPaymentValue],
		SUM([StatementAdvanceInvoice].[StatementPaymentVAT]) AS [StatementPaymentVAT],
		SUM([StatementAdvanceInvoice].[StatementPaymentValuePC]) AS [StatementPaymentValuePC],
		SUM([StatementAdvanceInvoice].[StatementPaymentVATPC]) AS [StatementPaymentVATPC]
	FROM
		[Invoice]
		LEFT OUTER JOIN [StatementAdvanceInvoice]
			ON [Invoice].[ID] = [StatementAdvanceInvoice].[AdvanceInvoiceID]
	WHERE
		[Invoice].[State] IN (2, 5) 
		AND
		[Invoice].[ProjectID] = @ProjectID 
		AND
		[Invoice].[CurrencyCode] = @CurrencyCode 
		AND
		[Invoice].[Advance] = 1 AND
			NOT EXISTS 
			(
				SELECT * 
				FROM 
					[StatementAdvanceInvoice] 
				WHERE 
					[AdvanceInvoiceID] = [Invoice].[ID] 
					AND 
					[StatementID] = @ID
			) 
		AND
		(
			@Category IS NULL 
			OR
			LEN(@Category) = 0 
			OR
			EXISTS
				(
					SELECT * 
					FROM 
						[DocumentCategory] INNER JOIN [Category]
							ON [Category].[ID] = [DocumentCategory].[CategoryID] 
					WHERE
						[DocumentCategory].[DocumentClass] = [Invoice].[Class] 
						AND
						[DocumentCategory].[DocumentID] = [Invoice].[ID] 
						AND
						[Category].[FileAs] LIKE @Category
				)
		)
		AND 
		[Invoice].[Date] <= @Date
	GROUP BY 
		[Invoice].[Class],
		[Invoice].[ID],
		[Invoice].[State],
		[Invoice].[Date],
		[Invoice].[Number],
		[Invoice].[FileAs],		
		[Invoice].[Created],
		[Invoice].[CreatedBy],
		[Invoice].[Modified],
		[Invoice].[ModifiedBy],
		[Invoice].[Timestamp],
		[Invoice].[CurrencyCode],
		[Invoice].[TotalWithVAT],
		[Invoice].[VAT]
	HAVING
		ISNULL(SUM([StatementAdvanceInvoice].[StatementPaymentValue]), 0) < ISNULL([Invoice].[TotalWithVAT], 0.0)
	ORDER BY [Invoice].[Date] ASC
	RETURN 0
GO

GRANT EXEC ON pjm7StatementInvoiceAdvanceSearch TO PUBLIC
GO

