IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[TaskBrowseSelectorDialog]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	BEGIN
		PRINT 'Dropping procedure TaskBrowseSelectorDialog'
		DROP PROCEDURE [dbo].[TaskBrowseSelectorDialog]
	END
GO

PRINT 'Creating procedure TaskBrowseSelectorDialog'
GO

/******************************************************************************
**		File: TaskBrowseSelectorDialog.sql
**		Name: TaskBrowseSelectorDialog
**		Desc: this procedure automatically generated by Avicom.Adf.Generator
**
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**      ----------						-----------
**
**		Auth: Andrew.Maklakov
**		Date: 01/20/2005 13:49:21
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		--------	--------		-------------------------------------------
**    
*******************************************************************************/
CREATE PROCEDURE [TaskBrowseSelectorDialog]
	@EmployeeID	TIdentifier,
	@ProjectID	TIdentifier
AS
	SET NOCOUNT ON
	
	IF @EmployeeID = 0 
		SELECT @EmployeeID = dbo.adfGetCurrentEmployeeID()
	
	SELECT DISTINCT
		[Task].[ID],
		[Task].[State],
		[Task].[ProjectID],
		[Task].[FileAs],
		[Task].[StartDate],
		[Task].[DueDate]
	FROM
		[Task]
		INNER JOIN dbo.fnPjm6GetAvailableProjectsForTimeEntryGet(@EmployeeID, @ProjectID) AS [Project]
			ON [Project].[ID] = [Task].[ProjectID]
		LEFT OUTER JOIN [TaskAssignment]
			ON [TaskAssignment].[TaskID] = [Task].[ID]
			AND [TaskAssignment].[State] = 1
		LEFT OUTER JOIN [vwAssignment] AS [Assignment]
			ON [Assignment].[ID] = [TaskAssignment].[AssignmentID]
	WHERE
		[Task].[State] IN (2) AND
		[Task].[SubprojectID] IS NULL AND
		(
			[Assignment].[EmployeeID] = IsNull(@EmployeeID, [Assignment].[EmployeeID])
		)
		AND
		(
			@ProjectID IN (0, -1, -2, -3, -4) OR
			[Task].[ProjectID] = @ProjectID
		) 
		
	RETURN 0
GO

GRANT EXECUTE ON [TaskBrowseSelectorDialog] TO PUBLIC
GO