IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[pjm5TaskCreate]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	BEGIN
		PRINT 'Dropping procedure pjm5TaskCreate'
		DROP PROCEDURE [dbo].[pjm5TaskCreate]
	END
GO

PRINT 'Creating procedure pjm5TaskCreate'
GO

/******************************************************************************
**		File: pjm5TaskCreate.sql
**		Name: pjm5TaskCreate
**		Desc: this procedure automatically generated by Avicom.Adf.Generator
**
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**      ----------						-----------
**
**		Auth: Andrew.Maklakov
**		Date: 01/20/2005 13:49:21
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		--------	--------		-------------------------------------------
**		11.03.13	SOV				 OpenXml  Xml
**		01.04.13	SOV				   . - 
*******************************************************************************/
CREATE PROCEDURE [pjm5TaskCreate]
	@Xml XML
AS
	DECLARE @State TState,
			@ID TIdentifier,
			@FileAs TName,
			@ProjectID TIdentifier,
			@PriorityID TIdentifier,
			@ParentID TIdentifier,
			@StartDate TDate,
			@DueDate TDate,
			@EndDate TDate,
			@Duration TAmount,
			@Estimated TBool,
			@ManHour TAmount,
			@Budget TMoney,
			@PercentComplete TPercent,
			@Milestone TBool,
			@SendStatusReport TBool,
			@Comments TNotes,
			@AssignmentState TState,
			@CurrencyCode TCode3,
			@EmployeeID TIdentifier,
			@AssignmentID TIdentifier,
			@value TVariant,
			@sendToExecute bit,
			@ProjectState TState,
			@CurrentEmployeeID TIdentifier,
			@ReminderState TState,
			@ReminderTime TDateTime,
			@ReminderInterval TTimeSpan,
			@MsProjectID TIdentifier,
			@TaskIndex TCount,
			@Wbs TName,
			@rv int
	
	SET NOCOUNT ON
	
	SELECT
		@ProjectID = [XmlTable].value('ProjectID[1]', 'int'),
		@ManHour = [XmlTable].value('ManHour[1]', 'decimal(18, 4)'), 
		@Budget = [XmlTable].value('Budget[1]', 'money'),
		@PercentComplete = [XmlTable].value('PercentComplete[1]', 'int'),
		@CurrencyCode = [Project].[CurrencyCode],
		@FileAs = [XmlTable].value('FileAs[1]', 'nvarchar(256)'),
		@PriorityID = [XmlTable].value('PriorityID[1]', 'int'),
		@StartDate = CAST([XmlTable].value('StartDate[1]', 'varchar(19)') as datetime),
		@DueDate = CAST([XmlTable].value('DueDate[1]', 'varchar(19)') as datetime),
		@Duration = [XmlTable].value('Duration[1]', 'decimal(18, 4)'),
		@Milestone = (CASE [XmlTable].value('Milestone[1]', 'varchar(5)') WHEN 'false' THEN 0 ELSE 1 END),
		@SendStatusReport = (CASE [XmlTable].value('SendStatusReport[1]', 'varchar(5)') WHEN 'false' THEN 0 ELSE 1 END),
		@Comments = [XmlTable].value('Comments[1]', 'nvarchar(max)'),
		@ProjectState = [Project].[State],
		@ReminderState = (CASE [XmlTable].value('ReminderState[1]', 'varchar(5)') WHEN 'false' THEN 0 ELSE 1 END),
		@ReminderTime = CAST([XmlTable].value('ReminderTime[1]', 'varchar(19)') as datetime),
		@TaskIndex = [XmlTable].value('TaskIndex[1]', 'int'),
		@Wbs = [XmlTable].value('Wbs[1]', 'nvarchar(256)')
	FROM
		@Xml.nodes('/pjm5TaskGet/Task') AS List(XmlTable)
		INNER JOIN [Project]
			ON [XmlTable].value('ProjectID[1]', 'int') = [Project].[ID]
	
	IF(EXISTS(SELECT *FROM [Budget] WHERE [DocumentID] = @ProjectID AND [DocumentClass] = dbo.adfGetClassByName('Pjm5.Project')))
	BEGIN
		RAISERROR('#ProjectHasBudgetPlanning', 18, -1)
		RETURN 1
	END

	SELECT @MsProjectID = [MsProjectID] FROM [Project] WHERE [ID] = @ProjectID
	IF @MsProjectID IS NOT NULL
	BEGIN
		RAISERROR('#documentfrommsproject', 18, -1)
		RETURN 1
	END
			
	IF @ManHour IS NOT NULL AND @ManHour < 0
	BEGIN
		RAISERROR('#ManHourIsInvalid', 18, -1)
		RETURN 1
	END

	IF @ProjectState IN (5, 6)
		SET @State = 7 --Template
	ELSE
	BEGIN
		SET @CurrentEmployeeID = dbo.adfGetCurrentEmployeeID()
		IF dbo.fnPjm5IsProjectMember(@ProjectID, @CurrentEmployeeID) = 0 AND
			dbo.fnPjm5IsProjectManager(@ProjectID, @CurrentEmployeeID) = 0 AND
			dbo.fnPjm7IsManagerAssistant(@ProjectID, @CurrentEmployeeID) = 0
		BEGIN
			RAISERROR('#accessdenied', 18, -1)
			RETURN 1
		END
		SET @State = 8 -- New
	END

	IF @ProjectState IN (2, 3)
	BEGIN
		EXEC adfParameterGet @Name='StartTaskAfterCreate', @Group='Pjm5', @Value = @value OUTPUT
	END
	SET @sendToExecute = ISNULL(CAST(@value as bit), 0)
	
	DECLARE
		@employees TABLE (
			[ID] int,
			[Class] int,
			[FileAs] varchar(256),
			[Units] decimal(18,4),
			[Work] int,
			[ProjectID] int
			)
	INSERT INTO @employees
	SELECT
		[XmlTable].value('ID[1]', 'int'),
		[XmlTable].value('Class[1]', 'int'),
		[XmlTable].value('FileAs[1]', 'nvarchar(256)'),
		[XmlTable].value('Units[1]', 'decimal(18, 4)'),
		[XmlTable].value('Work[1]', 'int'),
		@ProjectID AS [ProjectID]
	FROM
		@Xml.nodes('/pjm5TaskGet/BusinessCard') AS List(XmlTable)
				
	DECLARE @busyEntry TABLE ([AssignmentID] int, [TaskID] int, [Date] datetime, [Planned] int, [Committed] bit)
	INSERT INTO @busyEntry ([AssignmentID], [Date], [Planned], [Committed])
	SELECT
		[XmlTable].value('AssignmentID[1]', 'int'),
		CAST([XmlTable].value('Date[1]', 'varchar(19)') AS datetime),
		[XmlTable].value('Planned[1]', 'int'),
		(CASE [XmlTable].value('Commited[1]', 'varchar(5)') WHEN 'false' THEN 0 ELSE 1 END)
	FROM
		@Xml.nodes('/pjm5TaskGet/TaskAssignmentBooking') AS List(XmlTable)
	
	IF @@ERROR != 0
	BEGIN
		RETURN 1
	END
		
	IF (@State = 7)
		SET @AssignmentState = 3 --Template
	ELSE
		SET @AssignmentState = 4 -- New

	SELECT
		@Budget = SUM([BC].[Work] * [Assignment].[StandardRate] / 60.0)
	FROM
		@employees AS [BC]
		INNER JOIN [Assignment]
			ON [BC].[ID] = [Assignment].[ID]
	
	IF @TaskIndex IS NULL
	BEGIN
		SELECT 
			@TaskIndex = MAX([TaskWbs].[TaskIndex])
		FROM 
			[TaskWbs] 
			INNER JOIN [Task]
				ON [Task].[ID] = [TaskWbs].[TaskID]
		WHERE 
			[Task].[ProjectID] = @ProjectID
		SET @TaskIndex = ISNULL(@TaskIndex, 0) + 1
	END
	
	IF NOT EXISTS(SELECT * FROM @employees)
		SET @ManHour = 0
	BEGIN TRANSACTION
	INSERT INTO [Task]
		([State], [Flag], [FileAs], [ProjectID], 
		[PriorityID], 
		[StartDate], [DueDate], 
		[Duration], 
		[ManHour], [Budget],
		[PercentComplete], 
		[Milestone], [SendStatusReport], 
		[Comments])
	VALUES (
		@State, 0, @FileAs, @ProjectID,
		@PriorityID, 
		@StartDate, @DueDate,
		@Duration, 
		CAST(@ManHour * 60 AS int), @Budget,
		CAST(@PercentComplete as decimal(5, 2)) / CAST(100 as decimal(5, 2)),
		@Milestone, @SendStatusReport, 
		@Comments)
				
	IF @@ERROR != 0
	BEGIN
		ROLLBACK TRANSACTION
		RETURN 1
	END
	SET @ID = SCOPE_IDENTITY()
	
	EXEC @rv = pjm6TaskUpdateWbs @ID, @TaskIndex, @Wbs
	--UPDATE [TaskWbs] SET [TaskIndex] = @TaskIndex WHERE [TaskID] = @ID
	IF @rv != 0
	BEGIN
		ROLLBACK TRANSACTION
		RETURN 1
	END

	IF EXISTS(SELECT * FROM @employees)
	BEGIN
		INSERT INTO [TaskAssignment] ([TaskID], [AssignmentID], [Units], [Work], [RemainingWork])
		SELECT
			@ID,
			[BC].[ID],
			[BC].[Units],
			[BC].[Work],
			[BC].[Work]
		FROM
			@employees AS [BC]

		IF @@ERROR != 0
		BEGIN
			ROLLBACK TRANSACTION
			RETURN 1
		END
	END

	IF EXISTS(SELECT * FROM @busyEntry)
	BEGIN
		INSERT INTO [BusyEntry] ([AssignmentID], [ProjectID], [TaskID], [Date], [EmployeeID], [Planned])
		SELECT
			[vwAssignment].[ID],
			[vwAssignment].[ProjectID],
			@ID,
			[TaskAssignmentBooking].[Date],
			[vwAssignment].[EmployeeID],
			[TaskAssignmentBooking].[Planned]
		FROM
			@busyEntry AS [TaskAssignmentBooking]
			INNER JOIN [vwAssignment]
				ON [vwAssignment].[ID] = [TaskAssignmentBooking].[AssignmentID]
		IF @@ERROR != 0
		BEGIN
			ROLLBACK TRANSACTION
			RETURN 1
		END
	END
	
	IF @sendToExecute = 1
	BEGIN
		EXEC @rv = pjm5TaskChangeState @ID, 1
		IF @rv != 0
		BEGIN
			ROLLBACK TRANSACTION
			RETURN @rv
		END
	END

	SET @ReminderInterval = DATEDIFF(minute, @ReminderTime, @DueDate)
	EXEC @rv = pjm7TaskReminderCreate @ID,
		@DueDate, @ReminderState, @ReminderInterval
	IF @rv != 0
	BEGIN
		ROLLBACK TRANSACTION
		RETURN @rv
	END

	COMMIT TRANSACTION

	EXEC pjm5TaskGet @ID
	RETURN 0
GO

GRANT EXECUTE ON pjm5TaskCreate TO PUBLIC
GO
 