IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[pjm5TimeEntryAutoApprove]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	BEGIN
		PRINT 'Dropping procedure pjm5TimeEntryAutoApprove'
		DROP PROCEDURE [dbo].[pjm5TimeEntryAutoApprove]
	END
GO

PRINT 'Creating procedure pjm5TimeEntryAutoApprove'
GO

/******************************************************************************
**		File: pjm5TimeEntryAutoApprove.sql
**		Name: pjm5TimeEntryAutoApprove
**		Desc: this procedure automatically generated by Avicom.Adf.Generator
**
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**      ----------						-----------
**
**		Auth: dmitry.kolchev
**		Date: 05/28/2007 15:49
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		--------	--------		-------------------------------------------
**		01.12.09	syv				   @OriginatorUserID 
**									 UserID  EXECUTE AS OWNER
**		21.03.13	SOV/SAP			      
**		01.04.13	SOV				 ,   - . -
*******************************************************************************/
CREATE PROCEDURE [pjm5TimeEntryAutoApprove]
	@ID TIdentifier,
	@OriginatorUserID TIdentifier = NULL
AS
	DECLARE @sendToApprove bit, 
			@approve bit, 
			@userID int, 
			@value TVariant,
			@StartTime TDateTime,
			@ProjectID TIdentifier,
			@CurrentEmployeeID TIdentifier,
			@EmployeeID TIdentifier,
			@ActivityTypeID TIdentifier,
			@rv int
			
	SET NOCOUNT ON
	
	SET @CurrentEmployeeID = dbo.adfGetCurrentEmployeeID()

	SET @userID = dbo.adfGetCurrentUserID()
	SET @value = NULL
	SET @sendToApprove = 0
	
	SELECT
		@StartTime = [StartTime],
		@ProjectID = [ProjectID],
		@EmployeeID = [EmployeeID],
		@ActivityTypeID = [ActivityTypeID]
	FROM
		[TimeEntry]
	WHERE
		[ID] = @ID
		
	IF @ProjectID IS NOT NULL
	BEGIN
		DECLARE @var sql_variant, @ActivityTypeIsMandatory bit
		
		EXEC adfParameterGet 'ActivityTypeIsMandatory', 'Pjm5', @var OUTPUT
		IF @var IS NULL
			SET @ActivityTypeIsMandatory = 1
		ELSE
			SET @ActivityTypeIsMandatory = CAST(@var as BIT)
		IF ((@ActivityTypeIsMandatory = 1 AND @ActivityTypeID IS NOT NULL) OR @ActivityTypeIsMandatory = 0)
			AND NOT EXISTS
			(SELECT 
				[TimeEntry].[ID] 
			FROM
				[TimeEntry]
					INNER JOIN [Project]
						ON [Project].[ID] = [TimeEntry].[ProjectID]
			WHERE
				[TimeEntry].[ID] = @ID AND
				[TimeEntry].[TaskID] IS NULL AND
				[Project].[MsProjectID] IS NOT NULL
			)
		BEGIN
			DECLARE @CurrentTime DateTime = dbo.adfGetLocalDateByOriginalLogin()

			IF @StartTime < @CurrentTime
			BEGIN
				SELECT @value = [Value] FROM [UserParameter] WHERE [Name] = 'TimeEntrySendForApproving' AND [UserID] = @userID
				SET @sendToApprove = ISNULL(CAST(@value as bit), 1)
			END
			
			SET @approve = 0
			IF @CurrentEmployeeID = @EmployeeID AND (dbo.fnPjm5IsProjectManager(@ProjectID, @CurrentEmployeeID) = 1 ) 
				AND @StartTime < @CurrentTime
			BEGIN
				SET @value = NULL
				SELECT @value = [Value] FROM [UserParameter] WHERE [Name] = 'TimeEntryApprove' AND [UserID] = @userID
				SET @approve = ISNULL(CAST(@value as bit), 1)
			END
			
			IF @sendToApprove = 1 OR @approve = 1
			BEGIN
				EXEC @rv = pjm5TimeEntryChangeState @ID, 2, @OriginatorUserID
				IF @rv != 0
				BEGIN
					RETURN @rv
				END
			END
			
			IF @approve = 1
			BEGIN
				EXEC @rv = pjm5TimeEntryChangeState @ID, 3--, @OriginatorUserID
				IF @rv != 0
				BEGIN
					RETURN @rv
				END
			END
		END
	END
	
	RETURN 0
GO

   