IF EXISTS (SELECT * FROM sysobjects WHERE type = 'V' AND name = 'vwAssignment')
	BEGIN
		PRINT 'Dropping View vwAssignment'
		DROP  View vwAssignment
	END
GO

/******************************************************************************
**		File: 
**		Name: vwAssignment
**		Desc: 
**
**		This template can be customized:
**              
**
**		Auth: 
**		Date: 
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:				Description:
**		--------		--------				-------------------------------------------
**    
*******************************************************************************/

PRINT 'Creating View vwAssignment'
GO
CREATE View vwAssignment
as

	SELECT
		[Assignment].[Class],
		[Assignment].[ID],
		[Assignment].[State],
		[Assignment].[Flag],
		[Assignment].[FileAs],
		[AssignmentEntry].[EmployeeID],
		[Assignment].[ProjectID],
		[Assignment].[QualificationID],
		[Assignment].[StandardRate],
		[Assignment].[OvertimeRate],
		[Assignment].[Approver],
		[Assignment].[Administrator],
		[Assignment].[FinanceManagement],
		[Assignment].[AlwaysUseRate],
		[Assignment].[RateVisible],
		[Assignment].[ReceiveTaskStatusReports],
		[Assignment].[ReceiveIssueStatusReports],
		[Assignment].[Comments],
		[Assignment].[Created],
		[Assignment].[CreatedBy],
		[Assignment].[Modified],
		[Assignment].[ModifiedBy],
		[Assignment].[Timestamp],
		[Assignment].[MsResourceID],
		[Assignment].[EqualEmployeeFileAs]
	FROM
		[Assignment] LEFT OUTER JOIN [AssignmentEntry]
			ON [Assignment].[ID] = [AssignmentEntry].[AssignmentID]
GO
